define(["require", "exports", "electron", "chord/platform/log/common/log", "chord/platform/utils/common/paths"], function (require, exports, electron_1, log_1, paths_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.setBrowserGlobalProxy = void 0;
    var logger = new log_1.Logger(paths_1.filenameToNodeName(__filename));
    // If proxyRules is '' or null, this action cancels browser's proxy
    function setBrowserGlobalProxy(proxyRules) {
        logger.info('Set Browser Global Proxy:', proxyRules);
        electron_1.remote.getCurrentWebContents().session.setProxy({ proxyRules: proxyRules || null });
    }
    exports.setBrowserGlobalProxy = setBrowserGlobalProxy;
});
