define(["require", "exports", "assert", "mocha", "chord/base/common/property"], function (require, exports, assert, mocha_1, property_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    mocha_1.suite('base/common/property', function () {
        mocha_1.test('getDescendentProp', function () {
            var x = { a: { b: { c: [{ e: 100 }] } } };
            var result = property_1.getDescendentProp(x, 'a.b.c.0.e');
            assert.equal(result, 100);
        });
        mocha_1.test('setDescendentProp', function () {
            var x = { a: { b: { c: [{ e: 100 }] } } };
            var xx = property_1.setDescendentProp(x, 'a.b.c.0.e', 200);
            var result = xx.a.b.c[0].e;
            assert.equal(result, 200);
        });
    });
});
