define(["require", "exports", "chord/base/common/checker"], function (require, exports, checker_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.parseToMillisecond = exports.sleep = exports.getDateYear = exports.getHumanDuration = void 0;
    function getHumanDuration(millisecond) {
        if (!millisecond)
            return '';
        var duration = Math.floor(millisecond / 1000);
        var min = Math.floor(duration / 60);
        var sec = duration % 60;
        return min + ":" + sec.toString().padStart(2, '0');
    }
    exports.getHumanDuration = getHumanDuration;
    function getDateYear(millisecond) {
        if (!millisecond)
            return '';
        if (checker_1.isString(millisecond))
            return millisecond;
        return new Date(millisecond).getFullYear();
    }
    exports.getDateYear = getDateYear;
    function sleep(millisecond) {
        return new Promise(function (resolve) { return setTimeout(resolve, millisecond); });
    }
    exports.sleep = sleep;
    /**
     * Parse a time string to millisecond
     */
    function parseToMillisecond(info) {
        if (!!!info)
            return null;
        var c = Array.from(info).filter(function (i) { return i == ':'; }).length;
        var tm;
        switch (c) {
            case 0:
                tm = "00:00:" + info;
                break;
            case 1:
                tm = "00:" + info;
                break;
            case 2:
                tm = info;
                break;
        }
        return Date.parse("1970-01-01 " + tm + " UTC");
    }
    exports.parseToMillisecond = parseToMillisecond;
});
