define(["require", "exports", "path", "fs"], function (require, exports, paths, fs) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.mkdirp = void 0;
    function mkdirp(path, mode) {
        var mkdir = function (path, mode) {
            try {
                fs.mkdirSync(path, mode);
                return true;
            }
            catch (e) {
                if (e.code == 'ENOENT') {
                    throw e;
                }
                try {
                    if (!fs.statSync(path).isDirectory()) {
                        throw new Error(path + " exists and is not a directory");
                    }
                    return true;
                }
                catch (e) {
                    throw e;
                }
            }
        };
        // path is root
        if (path === paths.dirname(path)) {
            return true;
        }
        try {
            return mkdir(path, mode);
        }
        catch (e) {
            if (e.code == 'ENOENT') {
                mkdirp(paths.dirname(path), mode);
                return mkdir(path, mode);
            }
            throw e;
        }
    }
    exports.mkdirp = mkdirp;
});
