define(["require", "exports", "url", "querystring"], function (require, exports, url, querystring) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getHost = exports.querystringify = exports.getAbsolutUrl = void 0;
    function getAbsolutUrl(input, base) {
        if (!input)
            return input;
        if (!base) {
            if (input.startsWith('//')) {
                return 'http:' + input;
            }
            return input;
        }
        else {
            return new url.URL(input, base).href;
        }
    }
    exports.getAbsolutUrl = getAbsolutUrl;
    function querystringify(input) {
        return querystring.stringify(input);
    }
    exports.querystringify = querystringify;
    function getHost(input) {
        return url.parse(input).host;
    }
    exports.getHost = getHost;
});
