define(["require", "exports", "electron"], function (require, exports, electron_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.menuTemplate = void 0;
    var menuTemplate = function (win) { return [
        {
            label: 'Application',
            submenu: [
                {
                    label: 'About Chord',
                    click: function () { electron_1.shell.openExternal('https://github.com/PeterDing/chord'); }
                },
                { type: 'separator' },
                { label: 'Quit', accelerator: 'Command+Q', click: function () { electron_1.app.quit(); } },
                { label: 'Relaunch', accelerator: 'Command+R', click: function () { electron_1.app.relaunch(); } },
            ]
        },
        {
            label: 'Edit',
            submenu: [
                { label: 'Undo', accelerator: 'CmdOrCtrl+Z', role: 'undo' },
                { label: 'Redo', accelerator: 'Shift+CmdOrCtrl+Z', role: 'redo' },
                { type: 'separator' },
                { label: 'Cut', accelerator: 'CmdOrCtrl+X', role: 'cut' },
                { label: 'Copy', accelerator: 'CmdOrCtrl+C', role: 'copy' },
                { label: 'Paste', accelerator: 'CmdOrCtrl+V', role: 'paste' },
                { label: 'Select All', accelerator: 'CmdOrCtrl+A', role: 'selectAll' }
            ]
        },
        {
            label: 'View',
            submenu: [
                {
                    label: 'Toggle DevTools',
                    accelerator: 'Alt+Command+I',
                    click: function () {
                        win.show();
                        win.toggleDevTools();
                    }
                },
            ]
        },
        {
            role: 'help',
            submenu: [
                {
                    label: 'Fork at Github',
                    click: function () { electron_1.shell.openExternal('https://github.com/PeterDing/chord'); }
                },
                {
                    label: 'Report Bug',
                    click: function () { electron_1.shell.openExternal('https://github.com/PeterDing/chord/issues'); }
                },
            ]
        },
    ]; };
    exports.menuTemplate = menuTemplate;
});
