define(["require", "exports", "chord/library/data/tables/schemes/audio.sql", "chord/library/data/tables/schemes/user.sql", "chord/library/data/tables/schemes/song.sql", "chord/library/data/tables/schemes/librarySong.sql", "chord/library/data/tables/schemes/libraryAlbum.sql", "chord/library/data/tables/schemes/libraryArtist.sql", "chord/library/data/tables/schemes/libraryCollection.sql", "chord/library/data/tables/schemes/libraryUserProfile.sql", "chord/library/data/tables/schemes/episode.sql", "chord/library/data/tables/schemes/libraryEpisode.sql", "chord/library/data/tables/schemes/libraryPodcast.sql", "chord/library/data/tables/schemes/libraryRadio.sql"], function (require, exports, audio_sql_1, user_sql_1, song_sql_1, librarySong_sql_1, libraryAlbum_sql_1, libraryArtist_sql_1, libraryCollection_sql_1, libraryUserProfile_sql_1, episode_sql_1, libraryEpisode_sql_1, libraryPodcast_sql_1, libraryRadio_sql_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.createTables = void 0;
    function createTables(db) {
        ////////////////////////////////////////////////////////
        // create tables
        // music
        audio_sql_1.makeTable(db.getDatabase());
        user_sql_1.makeTable(db.getDatabase());
        song_sql_1.makeTable(db.getDatabase());
        librarySong_sql_1.makeTable(db.getDatabase());
        libraryAlbum_sql_1.makeTable(db.getDatabase());
        libraryArtist_sql_1.makeTable(db.getDatabase());
        libraryCollection_sql_1.makeTable(db.getDatabase());
        libraryUserProfile_sql_1.makeTable(db.getDatabase());
        // sound
        episode_sql_1.makeTable(db.getDatabase());
        libraryEpisode_sql_1.makeTable(db.getDatabase());
        libraryPodcast_sql_1.makeTable(db.getDatabase());
        libraryRadio_sql_1.makeTable(db.getDatabase());
        ////////////////////////////////////////////////////////
        // fix tables
        // music
        audio_sql_1.fixTable(db.getDatabase());
        user_sql_1.fixTable(db.getDatabase());
        song_sql_1.fixTable(db.getDatabase());
        librarySong_sql_1.fixTable(db.getDatabase());
        libraryAlbum_sql_1.fixTable(db.getDatabase());
        libraryArtist_sql_1.fixTable(db.getDatabase());
        libraryCollection_sql_1.fixTable(db.getDatabase());
        libraryUserProfile_sql_1.fixTable(db.getDatabase());
        // sound
        episode_sql_1.fixTable(db.getDatabase());
        libraryEpisode_sql_1.fixTable(db.getDatabase());
        libraryPodcast_sql_1.fixTable(db.getDatabase());
        libraryRadio_sql_1.fixTable(db.getDatabase());
        return true;
    }
    exports.createTables = createTables;
});
