define(["require", "exports", "chord/library/data/tables/schemes/util"], function (require, exports, util_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.fixTable = exports.makeTable = void 0;
    var TABLE_NAME = 'library_album';
    var TABLE_COLUMNS = [
        ['id', 'integer primary key asc'],
        ['albumId', 'text unique on conflict ignore'],
        ['type', 'text'],
        ['origin', 'text'],
        ['albumOriginalId', 'text'],
        ['albumMid', 'text'],
        ['url', 'text'],
        ['albumName', 'text'],
        ['albumCoverUrl', 'text'],
        ['albumCoverPath', 'text'],
        ['artistId', 'text'],
        ['artistOriginalId', 'text'],
        ['artistMid', 'text'],
        ['artistName', 'text'],
        ['subTitle', 'text'],
        ['description', 'text'],
        // json array
        ['genres', 'text'],
        // json array
        ['styles', 'text'],
        // json array
        ['tags', 'text'],
        ['duration', 'integer'],
        ['releaseDate', 'integer'],
        ['company', 'text'],
        // json array: ["songId"] only for local songs
        ['songs', 'text'],
        ['songCount', 'integer'],
        ['playCount', 'integer'],
        ['likeCount', 'integer'],
        ['like', 'integer'],
        ['addAt', 'integer'],
    ];
    var ADDONS = null;
    function makeTable(db) {
        var tableSql = util_1.makeTableSql(TABLE_NAME, TABLE_COLUMNS, ADDONS);
        db.exec(tableSql);
    }
    exports.makeTable = makeTable;
    function fixTable(db) {
        util_1.addMissColumns(TABLE_NAME, TABLE_COLUMNS, db);
    }
    exports.fixTable = fixTable;
});
