define(["require", "exports", "chord/library/data/tables/schemes/util"], function (require, exports, util_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.fixTable = exports.makeTable = void 0;
    var TABLE_NAME = 'library_artist';
    var TABLE_COLUMNS = [
        ['id', 'integer primary key asc'],
        ['artistId', 'text unique on conflict ignore'],
        ['type', 'text'],
        ['origin', 'text'],
        ['artistOriginalId', 'text'],
        ['artistMid', 'text'],
        ['url', 'text'],
        ['artistName', 'text'],
        ['artistAlias', 'text'],
        ['artistAvatarUrl', 'text'],
        ['artistAvatarPath', 'text'],
        ['area', 'text'],
        // json array
        ['genres', 'text'],
        // json array
        ['styles', 'text'],
        // json array
        ['tags', 'text'],
        ['description', 'text'],
        ['playCount', 'integer'],
        ['likeCount', 'integer'],
        ['like', 'integer'],
        ['addAt', 'integer'],
    ];
    var ADDONS = null;
    function makeTable(db) {
        var tableSql = util_1.makeTableSql(TABLE_NAME, TABLE_COLUMNS, ADDONS);
        db.exec(tableSql);
    }
    exports.makeTable = makeTable;
    function fixTable(db) {
        util_1.addMissColumns(TABLE_NAME, TABLE_COLUMNS, db);
    }
    exports.fixTable = fixTable;
});
