define(["require", "exports", "chord/library/data/tables/schemes/util"], function (require, exports, util_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.fixTable = exports.makeTable = void 0;
    var TABLE_NAME = 'library_podcast';
    var TABLE_COLUMNS = [
        ['id', 'integer primary key asc'],
        ['podcastId', 'text unique on conflict ignore'],
        ['type', 'text'],
        ['origin', 'text'],
        ['podcastOriginalId', 'text'],
        ['podcastMid', 'text'],
        ['url', 'text'],
        ['podcastName', 'text'],
        ['podcastCoverUrl', 'text'],
        ['podcastCoverPath', 'text'],
        ['radioId', 'text'],
        ['radioOriginalId', 'text'],
        ['radioMid', 'text'],
        ['radioName', 'text'],
        ['subTitle', 'text'],
        ['description', 'text'],
        // json array
        ['genres', 'text'],
        // json array
        ['styles', 'text'],
        // json array
        ['tags', 'text'],
        ['duration', 'integer'],
        ['releaseDate', 'integer'],
        ['company', 'text'],
        // json array: ["episodeId"] only for local episodes
        ['episodes', 'text'],
        ['episodeCount', 'integer'],
        ['playCount', 'integer'],
        ['likeCount', 'integer'],
        ['like', 'integer'],
        ['addAt', 'integer'],
    ];
    var ADDONS = null;
    function makeTable(db) {
        var tableSql = util_1.makeTableSql(TABLE_NAME, TABLE_COLUMNS, ADDONS);
        db.exec(tableSql);
    }
    exports.makeTable = makeTable;
    function fixTable(db) {
        util_1.addMissColumns(TABLE_NAME, TABLE_COLUMNS, db);
    }
    exports.fixTable = fixTable;
});
