define(["require", "exports", "chord/library/data/tables/schemes/util"], function (require, exports, util_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.fixTable = exports.makeTable = void 0;
    var TABLE_NAME = 'library_radio';
    var TABLE_COLUMNS = [
        ['id', 'integer primary key asc'],
        ['radioId', 'text unique on conflict ignore'],
        ['type', 'text'],
        ['origin', 'text'],
        ['radioOriginalId', 'text'],
        ['radioMid', 'text'],
        ['url', 'text'],
        ['radioName', 'text'],
        ['radioCoverUrl', 'text'],
        ['radioCoverPath', 'text'],
        ['followerCount', 'integer'],
        ['followingCount', 'integer'],
        // json array: ["radioId"] or []
        ['followers', 'text'],
        // json array: ["radioId"] or []
        ['followings', 'text'],
        ['listenCount', 'integer'],
        ['episodeCount', 'integer'],
        ['radioCount', 'integer'],
        ['podcastCount', 'integer'],
        ['favoritePodcastCount', 'integer'],
        // json array: ["episodeId"] or []
        ['episodes', 'text'],
        // json array: ["radioId"] or []
        ['radios', 'text'],
        // json array: ["podcastId"] or []
        ['podcasts', 'text'],
        // json array: ["podcastId"] or []
        ['favoritePodcasts', 'text'],
        ['description', 'text'],
        ['like', 'integer'],
        ['addAt', 'integer'],
    ];
    var ADDONS = null;
    function makeTable(db) {
        var tableSql = util_1.makeTableSql(TABLE_NAME, TABLE_COLUMNS, ADDONS);
        db.exec(tableSql);
    }
    exports.makeTable = makeTable;
    function fixTable(db) {
        util_1.addMissColumns(TABLE_NAME, TABLE_COLUMNS, db);
    }
    exports.fixTable = fixTable;
});
