define(["require", "exports", "url"], function (require, exports, nodeUrl) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.resizeImageUrl = exports.ESize = void 0;
    var ESize;
    (function (ESize) {
        ESize[ESize["Huge"] = 0] = "Huge";
        ESize[ESize["Large"] = 1] = "Large";
        ESize[ESize["Big"] = 2] = "Big";
        ESize[ESize["Middle"] = 3] = "Middle";
        ESize[ESize["Small"] = 4] = "Small";
        ESize[ESize["Tiny"] = 5] = "Tiny";
    })(ESize = exports.ESize || (exports.ESize = {}));
    function resizeImageUrl(url, size, resizeFunc) {
        switch (size) {
            case ESize.Huge:
                size = 700;
                break;
            case ESize.Large:
                size = 450;
                break;
            case ESize.Big:
                size = 250;
                break;
            case ESize.Middle:
                size = 150;
                break;
            case ESize.Small:
                size = 60;
                break;
            case ESize.Tiny:
                size = 30;
                break;
            default:
                break;
        }
        var u = nodeUrl.parse(url);
        url = u.protocol + "//" + u.hostname + u.pathname;
        return resizeFunc(url, size);
    }
    exports.resizeImageUrl = resizeImageUrl;
});
