var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
define(["require", "exports", "chord/platform/log/common/log", "chord/platform/utils/common/paths", "chord/base/common/assert", "chord/base/node/crypto", "chord/base/common/json", "chord/music/common/origin", "chord/music/common/errors", "chord/music/common/size", "chord/base/node/cookies", "chord/base/node/_request", "chord/music/netease/crypto", "chord/music/netease/util", "chord/music/netease/parser", "chord/music/qq/common"], function (require, exports, log_1, paths_1, assert_1, crypto_1, json_1, origin_1, errors_1, size_1, cookies_1, _request_1, crypto_2, util_1, parser_1, common_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.NeteaseMusicApi = void 0;
    var loggerWarning = new log_1.Logger(paths_1.filenameToNodeName(__filename), log_1.LogLevel.Warning);
    var MAX_RETRY = 3;
    var NeteaseMusicApi = /** @class */ (function () {
        function NeteaseMusicApi() {
            if (!this.cookieJar) {
                var cookieJar_1 = cookies_1.makeCookieJar();
                util_1.initiateCookies().forEach(function (cookie) {
                    var domain = cookie.domain;
                    cookieJar_1.setCookie(cookie, domain.startsWith('http') ? domain : 'http://' + domain);
                });
                this.cookieJar = cookieJar_1;
            }
        }
        NeteaseMusicApi.prototype.request = function (node, data, init, retry) {
            if (init === void 0) { init = false; }
            if (retry === void 0) { retry = 0; }
            return __awaiter(this, void 0, void 0, function () {
                var url, options, result, resultCode, message;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = NeteaseMusicApi.BASICURL + node;
                            options = {
                                method: 'POST',
                                url: url,
                                jar: this.cookieJar || null,
                                headers: NeteaseMusicApi.HEADERS,
                                form: crypto_2.encrypt(json_1.jsonDumpValue(data)),
                                gzip: true,
                                json: true,
                                resolveWithFullResponse: init,
                            };
                            return [4 /*yield*/, _request_1.request(options)];
                        case 1:
                            result = _a.sent();
                            // retry
                            if (!result && retry < MAX_RETRY)
                                return [2 /*return*/, this.request(node, data, init, retry + 1)];
                            assert_1.ok(result, "[ERROR] [NeteaseMusicApi.request]: url: " + url + ", result is " + result);
                            resultCode = init ? result.body['code'] : result['code'];
                            if (resultCode != 200) {
                                loggerWarning.warning("[ERROR] [NeteaseMusicApi.request]: url: " + url + ", result.code is " + resultCode + ", result is " + JSON.stringify(result));
                                message = init ? result.body['msg'] : result['msg'];
                                throw new Error(message);
                            }
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * to get directly link (128kbps)
         * http://music.163.com/song/media/outer/url?id=${songId}.mp3
         */
        NeteaseMusicApi.prototype.audios = function (songId, supKbps) {
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json, audio;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.audio;
                            data = {
                                ids: [songId],
                                br: supKbps * 1000,
                                csrf_token: '',
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            audio = parser_1.makeAudio(json['data'][0]);
                            return [2 /*return*/, audio ? [audio] : []];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.songsAudios = function (songIds) {
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json, songsAudios;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.audio;
                            data = {
                                ids: songIds,
                                br: 999000,
                                csrf_token: '',
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            songsAudios = json['data'].map(function (info) { return [parser_1.makeAudio(info)]; });
                            return [2 /*return*/, songsAudios];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.song = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.song;
                            data = {
                                c: [{ id: songId }],
                                ids: [songId],
                                csrf_token: '',
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeSong(json['songs'][0], json['privileges'][0])];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.lyric = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json, lyricInfo, transInfo;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.lyric;
                            data = {
                                csrf_token: "",
                                id: songId,
                                lv: -1,
                                tv: -1,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            lyricInfo = json['lrc'] ? json['lrc']['lyric'] : null;
                            transInfo = json['tlyric'] ? json['tlyric']['lyric'] : null;
                            return [2 /*return*/, parser_1.makeLyric(songId, lyricInfo, transInfo)];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.album = function (albumId) {
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.album + '/' + albumId;
                            data = {
                                csrf_token: '',
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeAlbum(json)];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.artist = function (artistId) {
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.artist + '/' + artistId;
                            data = {
                                csrf_token: '',
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeArtist(json)];
                    }
                });
            });
        };
        /**
         * There gets an artist's top 50 songs
         * It can't be more
         */
        NeteaseMusicApi.prototype.artistSongs = function (artistId, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.artist(artistId)];
                        case 1:
                            songs = (_a.sent()).songs;
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.artistAlbums = function (artistId, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.artistAlbums + '/' + artistId;
                            data = {
                                offset: offset,
                                total: true,
                                limit: limit,
                                csrf_token: '',
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeArtistAlbums(json)];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.collection = function (collectionId, size) {
            if (size === void 0) { size = 10000; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.collection;
                            data = {
                                id: collectionId,
                                total: true,
                                // offset: offset,  // offset, limit do not support
                                // limit: limit,
                                n: size,
                                csrf_token: '',
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeCollection(json['playlist'], json['privileges'])];
                    }
                });
            });
        };
        /**
         * Search
         *
         * data params:
         * @type:
         * 1: 单曲
         * 10: 专辑
         * 100: 歌手
         * 1000: 歌单
         * 1002: 用
         * 1004: M
         * 1006: 歌
         * 1009: 电
         * 1014: 视频
         */
        NeteaseMusicApi.prototype.search = function (type, keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.search;
                            data = {
                                s: keyword,
                                total: true,
                                offset: offset,
                                limit: limit,
                                type: type,
                                strategy: 5,
                                queryCorrect: true,
                                csrf_token: '',
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json];
                    }
                });
            });
        };
        /**
         * Search songs
         *
         * type = 1
         */
        NeteaseMusicApi.prototype.searchSongs = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.search(1, keyword, offset, limit)];
                        case 1:
                            json = _a.sent();
                            if (!json['result']) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeSongs(json['result']['songs'] || [])];
                    }
                });
            });
        };
        /**
         * Search albums
         * type = 10
         */
        NeteaseMusicApi.prototype.searchAlbums = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.search(10, keyword, offset, limit)];
                        case 1:
                            json = _a.sent();
                            if (!json['result']) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeAlbums(json['result']['albums'] || [])];
                    }
                });
            });
        };
        /**
         * Search artists
         *
         * type = 100
         */
        NeteaseMusicApi.prototype.searchArtists = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.search(100, keyword, offset, limit)];
                        case 1:
                            json = _a.sent();
                            if (!json['result']) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeArtists(json['result']['artists'] || [])];
                    }
                });
            });
        };
        /**
         * Search collections
         * type = 1000
         */
        NeteaseMusicApi.prototype.searchCollections = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.search(1000, keyword, offset, limit)];
                        case 1:
                            json = _a.sent();
                            if (!json['result']) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeCollections(json['result']['playlists'] || [])];
                    }
                });
            });
        };
        /**
         * Netease only return 5 similar songs
         */
        NeteaseMusicApi.prototype.similarSongs = function (songId, limit) {
            if (limit === void 0) { limit = 5; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.similarSongs;
                            data = {
                                songid: songId,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeSongs(json['songs'])];
                    }
                });
            });
        };
        /**
         * Netease doesn't provide similar albums api
         */
        NeteaseMusicApi.prototype.similarAlbums = function (albumId, limit) {
            if (limit === void 0) { limit = 5; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, []];
                });
            });
        };
        /**
         * NO Use It
         *
         * WARN: This api return {"code":301}
         */
        NeteaseMusicApi.prototype.similarArtists = function (artistId, limit) {
            if (limit === void 0) { limit = 5; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.similarArtists;
                            data = {
                                artistid: artistId,
                                csrf_token: '',
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeArtists(json['artists'])];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.similarCollections = function (collectionId, limit) {
            if (limit === void 0) { limit = 5; }
            return __awaiter(this, void 0, void 0, function () {
                var url, options, body, collectionIds, re, group, collections;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = "https://music.163.com/playlist?id=" + collectionId;
                            options = {
                                method: 'GET',
                                url: url,
                                headers: NeteaseMusicApi.WEB_HEADERS,
                                gzip: true,
                            };
                            return [4 /*yield*/, _request_1.request(options)];
                        case 1:
                            body = _a.sent();
                            collectionIds = new Set();
                            re = /sname f-fs1 s-fc0" href="\/playlist\?id=(\d+)/g;
                            while (group = re.exec(body)) {
                                collectionIds.add(group[1]);
                            }
                            return [4 /*yield*/, Promise.all(Array.from(collectionIds).map(function (collectionId) { return _this.collection(collectionId); }))];
                        case 2:
                            collections = _a.sent();
                            return [2 /*return*/, collections];
                    }
                });
            });
        };
        /**
         * Netease only return 3 collections
         */
        NeteaseMusicApi.prototype.songBelongsToCollections = function (songId, limit) {
            if (limit === void 0) { limit = 5; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.similarCollections;
                            data = {
                                songid: songId,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeCollections(json['playlists'])];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.collectionListOrders = function () {
            return [
                { id: 'hot', name: '最热' },
                { id: 'new', name: '最新' },
            ];
        };
        NeteaseMusicApi.prototype.collectionListOptions = function () {
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json, categories, options, _all;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.collectionListOptions;
                            data = {};
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            categories = json['categories'];
                            options = [];
                            _all = {
                                type: 'cat',
                                name: '全部歌单',
                                items: [{ id: '全部', name: '全部' }],
                            };
                            options.push(_all);
                            Object.keys(categories).forEach(function (id) {
                                var option = {
                                    type: 'cat',
                                    name: categories[id],
                                    items: json['sub']
                                        .filter(function (info) { return info['category'].toString() == id; })
                                        .map(function (info) { return ({
                                        id: info['name'],
                                        name: info['name'],
                                    }); }),
                                };
                                options.push(option);
                            });
                            return [2 /*return*/, options];
                    }
                });
            });
        };
        /**
         * order:
         *     hot
         *     new
         */
        NeteaseMusicApi.prototype.collectionList = function (cat, order, offset, limit) {
            if (order === void 0) { order = 'hot'; }
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.collectionList;
                            data = {
                                cat: cat,
                                order: order,
                                offset: offset,
                                limit: limit,
                                total: true,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeCollections(json['playlists'])];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.artistListOptions = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, common_1.ARTIST_LIST_OPTIONS];
                });
            });
        };
        NeteaseMusicApi.prototype.artistList = function (category, initial, offset, limit) {
            if (category === void 0) { category = null; }
            if (initial === void 0) { initial = null; }
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.artistList;
                            data = {
                                categoryCode: category || undefined,
                                initial: initial || undefined,
                                offset: offset,
                                limit: limit,
                                total: true,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeArtists(json['artists'])];
                    }
                });
            });
        };
        /**
         * Get new songs
         *
         * Here, offset, limit are not functional
         */
        NeteaseMusicApi.prototype.newSongs = function (offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.newSongs;
                            data = {
                                areaId: 0,
                                // limit: limit, 
                                // offset: offset,
                                total: true,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeSongs(json['data'] || [])];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.newAlbums = function (offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.newAlbums;
                            data = {
                                area: 'ALL',
                                limit: limit,
                                offset: offset,
                                total: true,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeAlbums(json['albums'] || [])];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.newCollections = function (offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.newCollections;
                            data = {
                                cat: '全部',
                                order: 'new',
                                limit: limit,
                                offset: offset,
                                total: true,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeCollections(json['playlists'] || [])];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.login = function (accountName, password) {
            return __awaiter(this, void 0, void 0, function () {
                var tmpApi, node, data, result, cookies, user, account;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            tmpApi = new NeteaseMusicApi();
                            node = NeteaseMusicApi.NODE_MAP.login;
                            data = {
                                username: accountName,
                                password: crypto_1.md5(password),
                                rememberLogin: 'true',
                            };
                            return [4 /*yield*/, tmpApi.request(node, data, true)];
                        case 1:
                            result = _a.sent();
                            cookies = {};
                            result.headers['set-cookie'].forEach(function (cookieStr) {
                                var cookie = cookies_1.makeCookieFrom(cookieStr);
                                cookies[cookie.key] = cookie.value;
                            });
                            user = parser_1.makeUserProfile(result.body.profile);
                            account = {
                                user: user,
                                cookies: cookies,
                                type: 'account',
                            };
                            return [2 /*return*/, account];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.setAccount = function (account) {
            var _this = this;
            assert_1.ok(account.user.origin == origin_1.ORIGIN.netease, "[NeteaseMusicApi.setAccount]: this account is not a netease account");
            var domain = 'music.163.com';
            Object.keys(account.cookies).forEach(function (key) {
                var cookie = cookies_1.makeCookie(key, account.cookies[key], domain);
                _this.cookieJar.setCookie(cookie, domain.startsWith('http') ? domain : 'http://' + domain);
            });
            // For createCollection
            var cookie = cookies_1.makeCookie('os', 'pc', domain);
            this.cookieJar.setCookie(cookie, domain.startsWith('http') ? domain : 'http://' + domain);
            this.account = account;
        };
        NeteaseMusicApi.prototype.getAccount = function () {
            return this.account;
        };
        NeteaseMusicApi.prototype.logined = function () {
            return !!this.account && !!this.account.cookies && !!this.account.cookies['MUSIC_U'];
        };
        NeteaseMusicApi.prototype.loginRefresh = function () {
            return __awaiter(this, void 0, void 0, function () {
                var node, data, r;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.loginRefresh;
                            data = {
                                csrf_token: '',
                            };
                            return [4 /*yield*/, this.request(node, data, true)];
                        case 1:
                            r = _a.sent();
                            return [2 /*return*/, r.headers];
                    }
                });
            });
        };
        /**
         * here, the userId is IUserProfile.userOriginalId, as followings
         */
        NeteaseMusicApi.prototype.userProfile = function (userId) {
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json, user, webUrl, html, info;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.userProfile;
                            data = {
                                userId: userId,
                                csrf_token: '',
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            user = parser_1.makeUserProfile(json, userId);
                            webUrl = 'https://music.163.com/user?id=' + userId;
                            return [4 /*yield*/, _request_1.request({
                                    method: 'GET',
                                    url: webUrl,
                                    jar: this.cookieJar || null,
                                    headers: NeteaseMusicApi.WEB_HEADERS,
                                    gzip: true,
                                })];
                        case 2:
                            html = _a.sent();
                            info = parser_1.getInfosFromHtml(html);
                            return [2 /*return*/, __assign(__assign({}, user), info)];
                    }
                });
            });
        };
        /**
         * user's favorite songs is at a collection
         */
        NeteaseMusicApi.prototype.userFavoriteSongs = function (userId, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var collections, collectionId, collection;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.userFavoriteCollections(userId, 0, 1)];
                        case 1:
                            collections = _a.sent();
                            if (collections.length < 1) {
                                return [2 /*return*/, []];
                            }
                            collectionId = collections[0].collectionOriginalId;
                            return [4 /*yield*/, this.collection(collectionId)];
                        case 2:
                            collection = _a.sent();
                            return [2 /*return*/, collection.songs.slice(offset, offset + limit)];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.userFavoriteArtists = function (userId, offset, limit, order) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            if (order === void 0) { order = false; }
            return __awaiter(this, void 0, void 0, function () {
                var account, node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                return [2 /*return*/, []];
                            }
                            account = this.account;
                            // logined user's favorite artists list can only be got
                            if (account.user.userOriginalId != userId) {
                                return [2 /*return*/, []];
                            }
                            node = NeteaseMusicApi.NODE_MAP.userFavoriteArtists;
                            data = {
                                offset: offset,
                                limit: limit,
                                order: order,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeArtists(json.data)];
                    }
                });
            });
        };
        /**
         * user's favorite and created collections are in here,
         * discriminated by userId
         */
        NeteaseMusicApi.prototype.userFavoriteCollections = function (userId, offset, limit, order) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            if (order === void 0) { order = false; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.userFavoriteCollections;
                            data = {
                                uid: userId,
                                offset: offset,
                                limit: limit,
                                order: order,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeCollections(json.playlist)];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.userFollowings = function (userId, offset, limit, order) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            if (order === void 0) { order = false; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.userFollowings + userId;
                            data = {
                                offset: offset,
                                limit: limit,
                                order: order,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeUserProfiles(json.follow)];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.userFollowers = function (userId, offset, limit, order) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            if (order === void 0) { order = false; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.userFollowers;
                            data = {
                                userId: userId,
                                offset: offset,
                                limit: limit,
                                order: order,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeUserProfiles(json.followeds)];
                    }
                });
            });
        };
        /**
         * songId is ISong.songOriginalId, as following
         */
        NeteaseMusicApi.prototype.userLikeSong = function (songId, _, dislike) {
            if (dislike === void 0) { dislike = false; }
            return __awaiter(this, void 0, void 0, function () {
                var userId, collections, collectionId, node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError(dislike ?
                                    '[NeteaseMusicApi] deleting one song from favorite songs list needs to login' :
                                    '[NeteaseMusicApi] Saving one song to favorite songs list needs to login');
                            }
                            userId = this.account.user.userOriginalId;
                            return [4 /*yield*/, this.userFavoriteCollections(userId, 0, 1)];
                        case 1:
                            collections = _a.sent();
                            if (collections.length < 1) {
                                throw new errors_1.ServerError('[NeteaseMusicApi] No user favorite collection');
                            }
                            collectionId = collections[0].collectionOriginalId;
                            node = NeteaseMusicApi.NODE_MAP.userLikeSong;
                            data = {
                                op: dislike ? 'del' : 'add',
                                pid: collectionId,
                                trackIds: JSON.stringify([songId]),
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 2:
                            json = _a.sent();
                            return [2 /*return*/, json.code == 200];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.userLikeArtist = function (artistId, _, dislike) {
            if (dislike === void 0) { dislike = false; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError(dislike ?
                                    '[NeteaseMusicApi] deleting one artist needs to login' :
                                    '[NeteaseMusicApi] Saving one artist needs to login');
                            }
                            node = dislike ?
                                NeteaseMusicApi.NODE_MAP.userDislikeArtist :
                                NeteaseMusicApi.NODE_MAP.userLikeArtist;
                            data = {
                                artistId: artistId,
                                artistIds: JSON.stringify([artistId]),
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.code == 200];
                    }
                });
            });
        };
        /**
         * Cookie 'os=pc' is needed
         */
        NeteaseMusicApi.prototype.createCollection = function (collectionName) {
            return __awaiter(this, void 0, void 0, function () {
                var account, csrf_token, node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[NeteaseMusicApi] Creating one collection needs to login');
                            }
                            account = this.getAccount();
                            csrf_token = account.cookies['__csrf'];
                            node = NeteaseMusicApi.NODE_MAP.createCollection;
                            data = {
                                name: collectionName,
                                csrf_token: csrf_token,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeCollection(json.playlist)];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.userLikeAlbum = function (albumId, _) {
            return __awaiter(this, void 0, void 0, function () {
                var account, csrf_token, album, songIds, collection, node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[NeteaseMusicApi] Save one album needs to login');
                            }
                            account = this.getAccount();
                            csrf_token = account.cookies['__csrf'];
                            return [4 /*yield*/, this.album(albumId)];
                        case 1:
                            album = _a.sent();
                            songIds = album.songs.map(function (song) { return song.songOriginalId; }).reverse();
                            return [4 /*yield*/, this.createCollection(album.albumName)];
                        case 2:
                            collection = _a.sent();
                            node = NeteaseMusicApi.NODE_MAP.userLikeSong;
                            data = {
                                op: 'add',
                                pid: collection.collectionOriginalId,
                                trackIds: JSON.stringify(songIds),
                                csrf_token: csrf_token,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 3:
                            json = _a.sent();
                            return [2 /*return*/, json.code == 200];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.userLikeCollection = function (collectionId, _, dislike) {
            if (dislike === void 0) { dislike = false; }
            return __awaiter(this, void 0, void 0, function () {
                var account, csrf_token, node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError(dislike ?
                                    '[NeteaseMusicApi] deleting one collection needs to login' :
                                    '[NeteaseMusicApi] Saving one collection needs to login');
                            }
                            account = this.getAccount();
                            csrf_token = account.cookies['__csrf'];
                            node = dislike ?
                                NeteaseMusicApi.NODE_MAP.userDislikeCollection :
                                NeteaseMusicApi.NODE_MAP.userLikeCollection;
                            data = dislike ? {
                                id: collectionId,
                                pid: collectionId,
                                csrf_token: csrf_token,
                            } : {
                                id: collectionId,
                                csrf_token: csrf_token,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.code == 200];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.userLikeUserProfile = function (userId, _, dislike) {
            if (dislike === void 0) { dislike = false; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError(dislike ?
                                    '[NeteaseMusicApi] deleting one collection needs to login' :
                                    '[NeteaseMusicApi] Saving one collection needs to login');
                            }
                            node = (dislike ?
                                NeteaseMusicApi.NODE_MAP.userDislikeUserProfile :
                                NeteaseMusicApi.NODE_MAP.userLikeUserProfile) + userId;
                            data = {};
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.code == 200];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.userDislikeSong = function (songId, _) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeSong(songId, null, true)];
                });
            });
        };
        NeteaseMusicApi.prototype.userDislikeAlbum = function (albumId, _) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    // there is no album saved at netease music
                    return [2 /*return*/, false];
                });
            });
        };
        NeteaseMusicApi.prototype.userDislikeArtist = function (artistId, _) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeArtist(artistId, null, true)];
                });
            });
        };
        NeteaseMusicApi.prototype.userDislikeCollection = function (collectionId, _) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeCollection(collectionId, null, true)];
                });
            });
        };
        NeteaseMusicApi.prototype.userDislikeUserProfile = function (userId, _) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeUserProfile(userId, null, true)];
                });
            });
        };
        NeteaseMusicApi.prototype.recommendNewSongs = function (offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = NeteaseMusicApi.NODE_MAP.recommendNewSongs;
                            data = {
                                type: "recommend",
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeSongs((json['result'] || []).map(function (i) { return i['song']; })).slice(offset, offset + limit)];
                    }
                });
            });
        };
        /**
         * Login is needed
         */
        NeteaseMusicApi.prototype.recommendSongs = function (offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                return [2 /*return*/, this.recommendNewSongs(offset, limit)];
                            }
                            node = NeteaseMusicApi.NODE_MAP.recommendSongs;
                            data = {
                                limit: limit,
                                offset: offset,
                                total: true,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeSongs(json['recommend'] || []).slice(offset, offset + limit)];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.recommendCollections = function (offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this.logined()) {
                                return [2 /*return*/, this.recommendDailyCollections(offset, limit)];
                            }
                            node = NeteaseMusicApi.NODE_MAP.recommendCollections;
                            data = {
                                limit: limit,
                                offset: offset,
                                n: limit,
                                total: true,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeCollections(json['result'] || [])];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.recommendDailyCollections = function (offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[NeteaseMusicApi] `recommendDailyCollections` needs to login');
                            }
                            node = NeteaseMusicApi.NODE_MAP.recommendDailyCollections;
                            data = {};
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeCollections(json['recommend'] || [])];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.playLog = function (songId, seek) {
            return __awaiter(this, void 0, void 0, function () {
                var account, csrf_token, node, data, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[NeteaseMusicApi] recording one played song needs to login');
                            }
                            account = this.getAccount();
                            csrf_token = account.cookies['__csrf'];
                            node = NeteaseMusicApi.NODE_MAP.playLog;
                            data = {
                                logs: JSON.stringify([{
                                        action: 'play',
                                        json: {
                                            end: 'ui',
                                            time: seek,
                                            wifi: 0,
                                            type: 'song',
                                            id: parseInt(songId),
                                        }
                                    }]),
                                csrf_token: csrf_token,
                            };
                            return [4 /*yield*/, this.request(node, data)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.code == 200];
                    }
                });
            });
        };
        NeteaseMusicApi.prototype.resizeImageUrl = function (url, size) {
            return size_1.resizeImageUrl(url, size, function (url, size) { return url + "?param=" + size + "y" + size; });
        };
        NeteaseMusicApi.prototype.fromURL = function (input) {
            return __awaiter(this, void 0, void 0, function () {
                var chunks, items, chunks_1, chunks_1_1, chunk, m, originId, type, matchList, matchList_1, matchList_1_1, _a, re, tp, item, _b, e_1_1;
                var e_1, _c, e_2, _d;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            chunks = input.split(' ');
                            items = [];
                            _e.label = 1;
                        case 1:
                            _e.trys.push([1, 16, 17, 18]);
                            chunks_1 = __values(chunks), chunks_1_1 = chunks_1.next();
                            _e.label = 2;
                        case 2:
                            if (!!chunks_1_1.done) return [3 /*break*/, 15];
                            chunk = chunks_1_1.value;
                            m = void 0;
                            originId = void 0;
                            type = void 0;
                            matchList = [
                                // song
                                [/song\?id=(\d+)/, 'song'],
                                // artist
                                [/artist\?id=(\d+)/, 'artist'],
                                // album
                                [/album\?id=(\d+)/, 'album'],
                                // playlist
                                [/playlist\?id=(\d+)/, 'collection'],
                                // user
                                [/home\?id=(\d+)/, 'user'],
                            ];
                            try {
                                for (matchList_1 = (e_2 = void 0, __values(matchList)), matchList_1_1 = matchList_1.next(); !matchList_1_1.done; matchList_1_1 = matchList_1.next()) {
                                    _a = __read(matchList_1_1.value, 2), re = _a[0], tp = _a[1];
                                    m = re.exec(chunk);
                                    if (m) {
                                        originId = m[1];
                                        type = tp;
                                        break;
                                    }
                                }
                            }
                            catch (e_2_1) { e_2 = { error: e_2_1 }; }
                            finally {
                                try {
                                    if (matchList_1_1 && !matchList_1_1.done && (_d = matchList_1.return)) _d.call(matchList_1);
                                }
                                finally { if (e_2) throw e_2.error; }
                            }
                            if (!originId) return [3 /*break*/, 14];
                            item = void 0;
                            _b = type;
                            switch (_b) {
                                case 'song': return [3 /*break*/, 3];
                                case 'artist': return [3 /*break*/, 5];
                                case 'album': return [3 /*break*/, 7];
                                case 'collection': return [3 /*break*/, 9];
                                case 'user': return [3 /*break*/, 11];
                            }
                            return [3 /*break*/, 13];
                        case 3: return [4 /*yield*/, this.song(originId)];
                        case 4:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 14];
                        case 5: return [4 /*yield*/, this.artist(originId)];
                        case 6:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 14];
                        case 7: return [4 /*yield*/, this.album(originId)];
                        case 8:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 14];
                        case 9: return [4 /*yield*/, this.collection(originId)];
                        case 10:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 14];
                        case 11: return [4 /*yield*/, this.userProfile(originId)];
                        case 12:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 14];
                        case 13: return [3 /*break*/, 14];
                        case 14:
                            chunks_1_1 = chunks_1.next();
                            return [3 /*break*/, 2];
                        case 15: return [3 /*break*/, 18];
                        case 16:
                            e_1_1 = _e.sent();
                            e_1 = { error: e_1_1 };
                            return [3 /*break*/, 18];
                        case 17:
                            try {
                                if (chunks_1_1 && !chunks_1_1.done && (_c = chunks_1.return)) _c.call(chunks_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                            return [7 /*endfinally*/];
                        case 18: return [2 /*return*/, items];
                    }
                });
            });
        };
        NeteaseMusicApi.HEADERS = {
            'Accept-Encoding': 'gzip, deflate',
            'Accept-Language': 'zh-CN,zh;q=0.9,en;q=0.8,zh-TW;q=0.7',
            'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36',
            'Accept': '*/*',
            'Content-Type': 'application/x-www-form-urlencoded',
            'Referer': 'http://music.163.com/m',
            'Connection': 'keep-alive',
            'Cache-Control': 'no-cache',
        };
        NeteaseMusicApi.WEB_HEADERS = {
            'Connection': 'keep-alive',
            'Upgrade-Insecure-Requests': '1',
            'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36',
            'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8',
            'Accept-Encoding': 'gzip, deflate',
            'Accept-Language': 'en-US,en;q=0.9,zh-CN;q=0.8,zh;q=0.7,ja;q=0.6,zh-TW;q=0.5',
        };
        NeteaseMusicApi.BASICURL = 'http://music.163.com/';
        NeteaseMusicApi.NODE_MAP = {
            audio: 'weapi/song/enhance/player/url',
            song: 'weapi/v3/song/detail',
            lyric: 'weapi/song/lyric',
            album: 'weapi/v1/album',
            collection: 'weapi/v3/playlist/detail',
            artist: 'weapi/v1/artist',
            artistSongs: 'weapi/v1/artist',
            artistAlbums: 'weapi/artist/albums',
            search: 'weapi/search/get',
            similarSongs: 'weapi/v1/discovery/simiSong',
            similarArtists: 'weapi/discovery/simiArtist',
            similarCollections: 'weapi/discovery/simiPlaylist',
            collectionListOptions: 'weapi/playlist/catalogue',
            collectionList: 'weapi/playlist/list',
            artistList: 'weapi/artist/list',
            newSongs: 'weapi/v1/discovery/new/songs',
            newAlbums: 'weapi/album/new',
            newCollections: 'weapi/playlist/list',
            login: 'weapi/login',
            loginRefresh: 'weapi/login/token/refresh',
            userProfile: 'weapi/share/userprofile/info',
            userFavoriteArtists: 'weapi/artist/sublist',
            userFavoriteCollections: 'weapi/user/playlist',
            userFollowings: 'weapi/user/getfollows/',
            userFollowers: 'weapi/user/getfolloweds',
            userLikeSong: 'weapi/playlist/manipulate/tracks',
            createCollection: 'weapi/playlist/create',
            userLikeArtist: 'weapi/artist/sub',
            userLikeCollection: 'weapi/playlist/subscribe',
            userLikeUserProfile: 'weapi/user/follow/',
            userDislikeArtist: 'weapi/artist/unsub',
            userDislikeCollection: 'weapi/playlist/unsubscribe',
            userDislikeUserProfile: 'weapi/user/delfollow/',
            recommendNewSongs: 'weapi/personalized/newsong',
            recommendSongs: 'weapi/v1/discovery/recommend/songs',
            recommendDailyCollections: 'weapi/v1/discovery/recommend/resource',
            recommendCollections: 'weapi/personalized/playlist',
            playLog: 'weapi/feedback/weblog',
        };
        return NeteaseMusicApi;
    }());
    exports.NeteaseMusicApi = NeteaseMusicApi;
});
