define(["require", "exports", "crypto", "big-integer", "chord/base/common/constants", "chord/base/node/random"], function (require, exports, crypto, bigInt, constants_1, random_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.encryptLinux = exports.encrypt = exports.toRSA = exports.toAES = void 0;
    var AES_MOD = 'AES-128-CBC';
    var AES_CBC_INIT_VECTOR = '0102030405060708';
    var NETEASE_INIT_AES_INPUT = '0CoJUm6Qyw8W8jud';
    var RSA_MOD = '00e0b509f6259df8642dbc35662901477df22677ec152b5ff68ace615bb7b725152b3ab17a876aea8a5aa76d2e417629ec4ee341f56135fccf695280104e0312ecbda92557c93870114af6c9d05c4f7f0c3685b7a46bee255932575cce10b424d813cfe4875d3e82047b97ddef52741d546b8e289dc6935b3ece0462db0a22b8e7';
    var RSA_PUB_KEY = '010001';
    function toAES(input, key) {
        var cipher = crypto.createCipheriv(AES_MOD, Buffer.from(key, 'binary'), Buffer.from(AES_CBC_INIT_VECTOR, 'binary'));
        return cipher.update(input, 'utf8', 'base64') + cipher.final('base64');
    }
    exports.toAES = toAES;
    function toRSA(input, pubKey, mod) {
        var reverseInput = Array.from(input).reverse().join('');
        var bigInput = bigInt(Buffer.from(reverseInput).toString('hex'), 16);
        var bigPubKey = bigInt(RSA_PUB_KEY, 16);
        var bigMod = bigInt(mod, 16);
        var result = bigInput.modPow(bigPubKey, bigMod);
        return result.toString(16).padStart(256);
    }
    exports.toRSA = toRSA;
    function encrypt(obj) {
        var str = JSON.stringify(obj);
        var secKey = random_1.getRandomSample(Array.from(constants_1.ASCII_LETTER_DIGIT), 16).join('');
        var encStr = toAES(toAES(str, NETEASE_INIT_AES_INPUT), secKey);
        var encSecKey = toRSA(secKey, RSA_PUB_KEY, RSA_MOD);
        return { params: encStr, encSecKey: encSecKey };
    }
    exports.encrypt = encrypt;
    function encryptLinux(obj) {
        var input = JSON.stringify(obj);
        var cipher = crypto.createCipheriv('AES-128-ECB', Buffer.from('7246674226682325323F5E6544673A51', 'hex'), '');
        var r = cipher.update(input, 'utf8', 'base64') + cipher.final('base64');
        // r = '045913148E5D4B33D53D16D283F3C3445BCA8A188E1BE398DB4C9A3FC117E19CFD5383E018356CEB3F0AE94452892D4ED77FA1307DCE569066821F538183EC9A11BA253DED5B5D7883C32F6A60F50658C227FE4CC1F2076243736E2A36B635D0E8864A120B597EE567CEB5693CCE750C7EF54E238436BDE0CA8F376126AA1104';
        r = Buffer.from(r, 'base64').toString('hex').toUpperCase();
        return { 'eparams': r };
    }
    exports.encryptLinux = encryptLinux;
});
