var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
define(["require", "exports", "assert", "process", "mocha", "chord/music/qianqian/api"], function (require, exports, assert, process, mocha_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var api = new api_1.QianQianApi();
    var IN_CI = process.env.IN_CI;
    mocha_1.suite('music/qianqian/QianQianApi', function () {
        /**
         * Net requests have some probability to be fail,
         * so we test these requests at local, missing at CI
        */
        if (IN_CI)
            return;
        mocha_1.test('audios', function () {
            return __awaiter(this, void 0, void 0, function () {
                var audios;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.audios('931434')];
                        case 1:
                            audios = _a.sent();
                            assert.equal(audios.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('audio', function () {
            return __awaiter(this, void 0, void 0, function () {
                var audios;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.audio('2108946')];
                        case 1:
                            audios = _a.sent();
                            assert.equal(audios.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('song', function () {
            return __awaiter(this, void 0, void 0, function () {
                var song;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.song('2108946')];
                        case 1:
                            song = _a.sent();
                            assert.equal(song.songOriginalId, '2108946');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('album', function () {
            return __awaiter(this, void 0, void 0, function () {
                var album;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.album('613447457')];
                        case 1:
                            album = _a.sent();
                            assert.equal(album.albumOriginalId, '613447457');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artist', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.artist('123')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.artistOriginalId, '123');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artistSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.artistSongs('123', 0, 1)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artistAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.artistAlbums('123', 0, 1)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('collection', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.collection('566332125')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.collectionOriginalId, '566332125');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('collectionSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.collectionSongs('566332125')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.searchSongs('linkin', 0, 2)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.searchAlbums('linkin', 0, 2)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchArtists', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.searchArtists('linkin', 0, 2)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.searchCollections('linkin', 0, 2)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userProfile', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.userProfile('麦芽糖糖')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.userName, '麦芽糖糖');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFavoriteAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.userFavoriteAlbums('2698337947')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFavoriteArtists', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.userFavoriteArtists('2698337947')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFavoriteCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.userFavoriteCollections('2698337947')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userCreatedCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.userCreatedCollections('2698337947')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFollowers', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.userFollowers('2698337947')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFollowings', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.userFollowings('2698337947')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('fromURL', function () {
            return __awaiter(this, void 0, void 0, function () {
                var data, data_1, data_1_1, _a, url, key, id, items, e_1_1;
                var e_1, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            data = [
                                ['http://music.taihe.com/song/931434', 'songOriginalId', '931434'],
                                ['http://music.taihe.com/artist/1097?pst=sug', 'artistOriginalId', '123'],
                                ['http://music.taihe.com/album/613447457', 'albumOriginalId', '613447457'],
                                ['http://music.taihe.com/songlist/566332198', 'collectionOriginalId', '566332198'],
                                ['http://music.taihe.com/user?nickname=%E4%B8%80%E6%9D%AF%E6%B8%85%E8%8C%B6%E5%92%8C%E8%80%81%E6%AD%8C', 'userOriginalId', '2698316399'],
                            ];
                            _c.label = 1;
                        case 1:
                            _c.trys.push([1, 6, 7, 8]);
                            data_1 = __values(data), data_1_1 = data_1.next();
                            _c.label = 2;
                        case 2:
                            if (!!data_1_1.done) return [3 /*break*/, 5];
                            _a = __read(data_1_1.value, 3), url = _a[0], key = _a[1], id = _a[2];
                            return [4 /*yield*/, api.fromURL(url)];
                        case 3:
                            items = _c.sent();
                            assert.equal(items[0][key], id);
                            _c.label = 4;
                        case 4:
                            data_1_1 = data_1.next();
                            return [3 /*break*/, 2];
                        case 5: return [3 /*break*/, 8];
                        case 6:
                            e_1_1 = _c.sent();
                            e_1 = { error: e_1_1 };
                            return [3 /*break*/, 8];
                        case 7:
                            try {
                                if (data_1_1 && !data_1_1.done && (_b = data_1.return)) _b.call(data_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                            return [7 /*endfinally*/];
                        case 8: return [2 /*return*/];
                    }
                });
            });
        });
    });
});
