var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
define(["require", "exports", "assert", "process", "mocha", "chord/music/qq/api"], function (require, exports, assert, process, mocha_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var qqApi = new api_1.QQMusicApi();
    var IN_CI = process.env.IN_CI;
    mocha_1.suite('music/qq/QQMusicApi', function () {
        /**
         * Net requests have some probability to be fail,
         * so we test these requests at local, missing at CI
        */
        if (IN_CI)
            return;
        mocha_1.test('audios', function () {
            return __awaiter(this, void 0, void 0, function () {
                var audios;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.audios('228011930')];
                        case 1:
                            audios = _a.sent();
                            assert.equal(audios.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('song', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, song, songOriginalId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '228011930';
                            return [4 /*yield*/, qqApi.song(id)];
                        case 1:
                            song = _a.sent();
                            songOriginalId = song.songOriginalId;
                            assert.equal(songOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('lyric', function () {
            return __awaiter(this, void 0, void 0, function () {
                var lyric;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.lyric('228011930', '001Ar8Ya3b63M4')];
                        case 1:
                            lyric = _a.sent();
                            assert.equal(lyric.songId, 'qq|song|228011930');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('album', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, album;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '5917989';
                            return [4 /*yield*/, qqApi.album(id)];
                        case 1:
                            album = _a.sent();
                            assert.equal(album.albumOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artist', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, artist;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '2923';
                            return [4 /*yield*/, qqApi.artist(id)];
                        case 1:
                            artist = _a.sent();
                            assert.equal(artist.artistOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artistSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, songs, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '2923';
                            return [4 /*yield*/, qqApi.artistSongs(id, 0, 1)];
                        case 1:
                            songs = _a.sent();
                            size = songs.length;
                            assert.equal(size, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artistAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, albums, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '003wI8vE3k8cTY';
                            return [4 /*yield*/, qqApi.artistAlbums(id, 0, 1)];
                        case 1:
                            albums = _a.sent();
                            size = albums.length;
                            assert.equal(size, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('collection', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, collection, songsSize, collectionOriginalId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '6267000549';
                            return [4 /*yield*/, qqApi.collection(id)];
                        case 1:
                            collection = _a.sent();
                            songsSize = collection.songs.length;
                            assert.equal(songsSize > 0, true);
                            collectionOriginalId = collection.collectionOriginalId;
                            assert.equal(collectionOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songs, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.searchSongs('linkin', 0, 1)];
                        case 1:
                            songs = _a.sent();
                            size = songs.length;
                            assert.equal(size, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var albums, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.searchAlbums('linkin', 0, 1)];
                        case 1:
                            albums = _a.sent();
                            size = albums.length;
                            assert.equal(size, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.searchCollections('linkin', 0, 1)];
                        case 1:
                            collections = _a.sent();
                            size = collections.length;
                            assert.equal(size, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('songList', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songs, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.songList(1, 0, 1)];
                        case 1:
                            songs = _a.sent();
                            size = songs.length;
                            assert.equal(size > 1, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('albumListOptions', function () {
            return __awaiter(this, void 0, void 0, function () {
                var options;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.albumListOptions()];
                        case 1:
                            options = _a.sent();
                            assert.equal(options.slice(-1)[0].type, 'sort');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('albumList', function () {
            return __awaiter(this, void 0, void 0, function () {
                var albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.albumList(5, 0, -1, -1, -1, -1, 0, 1)];
                        case 1:
                            albums = _a.sent();
                            assert.equal(albums.length > 1, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('collectionListOptions', function () {
            return __awaiter(this, void 0, void 0, function () {
                var options;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.collectionListOptions()];
                        case 1:
                            options = _a.sent();
                            assert.equal(options.slice(-1)[0].type, 'sort');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('collectionList', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.collectionList(3, 10000000, 0, 1)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length > 1, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('newSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.newSongs(0, 1)];
                        case 1:
                            songs = _a.sent();
                            assert.equal(songs.length > 1, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('newAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.newAlbums(0, 1)];
                        case 1:
                            albums = _a.sent();
                            assert.equal(albums.length > 1, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('newCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.newCollections(0, 1)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length > 1, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('logined', function () {
            var ok = qqApi.logined();
            assert.equal(ok, false);
        });
        mocha_1.test('recommendCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, qqApi.recommendCollections(0, 1)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length > 1, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
    });
});
