var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
define(["require", "exports", "chord/platform/log/common/log", "chord/platform/utils/common/paths", "chord/base/common/assert", "chord/base/common/objects", "chord/base/node/crypto", "chord/base/node/random", "chord/base/node/cookies", "chord/base/node/url", "chord/base/node/_request", "chord/music/common/origin", "chord/music/common/size", "chord/music/xiami/parser", "chord/music/xiami/common", "chord/music/xiami/webApi"], function (require, exports, log_1, paths_1, assert_1, objects_1, crypto_1, random_1, cookies_1, url_1, _request_1, origin_1, size_1, parser_1, common_1, webApi_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.AliMusicApi = void 0;
    var loggerWarning = new log_1.Logger(paths_1.filenameToNodeName(__filename), log_1.LogLevel.Warning);
    var DOMAIN = 'xiami.com';
    var UIDXM = 'uidXM';
    var CNA = 'cna';
    /**
     * Alibaba Music Api
     */
    var AliMusicApi = /** @class */ (function () {
        function AliMusicApi() {
            var _this = this;
            this.cookies = {};
            this.userId = '1';
            // Get cna
            this.getEtag().then(function (etag) {
                _this.setEtagCookie(etag);
            });
            this.xiamiWebApi = new webApi_1.XiamiApi();
        }
        AliMusicApi.prototype.reset = function () {
            this.token = null;
            this.cookies = {};
        };
        AliMusicApi.makeCookie = function (key, value) {
            var domain = DOMAIN;
            return cookies_1.makeCookie(key, value, domain);
        };
        AliMusicApi.prototype.makeQueryStr = function (params) {
            var header = {
                platformId: AliMusicApi.PLATFORM_ID,
                callId: Date.now(),
                appVersion: 1000000,
                resolution: '2560x1440',
                appId: 200,
                openId: 0,
            };
            if (this.accessToken) {
                header = objects_1.assign({}, header, { accessToken: this.accessToken });
            }
            return JSON.stringify({
                requestStr: JSON.stringify({
                    header: header,
                    model: params,
                })
            });
        };
        AliMusicApi.prototype.makeSign = function (queryStr, time) {
            var token = this.token || 'undefined';
            var str = token + '&' + time + '&' + AliMusicApi.APPKEY + '&' + queryStr;
            return crypto_1.md5(str);
        };
        AliMusicApi.prototype.makeParamstr = function (time, sign, queryStr, node) {
            var paramstr = url_1.querystringify({
                jsv: AliMusicApi.JSV,
                appKey: AliMusicApi.APPKEY,
                t: time,
                sign: sign,
                api: node,
                v: AliMusicApi.VERSION,
                type: 'originaljsonp',
                timeout: '200000',
                dataType: 'originaljsonp',
                AntiCreep: 'true',
                AntiFlood: 'true',
                callback: 'mtopjsonp1',
                data: queryStr,
            });
            return paramstr;
        };
        AliMusicApi.prototype.getToken = function () {
            return __awaiter(this, void 0, void 0, function () {
                var guess;
                return __generator(this, function (_a) {
                    if (this.token) {
                        return [2 /*return*/, null];
                    }
                    // userId is needed to anti-creep
                    if (this.userId) {
                        this.setUserIdCookie();
                    }
                    guess = random_1.getRandomInt(0, 4);
                    switch (guess) {
                        case 0:
                            return [2 /*return*/, this.request(AliMusicApi.NODE_MAP.song, { songId: '1' }, 'http://h.xiami.com/song_detail.html?id=1&f=&from=&ch=', true)];
                        case 1:
                            return [2 /*return*/, this.request(AliMusicApi.NODE_MAP.album, { albumId: '1' }, 'http://h.xiami.com/album_detail.html?id=1&f=&from=&ch=', true)];
                        case 2:
                            return [2 /*return*/, this.request(AliMusicApi.NODE_MAP.artist, { artistId: '1' }, 'http://h.xiami.com/artist_detail.html?id=1&f=&from=&ch=', true)];
                        case 3:
                            return [2 /*return*/, this.request(AliMusicApi.NODE_MAP.collection, { collectId: '928111975' }, 'http://h.xiami.com/collect_detail.html?id=1&f=&from=&ch=', true)];
                        case 4:
                            return [2 /*return*/, this.request(AliMusicApi.NODE_MAP.userProfile, { userId: 423815251 }, null, true)];
                        default:
                            break;
                    }
                    return [2 /*return*/];
                });
            });
        };
        AliMusicApi.prototype.setUserIdCookie = function (userId) {
            userId = userId || this.userId;
            assert_1.ok(userId, 'no userId');
            var key = 'uidXM';
            var value = userId;
            var cookie = AliMusicApi.makeCookie(key, value);
            this.cookies['uidXM'] = cookie;
        };
        /**
         * Etag for anti spider
         */
        AliMusicApi.prototype.getEtag = function () {
            return __awaiter(this, void 0, void 0, function () {
                var url, options, result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = 'http://log.mmstat.com/eg.js';
                            options = {
                                method: 'GET',
                                url: url,
                                headers: __assign({}, AliMusicApi.HEADERS),
                                gzip: true,
                                resolveWithFullResponse: true,
                            };
                            return [4 /*yield*/, _request_1.request(options)];
                        case 1:
                            result = _a.sent();
                            return [2 /*return*/, result.headers['etag']];
                    }
                });
            });
        };
        AliMusicApi.prototype.setEtagCookie = function (etag) {
            var key = 'cna';
            var value = etag;
            var cookie = AliMusicApi.makeCookie(key, value);
            this.cookies['cna'] = cookie;
        };
        /**
         * If init is true, request returns response, NOT json
         */
        AliMusicApi.prototype.request = function (node, apiParams, referer, init, excludedCookies) {
            if (init === void 0) { init = false; }
            if (excludedCookies === void 0) { excludedCookies = []; }
            return __awaiter(this, void 0, void 0, function () {
                var url, queryStr, time, sign, params, headers, cookieJar, cookies, key, options, result, json;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!!init) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.getToken()];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2:
                            // set random use id for anti-spider
                            this.setUserIdCookie(random_1.getRandomInt(1, 30000000).toString());
                            url = AliMusicApi.BASICURL + node + '/' + AliMusicApi.VERSION + '/';
                            queryStr = this.makeQueryStr(apiParams);
                            time = Date.now();
                            sign = this.makeSign(queryStr, time);
                            params = this.makeParamstr(time, sign, queryStr, node);
                            headers = !!referer ? __assign(__assign({}, AliMusicApi.HEADERS), { Referer: referer }) : __assign({}, AliMusicApi.HEADERS);
                            cookieJar = cookies_1.makeCookieJar();
                            cookies = __assign({}, this.cookies);
                            excludedCookies.forEach(function (key) { delete cookies[key]; });
                            for (key in cookies) {
                                cookieJar.setCookie(cookies[key], 'http://' + DOMAIN);
                            }
                            url = url + '?' + params;
                            options = {
                                method: 'GET',
                                url: url,
                                // Cookies is excepted to get token
                                jar: !init ? cookieJar : null,
                                headers: headers,
                                gzip: true,
                                resolveWithFullResponse: init,
                            };
                            return [4 /*yield*/, _request_1.request(options)];
                        case 3:
                            result = _a.sent();
                            if (init && result.headers.hasOwnProperty('set-cookie')) {
                                cookies_1.makeCookies(result.headers['set-cookie']).forEach(function (cookie) {
                                    _this.cookies[cookie.key] = cookie;
                                    if (cookie.key == '_m_h5_tk') {
                                        _this.token = cookie.value.split('_')[0];
                                    }
                                });
                                return [2 /*return*/, null];
                            }
                            json = JSON.parse(result.trim().slice(11, -1));
                            // TODO: Handle each errors
                            if (json.ret[0].search('SUCCESS') == -1) {
                                loggerWarning.warning('[AliMusicApi.request] [Error]: (params, response):', options, json);
                            }
                            if (!(json.ret && json.ret[0].search('FAIL_SYS_TOKEN_EXOIRED') != -1)) return [3 /*break*/, 5];
                            loggerWarning.warning('AliMusicApi: TOKEN_EXOIRED');
                            this.reset();
                            return [4 /*yield*/, this.getToken()];
                        case 4:
                            _a.sent();
                            return [2 /*return*/, this.request(node, apiParams, referer, init)];
                        case 5: return [2 /*return*/, json];
                    }
                });
            });
        };
        /**
         * Get audio urls, the songId must be number string
         *
         * WARN: AliMusicApi.song could be easily blocked by server,
         * We try XiamiApi.audios to get the audio urls
         */
        AliMusicApi.prototype.audios = function (songId, supkbps) {
            return __awaiter(this, void 0, void 0, function () {
                var audios, _a, song;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _b.trys.push([0, 2, , 4]);
                            return [4 /*yield*/, this.xiamiWebApi.audios(songId)];
                        case 1:
                            audios = _b.sent();
                            return [2 /*return*/, audios];
                        case 2:
                            _a = _b.sent();
                            return [4 /*yield*/, this.song(songId)];
                        case 3:
                            song = _b.sent();
                            return [2 /*return*/, song.audios];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Get many songs' audios
         */
        AliMusicApi.prototype.songsAudios = function (songIds) {
            return __awaiter(this, void 0, void 0, function () {
                var songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.songs(songIds)];
                        case 1:
                            songs = _a.sent();
                            return [2 /*return*/, songs.map(function (song) { return song.audios; })];
                    }
                });
            });
        };
        /**
         * Get a song, the songId must be number string
         */
        AliMusicApi.prototype.song2 = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, info, song;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.song, { songId: songId }, "http://h.xiami.com/song.html?id=" + songId + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.songDetail;
                            song = parser_1.makeAliSong(info);
                            return [2 /*return*/, song];
                    }
                });
            });
        };
        /**
         * Get a song, the songId must be number string
         */
        AliMusicApi.prototype.song = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, info, song;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.songs, { songIds: [songId] }, "http://h.xiami.com/song.html?id=" + songId + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.songs[0];
                            song = parser_1.makeAliSong(info);
                            return [2 /*return*/, song];
                    }
                });
            });
        };
        /**
         * Get songs, the songId must be number string
         */
        AliMusicApi.prototype.songs = function (songIds) {
            return __awaiter(this, void 0, void 0, function () {
                var json, info, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.songs, { songIds: songIds }, "http://h.xiami.com/song.html?id=" + songIds[0] + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.songs;
                            songs = parser_1.makeAliSongs(info);
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        AliMusicApi.prototype.lyric = function (songId, song) {
            return __awaiter(this, void 0, void 0, function () {
                var lyricUrl, cn;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(!song || !song.lyricUrl)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.song(songId)];
                        case 1:
                            song = _a.sent();
                            _a.label = 2;
                        case 2:
                            lyricUrl = song.lyricUrl;
                            if (!lyricUrl)
                                return [2 /*return*/, null];
                            return [4 /*yield*/, _request_1.htmlGet(lyricUrl)];
                        case 3:
                            cn = _a.sent();
                            return [2 /*return*/, parser_1.makeAliLyric(songId, cn)];
                    }
                });
            });
        };
        /**
         * Get similer songs, the songId must be number string
         */
        AliMusicApi.prototype.similarSongs = function (songId, size) {
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.similarSongs, {
                                limit: size,
                                quality: 'l',
                                context: '',
                                songId: parseInt(songId),
                            }, "http://h.xiami.com/song.html?id=" + songId + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.songs;
                            songs = parser_1.makeAliSongs(info);
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        /**
         * Get an album, the albumId must be number string
         */
        AliMusicApi.prototype.album = function (albumId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, info, album, err_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 4]);
                            return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.album, { albumId: albumId }, "http://h.xiami.com/album_detail.html?id=" + albumId + "&f=&from=&ch=", false, [UIDXM])];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.albumDetail;
                            album = parser_1.makeAliAlbum(info);
                            return [2 /*return*/, album];
                        case 2:
                            err_1 = _a.sent();
                            return [4 /*yield*/, this.xiamiWebApi.album(albumId)];
                        case 3: return [2 /*return*/, _a.sent()];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        AliMusicApi.prototype.albums = function (albumIds) {
            return __awaiter(this, void 0, void 0, function () {
                var json, info, albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.albums, { albumIds: albumIds }, "http://h.xiami.com/album_detail.html?id=" + albumIds[0] + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.albums;
                            albums = parser_1.makeAliAlbums(info);
                            return [2 /*return*/, albums];
                    }
                });
            });
        };
        /**
         * Get an artist, the artistId must be number string
         */
        AliMusicApi.prototype.artist = function (artistId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, info, artist, err_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 4]);
                            return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.artist, { artistId: artistId }, "http://h.xiami.com/artist_detail.html?id=" + artistId + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            info = json.data.data['artistDetailVO'];
                            artist = parser_1.makeAliArtist(info);
                            return [2 /*return*/, artist];
                        case 2:
                            err_2 = _a.sent();
                            return [4 /*yield*/, this.xiamiWebApi.artist(artistId)];
                        case 3: return [2 /*return*/, _a.sent()];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Get albums of an artist, the artistId must be number string
         */
        AliMusicApi.prototype.artistAlbums = function (artistId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, albums, e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.artistAlbums, {
                                    artistId: artistId,
                                    pagingVO: {
                                        page: page,
                                        pageSize: size,
                                    }
                                }, "http://h.xiami.com/artist_detail.html?id=" + artistId + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.albums;
                            albums = parser_1.makeAliAlbums(info);
                            return [2 /*return*/, albums];
                        case 2:
                            e_1 = _a.sent();
                            return [2 /*return*/, this.xiamiWebApi.artistAlbums(artistId, page, size)];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Get albums amount of an artist, the artistId must be number string
         */
        AliMusicApi.prototype.artistAlbumCount = function (artistId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.artistAlbums, {
                                artistId: artistId,
                                pagingVO: {
                                    page: 1,
                                    pageSize: 1,
                                }
                            }, "http://h.xiami.com/artist_detail.html?id=" + artistId + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.total];
                    }
                });
            });
        };
        /**
         * Get songs of an artist, the artistId must be number string
         */
        AliMusicApi.prototype.artistSongs = function (artistId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, songs, e_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.artistSongs, {
                                    artistId: artistId,
                                    backwardOffSale: true,
                                    pagingVO: {
                                        page: page,
                                        pageSize: size,
                                    }
                                }, "http://h.xiami.com/artist_detail.html?id=" + artistId + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.songs;
                            songs = parser_1.makeAliSongs(info);
                            return [2 /*return*/, songs];
                        case 2:
                            e_2 = _a.sent();
                            return [2 /*return*/, this.xiamiWebApi.artistSongs(artistId, page, size)];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Get songs amount of an artist, the artistId must be number string
         */
        AliMusicApi.prototype.artistSongCount = function (artistId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.artistSongs, {
                                artistId: artistId,
                                backwardOffSale: true,
                                pagingVO: {
                                    page: 1,
                                    pageSize: 1,
                                }
                            }, "http://h.xiami.com/artist_detail.html?id=" + artistId + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.total];
                    }
                });
            });
        };
        /**
         * Get similar artists of the artist, the artistId must be number string
         */
        AliMusicApi.prototype.similarArtists = function (artistId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, artists;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.similarArtists, {
                                artistId: artistId,
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                }
                            }, "http://h.xiami.com/artist_detail.html?id=" + artistId + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.artists;
                            artists = parser_1.makeAliArtists(info);
                            return [2 /*return*/, artists];
                    }
                });
            });
        };
        /**
         * How many similar artists has the artist, the artistId must be number string
         */
        AliMusicApi.prototype.similarArtistCount = function (artistId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.similarArtists, {
                                artistId: artistId,
                                pagingVO: {
                                    page: 1,
                                    pageSize: 1,
                                }
                            }, "http://h.xiami.com/artist_detail.html?id=" + artistId + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.pagingVO.count];
                    }
                });
            });
        };
        /**
         * Get a collection, the collectionId must be number string
         */
        AliMusicApi.prototype.collection = function (collectionId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 100; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, collection, err_3;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 4]);
                            return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.collection, {
                                    listId: collectionId,
                                    isFullTags: false,
                                    pagingVO: {
                                        page: page,
                                        pageSize: size,
                                    }
                                }, "http://h.xiami.com/collect_detail.html?id=" + collectionId + "&f=&from=&ch=")];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.collectDetail;
                            collection = parser_1.makeAliCollection(info);
                            return [2 /*return*/, collection];
                        case 2:
                            err_3 = _a.sent();
                            return [4 /*yield*/, this.xiamiWebApi.collection(collectionId)];
                        case 3: return [2 /*return*/, _a.sent()];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Search Songs
         *
         * XXX Cookies must include 'uidXM=${userId}'
         *
         * If we call this api frequently, the xiami server will blocked us,
         * so we instead to use the web api.
         */
        AliMusicApi.prototype.searchSongs = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, err_4, info, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 4]);
                            return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.searchSongs, {
                                    key: keyword.replace(/\s+/g, '+'),
                                    pagingVO: {
                                        page: page,
                                        pageSize: size,
                                    }
                                })];
                        case 1:
                            json = _a.sent();
                            return [3 /*break*/, 4];
                        case 2:
                            err_4 = _a.sent();
                            return [4 /*yield*/, this.xiamiWebApi.searchSongs(keyword, page, size)];
                        case 3: return [2 /*return*/, _a.sent()];
                        case 4:
                            info = json.data.data.songs;
                            songs = parser_1.makeAliSongs(info);
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        /**
         * Search albums
         *
         * XXX Cookies must include 'uidXM=${userId}'
         */
        AliMusicApi.prototype.searchAlbums = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, err_5, info, albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 4]);
                            return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.searchAlbums, {
                                    // isRecommendCorrection: false,
                                    // isTouFu: true,
                                    key: keyword.replace(/\s+/g, '+'),
                                    pagingVO: {
                                        page: page,
                                        pageSize: size,
                                    }
                                })];
                        case 1:
                            json = _a.sent();
                            return [3 /*break*/, 4];
                        case 2:
                            err_5 = _a.sent();
                            return [4 /*yield*/, this.xiamiWebApi.searchAlbums(keyword, page, size)];
                        case 3: return [2 /*return*/, _a.sent()];
                        case 4:
                            info = json.data.data.albums;
                            albums = parser_1.makeAliAlbums(info);
                            return [2 /*return*/, albums];
                    }
                });
            });
        };
        AliMusicApi.prototype.searchArtists = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, err_6, info, artists;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 4]);
                            return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.searchArtists, {
                                    key: keyword.replace(/\s+/g, '+'),
                                    pagingVO: {
                                        page: page,
                                        pageSize: size,
                                    }
                                })];
                        case 1:
                            json = _a.sent();
                            return [3 /*break*/, 4];
                        case 2:
                            err_6 = _a.sent();
                            return [4 /*yield*/, this.xiamiWebApi.searchArtists(keyword, page, size)];
                        case 3: return [2 /*return*/, _a.sent()];
                        case 4:
                            info = json.data.data.artists;
                            artists = parser_1.makeAliArtists(info);
                            return [2 /*return*/, artists];
                    }
                });
            });
        };
        AliMusicApi.prototype.searchCollections = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, err_7, info, collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 4]);
                            return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.searchCollections, {
                                    key: keyword.replace(/\s+/g, '+'),
                                    pagingVO: {
                                        page: page,
                                        pageSize: size,
                                    }
                                })];
                        case 1:
                            json = _a.sent();
                            return [3 /*break*/, 4];
                        case 2:
                            err_7 = _a.sent();
                            return [4 /*yield*/, this.xiamiWebApi.searchCollections(keyword, page, size)];
                        case 3: return [2 /*return*/, _a.sent()];
                        case 4:
                            info = json.data.data.collects;
                            collections = parser_1.makeAliCollections(info);
                            return [2 /*return*/, collections];
                    }
                });
            });
        };
        /**
         * radioId:
         *     1 - 猜你喜欢
         *     0 - 听见不同
         *     7 - 私人电台
         */
        AliMusicApi.prototype.radioSongs = function (radioId, size) {
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.radioSongs, {
                                extraId: 0,
                                limit: size,
                                radioType: radioId,
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.songs;
                            songs = parser_1.makeAliSongs(info);
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        /**
         * TODO, parser is need
         */
        AliMusicApi.prototype.hotTags = function () {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.hotTags, {})];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json];
                    }
                });
            });
        };
        /**
         * Get new songs
         *
         * languageId:
         *     5:  推荐
         *     10: 华语
         *     12: 欧美
         *     13: 韩国
         *     14: 日本
         */
        AliMusicApi.prototype.songList = function (languageId, page, size) {
            if (languageId === void 0) { languageId = 5; }
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.songList, {
                                language: languageId.toString(),
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                },
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.songs;
                            return [2 /*return*/, parser_1.makeAliSongs(info)];
                    }
                });
            });
        };
        AliMusicApi.prototype.albumListOptions = function () {
            return __awaiter(this, void 0, void 0, function () {
                var json, orders, options;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.newAlbums, {
                                bizCode: 'album',
                                filter: '{}',
                                pagingVO: {
                                    page: 1,
                                    pageSize: 1,
                                },
                            })];
                        case 1:
                            json = _a.sent();
                            orders = {
                                name: '排序',
                                type: 'order',
                                items: [
                                    { id: '0', name: '推荐' },
                                    { id: '1', name: '最新' },
                                    { id: '2', name: '最热' },
                                ],
                            };
                            options = json.data.data.label.map(function (option) {
                                option.items.forEach(function (item) { return item.id = item.id.toString(); });
                                return option;
                            });
                            return [2 /*return*/, __spreadArray(__spreadArray([], __read(options)), [orders])];
                    }
                });
            });
        };
        /**
         * Select Albums
         *
         * order:
         *     0 or undefined: 推荐
         *     1: 最新
         *     2: 最热
         *
         * language: 语种
         * tag: 曲风
         * century: 年代
         * category: 分类
         */
        AliMusicApi.prototype.albumList = function (order, languageId, tagId, centuryId, categoryId, page, size) {
            if (order === void 0) { order = 0; }
            if (languageId === void 0) { languageId = 0; }
            if (tagId === void 0) { tagId = 0; }
            if (centuryId === void 0) { centuryId = 0; }
            if (categoryId === void 0) { categoryId = 0; }
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.albumList, {
                                bizCode: 'album',
                                filter: JSON.stringify({
                                    order: order || undefined,
                                    language: languageId || undefined,
                                    tag: tagId || undefined,
                                    century: centuryId || undefined,
                                    category: categoryId || undefined,
                                }),
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                },
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.albums;
                            return [2 /*return*/, parser_1.makeAliAlbums(info)];
                    }
                });
            });
        };
        AliMusicApi.prototype.collectionListOrders = function () {
            return [
                { id: 'system', name: '推荐' },
                { id: 'recommend', name: '精选' },
                { id: 'hot', name: '最热' },
                { id: 'new', name: '最新' },
            ];
        };
        /**
         * Collection List Options
         */
        AliMusicApi.prototype.collectionListOptions = function () {
            return __awaiter(this, void 0, void 0, function () {
                var json, options, option;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.recommendTags, { from: 'web' })];
                        case 1:
                            json = _a.sent();
                            options = json.data.data.recommendTags
                                .map(function (tag) { return ({
                                type: null,
                                name: tag['title'],
                                items: tag['items'].map(function (item) { return ({
                                    name: item['name'],
                                    id: item['name'],
                                }); }),
                            }); });
                            option = {
                                type: null,
                                name: '全部歌单',
                                items: [{
                                        name: '全部',
                                        id: null,
                                    }],
                            };
                            return [2 /*return*/, __spreadArray([option], __read(options))];
                    }
                });
            });
        };
        /**
         * Get collections by type
         *
         * types:
         *     'system' - 推荐
         *     'recommend' - 精选
         *     'hot' - 最热
         *     'new' - 最新
         */
        AliMusicApi.prototype.collectionList = function (keyword, type, page, size) {
            if (type === void 0) { type = 'new'; }
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.collections, {
                                custom: 0,
                                dataType: type,
                                info: 1,
                                key: keyword ? keyword.replace(/\s+/g, '+') : undefined,
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                }
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.collects;
                            collections = parser_1.makeAliCollections(info);
                            return [2 /*return*/, collections];
                    }
                });
            });
        };
        AliMusicApi.prototype.artistListOptions = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, common_1.ARTIST_LIST_OPTIONS];
                });
            });
        };
        AliMusicApi.prototype.artistList = function (language, tag, gender, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, artists, pinyins, hotArtists, hotPinyins;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.artistList, {
                                language: Number.parseInt(language),
                                tag: Number.parseInt(tag),
                                gender: Number.parseInt(gender),
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.artists;
                            artists = parser_1.makeAliArtists(info);
                            pinyins = info.map(function (i) { return i.pinyin; });
                            info = json.data.data.hotArtists;
                            hotArtists = parser_1.makeAliArtists(info);
                            hotPinyins = info.map(function (i) { return i.pinyin; });
                            return [2 /*return*/, [__spreadArray(__spreadArray(__spreadArray([], __read(hotArtists)), [null]), __read(artists)), __spreadArray(__spreadArray(__spreadArray([], __read(hotPinyins)), [null]), __read(pinyins))]];
                    }
                });
            });
        };
        AliMusicApi.prototype.newSongs = function (page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.songList(5, page, size)];
                });
            });
        };
        /**
         * Get new albums
         *
         * The minimum return albums size are 5
         */
        AliMusicApi.prototype.newAlbums = function (page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.albumList(0, 0, 0, 0, 0, page, size)];
                });
            });
        };
        AliMusicApi.prototype.newCollections = function (page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.collectionList(undefined, 'new', page, size)];
                });
            });
        };
        AliMusicApi.prototype.login = function (accountName, password) {
            return __awaiter(this, void 0, void 0, function () {
                var tmpApi, json, message, info, account, userProfile;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            tmpApi = new AliMusicApi();
                            return [4 /*yield*/, tmpApi.request(AliMusicApi.NODE_MAP.login, {
                                    account: accountName,
                                    password: crypto_1.md5(password),
                                }, "http://h.xiami.com/")];
                        case 1:
                            json = _a.sent();
                            /**
                             * accessToken: string
                             * expires: number
                             * nickName: string
                             * refreshExpires: number
                             * refreshToken: string
                             * schemeUrl: string
                             * userId: number
                             */
                            if (json.ret[0].search('SUCCESS') == -1) {
                                message = json.ret[0].split('::')[1];
                                throw new Error(message);
                            }
                            info = json.data.data;
                            account = parser_1.makeAccount(info);
                            return [4 /*yield*/, this.userProfile(account.user.userOriginalId)];
                        case 2:
                            userProfile = _a.sent();
                            account.user.userAvatarUrl = userProfile.userAvatarUrl;
                            return [2 /*return*/, account];
                    }
                });
            });
        };
        /**
         * WARN !! This is only way of setting an account to an AliMusicApi instance
         */
        AliMusicApi.prototype.setAccount = function (account) {
            assert_1.ok(account.user.origin == origin_1.ORIGIN.xiami, "[AliMusicApi.setAccount]: this account is not a xiami account");
            this.setAccessToken(account.accessToken, account.refreshToken);
            this.setUserId(account.user.userOriginalId);
            this.account = account;
        };
        AliMusicApi.prototype.getAccount = function () {
            return this.account;
        };
        AliMusicApi.prototype.setAccessToken = function (accessToken, refreshToken) {
            this.accessToken = accessToken;
            this.refreshToken = refreshToken;
        };
        /**
         * here, the userId is IUserProfile.userOriginalId, as followings
         */
        AliMusicApi.prototype.setUserId = function (userId) {
            this.userId = userId;
        };
        AliMusicApi.prototype.logined = function () {
            return !!this.account && !!this.account.accessToken;
        };
        /**
         * here, the userId is IUserProfile.userOriginalId
         */
        AliMusicApi.prototype.userProfile = function (userId) {
            return __awaiter(this, void 0, void 0, function () {
                var req, _a, json, userProfileMore, userProfile, _up;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            req = this.request(AliMusicApi.NODE_MAP.userProfile, { userId: parseInt(userId) });
                            return [4 /*yield*/, Promise.all([req, this.userProfileMore(userId)])];
                        case 1:
                            _a = __read.apply(void 0, [_b.sent(), 2]), json = _a[0], userProfileMore = _a[1];
                            userProfile = parser_1.makeUserProfile(json.data.data);
                            _up = __assign(__assign({}, userProfile), userProfileMore);
                            _up.userId = userProfile.userId;
                            return [2 /*return*/, _up];
                    }
                });
            });
        };
        /**
         * here, the userId is IUserProfile.userOriginalId
         */
        AliMusicApi.prototype.userProfileMore = function (userId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userProfileMore, { userId: parseInt(userId) })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeUserProfileMore(json.data.data)];
                    }
                });
            });
        };
        /**
         * here, the userId is IUserProfile.userOriginalId
         */
        AliMusicApi.prototype.userFavorites = function (userId, type, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userFavorites, {
                                full: false,
                                type: type,
                                userId: parseInt(userId),
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                },
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json];
                    }
                });
            });
        };
        /**
         * here, the userId is IUserProfile.userOriginalId
         */
        AliMusicApi.prototype.userFavoriteSongs = function (userId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.userFavorites(userId, 1, page, size)];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.songs;
                            songs = parser_1.makeAliSongs(info);
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        /**
         * here, the userId is IUserProfile.userOriginalId
         */
        AliMusicApi.prototype.userFavoriteAlbums = function (userId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.userFavorites(userId, 2, page, size)];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.albums;
                            albums = parser_1.makeAliAlbums(info);
                            return [2 /*return*/, albums];
                    }
                });
            });
        };
        /**
         * here, the userId is IUserProfile.userOriginalId
         */
        AliMusicApi.prototype.userFavoriteArtists = function (userId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, artists;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.userFavorites(userId, 3, page, size)];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.artists;
                            artists = parser_1.makeAliArtists(info);
                            return [2 /*return*/, artists];
                    }
                });
            });
        };
        /**
         * here, the userId is IUserProfile.userOriginalId
         */
        AliMusicApi.prototype.userFavoriteCollections = function (userId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.userFavorites(userId, 5, page, size)];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.collects;
                            collections = parser_1.makeAliCollections(info);
                            return [2 /*return*/, collections];
                    }
                });
            });
        };
        /**
         * here, the userId is IUserProfile.userOriginalId
         */
        AliMusicApi.prototype.userCreatedCollections = function (userId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, collections, userName, userProfile;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userCreatedCollections, {
                                userId: userId,
                                hideSystemSonglistCover: 1,
                                includeSystemCreate: 1,
                                sort: 0,
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                },
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.collects;
                            collections = parser_1.makeAliCollections(info);
                            userName = collections.length ? collections[0].userName : null;
                            if (!!userName) return [3 /*break*/, 3];
                            return [4 /*yield*/, this.userProfile(userId)];
                        case 2:
                            userProfile = _a.sent();
                            userName = userProfile.userName;
                            _a.label = 3;
                        case 3:
                            collections.forEach(function (collection) { return collection.userName = userName; });
                            return [2 /*return*/, collections];
                    }
                });
            });
        };
        /**
         * here, the userId is IUserProfile.userOriginalId
         */
        AliMusicApi.prototype.userRecentPlay = function (userId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userRecentPlay, 
                            // {
                            // objectType: 'song',
                            // },
                            {
                                userId: userId,
                                fullView: 1,
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                },
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.songs;
                            songs = parser_1.makeAliSongs(info);
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        /**
         * here, the userId is IUserProfile.userOriginalId
         */
        AliMusicApi.prototype.userFollowings = function (userId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userFollowings, {
                                userId: userId,
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                },
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.friendVOList;
                            return [2 /*return*/, parser_1.makeUserProfiles(info)];
                    }
                });
            });
        };
        /**
         * here, the userId is IUserProfile.userOriginalId
         */
        AliMusicApi.prototype.userFollowers = function (userId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userFollowers, {
                                userId: userId,
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                },
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.friendVOList;
                            return [2 /*return*/, parser_1.makeUserProfiles(info)];
                    }
                });
            });
        };
        /**
         * songId is ISong.songOriginalId, as following
         */
        AliMusicApi.prototype.userLikeSong = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userLikeSong, {
                                songId: songId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.status];
                    }
                });
            });
        };
        AliMusicApi.prototype.userLikeAlbum = function (albumId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userLikeAlbum, {
                                albumId: albumId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.status];
                    }
                });
            });
        };
        AliMusicApi.prototype.userLikeArtist = function (artistId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userLikeArtist, {
                                artistId: artistId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.status];
                    }
                });
            });
        };
        AliMusicApi.prototype.userLikeCollection = function (collectionId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userLikeCollection, {
                                collectId: collectionId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.status];
                    }
                });
            });
        };
        AliMusicApi.prototype.userLikeUserProfile = function (userId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userLikeUserProfile, {
                                toUserId: userId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.toUserId == userId];
                    }
                });
            });
        };
        AliMusicApi.prototype.userDislikeSong = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userDislikeSong, {
                                songId: songId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.status];
                    }
                });
            });
        };
        AliMusicApi.prototype.userDislikeAlbum = function (albumId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userDislikeAlbum, {
                                albumId: albumId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.status];
                    }
                });
            });
        };
        AliMusicApi.prototype.userDislikeArtist = function (artistId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userDislikeArtist, {
                                artistId: artistId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.status];
                    }
                });
            });
        };
        AliMusicApi.prototype.userDislikeCollection = function (collectionId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userDislikeCollection, {
                                collectId: collectionId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.status];
                    }
                });
            });
        };
        AliMusicApi.prototype.userDislikeUserProfile = function (userId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.userDislikeUserProfile, {
                                toUserId: userId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.status];
                    }
                });
            });
        };
        AliMusicApi.prototype.recommendSongs = function (page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.recommendSongs, {
                            // no params needed
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data.data.songs;
                            songs = parser_1.makeAliSongs(info);
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        /**
         * Recommend collections related through user's favorite collections
         */
        AliMusicApi.prototype.recommendCollections = function (page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.recommendCollections, {
                                recommendType: 'favorite',
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeAliCollections(json.data.data.list)];
                    }
                });
            });
        };
        /**
         * Record played song
         */
        AliMusicApi.prototype.playLog = function (songId, seek) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(AliMusicApi.NODE_MAP.playLog, {
                                collectId: 0,
                                latitude: 0,
                                longitude: 0,
                                songId: parseInt(songId),
                                startPoint: seek,
                                time: Date.now(),
                                type: 8,
                                userId: 0,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.data.status];
                    }
                });
            });
        };
        AliMusicApi.prototype.resizeImageUrl = function (url, size) {
            return size_1.resizeImageUrl(url, size, function (url, size) { return url + "?x-oss-process=image/resize,m_fill,w_" + size + ",h_" + size + "/format,webp"; });
        };
        AliMusicApi.prototype.fromURL = function (input) {
            return __awaiter(this, void 0, void 0, function () {
                var chunks, items, chunks_1, chunks_1_1, chunk, m, url, type, matchList, matchList_1, matchList_1_1, _a, re, tp, originId, cn, item, _b, e_3_1;
                var e_3, _c, e_4, _d;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            chunks = input.split(' ');
                            items = [];
                            _e.label = 1;
                        case 1:
                            _e.trys.push([1, 19, 20, 21]);
                            chunks_1 = __values(chunks), chunks_1_1 = chunks_1.next();
                            _e.label = 2;
                        case 2:
                            if (!!chunks_1_1.done) return [3 /*break*/, 18];
                            chunk = chunks_1_1.value;
                            m = void 0;
                            url = void 0;
                            type = void 0;
                            matchList = [
                                // song
                                [/song\/(\w+)/, 'song'],
                                // artist
                                [/artist\/(\w+)/, 'artist'],
                                // album
                                [/album\/(\w+)/, 'album'],
                                // collection
                                [/collect\/(\w+)/, 'collect'],
                                // user
                                [/user\/(\w+)/, 'user'],
                            ];
                            try {
                                for (matchList_1 = (e_4 = void 0, __values(matchList)), matchList_1_1 = matchList_1.next(); !matchList_1_1.done; matchList_1_1 = matchList_1.next()) {
                                    _a = __read(matchList_1_1.value, 2), re = _a[0], tp = _a[1];
                                    m = re.exec(chunk);
                                    if (m) {
                                        type = tp;
                                        url = webApi_1.XiamiApi.BASICURL + type + '/' + m[1];
                                        break;
                                    }
                                }
                            }
                            catch (e_4_1) { e_4 = { error: e_4_1 }; }
                            finally {
                                try {
                                    if (matchList_1_1 && !matchList_1_1.done && (_d = matchList_1.return)) _d.call(matchList_1);
                                }
                                finally { if (e_4) throw e_4.error; }
                            }
                            if (!url) return [3 /*break*/, 17];
                            originId = void 0;
                            if (!(type == 'user' || type == 'collect')) return [3 /*break*/, 3];
                            originId = m[1];
                            return [3 /*break*/, 5];
                        case 3: return [4 /*yield*/, this.xiamiWebApi.request('GET', url)];
                        case 4:
                            cn = _e.sent();
                            m = (new RegExp("xiami\\.com/" + type + "/(\\d+)")).exec(cn);
                            if (!m)
                                return [3 /*break*/, 18];
                            originId = m[1];
                            _e.label = 5;
                        case 5:
                            item = void 0;
                            _b = type;
                            switch (_b) {
                                case 'song': return [3 /*break*/, 6];
                                case 'artist': return [3 /*break*/, 8];
                                case 'album': return [3 /*break*/, 10];
                                case 'collect': return [3 /*break*/, 12];
                                case 'user': return [3 /*break*/, 14];
                            }
                            return [3 /*break*/, 16];
                        case 6: return [4 /*yield*/, this.song(originId)];
                        case 7:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 17];
                        case 8: return [4 /*yield*/, this.artist(originId)];
                        case 9:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 17];
                        case 10: return [4 /*yield*/, this.album(originId)];
                        case 11:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 17];
                        case 12: return [4 /*yield*/, this.collection(originId)];
                        case 13:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 17];
                        case 14: return [4 /*yield*/, this.userProfile(originId)];
                        case 15:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 17];
                        case 16: return [3 /*break*/, 17];
                        case 17:
                            chunks_1_1 = chunks_1.next();
                            return [3 /*break*/, 2];
                        case 18: return [3 /*break*/, 21];
                        case 19:
                            e_3_1 = _e.sent();
                            e_3 = { error: e_3_1 };
                            return [3 /*break*/, 21];
                        case 20:
                            try {
                                if (chunks_1_1 && !chunks_1_1.done && (_c = chunks_1.return)) _c.call(chunks_1);
                            }
                            finally { if (e_3) throw e_3.error; }
                            return [7 /*endfinally*/];
                        case 21: return [2 /*return*/, items];
                    }
                });
            });
        };
        AliMusicApi.HEADERS = {
            'Pragma': 'no-cache',
            'Accept-Encoding': 'gzip, deflate',
            'Accept-Language': 'zh-CN,zh;q=0.9,en;q=0.8,zh-TW;q=0.7',
            'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36',
            'Accept': '*/*',
            // Referer is needed
            // 'Referer': 'http://h.xiami.com/collect_detail.html?id=422425970&f=&from=&ch=',
            'Connection': 'keep-alive',
            'Cache-Control': 'no-cache',
        };
        // static readonly BASICURL = 'https://acs.m.xiami.com/h5/';
        AliMusicApi.BASICURL = 'http://h5api.m.xiami.com/h5/';
        AliMusicApi.PLATFORM_ID = 'h5';
        AliMusicApi.VERSION = '1.0';
        AliMusicApi.APPKEY = '23649156';
        AliMusicApi.JSV = '2.4.0';
        AliMusicApi.NODE_MAP = {
            // No use this song node, it does not give audio url
            song: 'mtop.alimusic.music.songservice.getsongdetail',
            songs: 'mtop.alimusic.music.songservice.getsongs',
            similarSongs: 'mtop.alimusic.recommend.songservice.getroamingsongs',
            album: 'mtop.alimusic.music.albumservice.getalbumdetail',
            albums: 'mtop.alimusic.music.albumservice.getalbums',
            artist: 'mtop.alimusic.music.artistservice.getartistdetail',
            artistAlbums: 'mtop.alimusic.music.albumservice.getartistalbums',
            artistSongs: 'mtop.alimusic.music.songservice.getartistsongs',
            similarArtists: 'mtop.alimusic.recommend.artistservice.getsimilarartists',
            collection: 'mtop.alimusic.music.list.collectservice.getcollectdetail',
            collections: 'mtop.alimusic.music.list.collectservice.getcollects',
            // genre: 'mtop.alimusic.music.genreservice.getgenredetail',  // no privilege
            recommendTags: 'mtop.alimusic.music.list.collectservice.getrecommendtags',
            hotTags: 'mtop.alimusic.music.list.collectservice.gethottags',
            // searchSongs: XXX Cookies must include 'uidXM=${userId}'
            searchSongs: 'mtop.alimusic.search.searchservice.searchsongs',
            // searchAlbums: XXX Cookies must include 'uidXM=${userId}'
            searchAlbums: 'mtop.alimusic.search.searchservice.searchalbums',
            searchArtists: 'mtop.alimusic.search.searchservice.searchartists',
            searchCollections: 'mtop.alimusic.search.searchservice.searchcollects',
            // AI recommends songs
            radioSongs: 'mtop.alimusic.music.radio.getradiosongs',
            newSongs: '',
            newAlbums: 'mtop.alimusic.recommend.albumservice.getmusiclist',
            newCollections: '',
            songList: 'mtop.alimusic.recommend.songservice.gethotsongs',
            albumList: 'mtop.alimusic.recommend.albumservice.getmusiclist',
            artistList: 'mtop.alimusic.music.artistservice.gethotartists',
            login: 'mtop.alimusic.xuser.facade.xiamiuserservice.login',
            userProfile: 'mtop.alimusic.xuser.facade.xiamiuserservice.getuserinfobyuserid',
            userProfileMore: 'mtop.alimusic.xuser.facade.homepageservice.getuserhomeinfo',
            userFavorites: 'mtop.alimusic.fav.favoriteservice.getfavorites',
            userCreatedCollections: 'mtop.alimusic.music.list.collectservice.getcollectbyuser',
            // userRecentPlay: 'mtop.alimusic.playlog.facade.playlogservice.getrecentplaylog',
            userRecentPlay: 'mtop.alimusic.playlog.facade.playlogservice.getrecentsongplaylog',
            userFollowings: 'mtop.alimusic.social.friendservice.getfollows',
            // no privilege for some users
            userFollowers: 'mtop.alimusic.social.friendservice.getfans',
            userLikeSong: 'mtop.alimusic.fav.songfavoriteservice.favoritesong',
            userLikeAlbum: 'mtop.alimusic.fav.albumfavoriteservice.favoritealbum',
            userLikeArtist: 'mtop.alimusic.fav.artistfavoriteservice.favoriteartist',
            userLikeCollection: 'mtop.alimusic.fav.collectfavoriteservice.favoritecollect',
            userLikeUserProfile: 'mtop.alimusic.social.friendservice.addfollow',
            userDislikeSong: 'mtop.alimusic.fav.songfavoriteservice.unfavoritesong',
            userDislikeAlbum: 'mtop.alimusic.fav.albumfavoriteservice.unfavoritealbum',
            userDislikeArtist: 'mtop.alimusic.fav.artistfavoriteservice.unfavoriteartist',
            userDislikeCollection: 'mtop.alimusic.fav.collectfavoriteservice.unfavoritecollect',
            userDislikeUserProfile: 'mtop.alimusic.social.friendservice.unfollow',
            // recommend songs for user logined
            recommendSongs: 'mtop.alimusic.recommend.songservice.getdailysongs',
            recommendAlbums: 'mtop.alimusic.music.recommendservice.getrecommendalbums',
            // Recommend collections by user's favorite collections
            recommendCollections: 'mtop.alimusic.music.recommendservice.getrecommendcollects',
            playLog: 'mtop.alimusic.playlog.facade.playlogservice.addplaylog',
        };
        return AliMusicApi;
    }());
    exports.AliMusicApi = AliMusicApi;
});
