var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
define(["require", "exports", "assert", "process", "mocha", "chord/music/xiami/api"], function (require, exports, assert, process, mocha_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var aliApi = new api_1.AliMusicApi();
    var IN_CI = process.env.IN_CI;
    mocha_1.suite('music/xiami/AliMusicApi', function () {
        /**
         * Net requests have some probability to be fail,
         * so we test these requests at local, missing at CI
        */
        if (IN_CI)
            return;
        mocha_1.test('audios', function () {
            return __awaiter(this, void 0, void 0, function () {
                var audios;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.audios('1')];
                        case 1:
                            audios = _a.sent();
                            assert.equal(audios.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('song', function () {
            return __awaiter(this, void 0, void 0, function () {
                var song, songOriginalId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.song('1')];
                        case 1:
                            song = _a.sent();
                            songOriginalId = song.songOriginalId;
                            assert.equal(songOriginalId, '1');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('songs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songs, size, songOriginalId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.songs(['1', '2'])];
                        case 1:
                            songs = _a.sent();
                            size = songs.length;
                            assert.equal(size, 2);
                            songOriginalId = songs[0].songOriginalId;
                            assert.equal(songOriginalId, '1');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('lyric', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, lyric;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '375918';
                            return [4 /*yield*/, aliApi.lyric(id)];
                        case 1:
                            lyric = _a.sent();
                            assert.equal(lyric.songId, "xiami|song|" + id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('similarSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songs, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.similarSongs('1')];
                        case 1:
                            songs = _a.sent();
                            size = songs.length;
                            assert.equal(size > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('album', function () {
            return __awaiter(this, void 0, void 0, function () {
                var album, albumId, songsSize, audios;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.album('1')];
                        case 1:
                            album = _a.sent();
                            albumId = album.albumId;
                            assert.equal(albumId, 'xiami|album|1');
                            songsSize = album.songs.length;
                            assert.equal(songsSize, 11);
                            audios = album.songs[0].audios;
                            assert.equal(audios.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('albums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var albums, size, albumId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.albums(['1', '2'])];
                        case 1:
                            albums = _a.sent();
                            size = albums.length;
                            assert.equal(size, 2);
                            albumId = albums[0].albumId;
                            assert.equal(albumId, 'xiami|album|1');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artist', function () {
            return __awaiter(this, void 0, void 0, function () {
                var artist, artistId, name;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.artist('1')];
                        case 1:
                            artist = _a.sent();
                            artistId = artist.artistId;
                            assert.equal(artistId, 'xiami|artist|1');
                            name = artist.artistName;
                            assert.equal(name, 'Alex');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artistSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songs, size, name;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.artistSongs('1', 1, 1)];
                        case 1:
                            songs = _a.sent();
                            size = songs.length;
                            assert.equal(size, 1);
                            name = songs[0].artistName;
                            assert.equal(name, 'Alex');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artistSongCount', function () {
            return __awaiter(this, void 0, void 0, function () {
                var size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.artistSongCount('1')];
                        case 1:
                            size = _a.sent();
                            assert.equal(size > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artistAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var albums, size, name;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.artistAlbums('1', 1, 1)];
                        case 1:
                            albums = _a.sent();
                            size = albums.length;
                            assert.equal(size, 1);
                            name = albums[0].artistName;
                            assert.equal(name, 'Alex');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artistAlbumCount', function () {
            return __awaiter(this, void 0, void 0, function () {
                var size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.artistAlbumCount('1')];
                        case 1:
                            size = _a.sent();
                            assert.equal(size > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('similarArtists', function () {
            return __awaiter(this, void 0, void 0, function () {
                var artists, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.similarArtists('1')];
                        case 1:
                            artists = _a.sent();
                            size = artists.length;
                            assert.equal(size > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('similarArtistCount', function () {
            return __awaiter(this, void 0, void 0, function () {
                var size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.similarArtistCount('1')];
                        case 1:
                            size = _a.sent();
                            assert.equal(size > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('collection', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collection, songsSize, collectionId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.collection('398783788')];
                        case 1:
                            collection = _a.sent();
                            songsSize = collection.songs.length;
                            assert.equal(songsSize > 0, true);
                            collectionId = collection.collectionId;
                            assert.equal(collectionId, 'xiami|collection|398783788');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songs, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.searchSongs('linkin', 2, 1)];
                        case 1:
                            songs = _a.sent();
                            size = songs.length;
                            assert.equal(size, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var albums, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.searchAlbums('linkin', 1, 1)];
                        case 1:
                            albums = _a.sent();
                            size = albums.length;
                            assert.equal(size, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchArtists', function () {
            return __awaiter(this, void 0, void 0, function () {
                var artists, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.searchArtists('linkin', 1, 1)];
                        case 1:
                            artists = _a.sent();
                            size = artists.length;
                            assert.equal(size, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.searchCollections('linkin', 1, 1)];
                        case 1:
                            collections = _a.sent();
                            size = collections.length;
                            assert.equal(size, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('songList', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songs, size;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.songList(5, 1, 1)];
                        case 1:
                            songs = _a.sent();
                            size = songs.length;
                            assert.equal(size, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('albumListOptions', function () {
            return __awaiter(this, void 0, void 0, function () {
                var options;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.albumListOptions()];
                        case 1:
                            options = _a.sent();
                            assert.equal(options.slice(-1)[0].type, 'order');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('albumList', function () {
            return __awaiter(this, void 0, void 0, function () {
                var albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.albumList(0, 0, 0, 0, 0, 1, 1)];
                        case 1:
                            albums = _a.sent();
                            assert.equal(albums.length > 1, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('collectionListOptions', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.collectionListOptions()];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length > 1, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('collectionList', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.collectionList('古典', 'new', 1, 1)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artistList', function () {
            return __awaiter(this, void 0, void 0, function () {
                var artists;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.artistList('0', '0', '0')];
                        case 1:
                            artists = _a.sent();
                            assert.equal(artists.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('newSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.newSongs(1, 1)];
                        case 1:
                            songs = _a.sent();
                            assert.equal(songs.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('newAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.newAlbums(1, 1)];
                        case 1:
                            albums = _a.sent();
                            assert.equal(albums.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('newCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.newCollections(1, 1)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('logined', function () {
            var ok = aliApi.logined();
            assert.equal(ok, false);
        });
        mocha_1.test('userProfile', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, userProfile;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '8539366';
                            return [4 /*yield*/, aliApi.userProfile(id)];
                        case 1:
                            userProfile = _a.sent();
                            assert.equal(userProfile.userOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFavoriteSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '8539366';
                            return [4 /*yield*/, aliApi.userFavoriteSongs(id, 1, 1)];
                        case 1:
                            songs = _a.sent();
                            assert.equal(songs.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFavoriteArtists', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, artists;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '8539366';
                            return [4 /*yield*/, aliApi.userFavoriteArtists(id, 1, 1)];
                        case 1:
                            artists = _a.sent();
                            assert.equal(artists.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFavoriteCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '8539366';
                            return [4 /*yield*/, aliApi.userFavoriteCollections(id, 1, 1)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userCreatedCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '8539366';
                            return [4 /*yield*/, aliApi.userCreatedCollections(id, 1, 1)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userRecentPlay', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '8539366';
                            return [4 /*yield*/, aliApi.userCreatedCollections(id, 1, 1)];
                        case 1:
                            songs = _a.sent();
                            assert.equal(songs.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFollowers', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, followers;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '8539366';
                            return [4 /*yield*/, aliApi.userFollowers(id, 1, 1)];
                        case 1:
                            followers = _a.sent();
                            assert.equal(followers.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        // FAIL_SYS_UNAUTHORIZED_ENTRANCE::API访问入口未授权
        // test('userFollowings', async function () {
        //     let id = '8539366';
        //     let followings = await aliApi.userFollowings(id, 1, 1);
        //     assert.equal(followings.length, 1);
        // });
        mocha_1.test('recommendSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.recommendSongs(1, 1)];
                        case 1:
                            songs = _a.sent();
                            assert.equal(songs.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('recommendCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, aliApi.recommendCollections(1, 1)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('fromURL', function () {
            return __awaiter(this, void 0, void 0, function () {
                var data, data_1, data_1_1, _a, url, key, id, items, e_1_1;
                var e_1, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            data = [
                                ['https://www.xiami.com/song/xOeiBHc63b1', 'songOriginalId', '1810858337'],
                                ['https://www.xiami.com/artist/nmS0Gm85a40', 'artistOriginalId', '2100015120'],
                                ['https://www.xiami.com/album/yhVGfOd4398', 'albumOriginalId', '2104368824'],
                                ['https://www.xiami.com/collect/21816274', 'collectionOriginalId', '21816274'],
                                ['https://www.xiami.com/user/7437508', 'userOriginalId', '7437508'],
                            ];
                            _c.label = 1;
                        case 1:
                            _c.trys.push([1, 6, 7, 8]);
                            data_1 = __values(data), data_1_1 = data_1.next();
                            _c.label = 2;
                        case 2:
                            if (!!data_1_1.done) return [3 /*break*/, 5];
                            _a = __read(data_1_1.value, 3), url = _a[0], key = _a[1], id = _a[2];
                            return [4 /*yield*/, aliApi.fromURL(url)];
                        case 3:
                            items = _c.sent();
                            assert.equal(items[0][key], id);
                            _c.label = 4;
                        case 4:
                            data_1_1 = data_1.next();
                            return [3 /*break*/, 2];
                        case 5: return [3 /*break*/, 8];
                        case 6:
                            e_1_1 = _c.sent();
                            e_1 = { error: e_1_1 };
                            return [3 /*break*/, 8];
                        case 7:
                            try {
                                if (data_1_1 && !data_1_1.done && (_b = data_1.return)) _b.call(data_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                            return [7 /*endfinally*/];
                        case 8: return [2 /*return*/];
                    }
                });
            });
        });
    });
});
