var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
define(["require", "exports", "electron", "chord/base/common/time", "chord/platform/log/common/log", "chord/platform/utils/common/paths", "chord/music/common/errors", "chord/base/node/crypto", "chord/base/node/cookies", "chord/base/node/url", "chord/base/node/_request", "chord/music/xiami/parser"], function (require, exports, electron_1, time_1, log_1, paths_1, errors_1, crypto_1, cookies_1, url_1, _request_1, parser_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.XiamiApi = void 0;
    var loggerWarning = new log_1.Logger(paths_1.filenameToNodeName(__filename), log_1.LogLevel.Warning);
    var DOMAIN = 'xiami.com';
    /**
     * Xiami Web Api
     */
    var XiamiApi = /** @class */ (function () {
        function XiamiApi() {
            this.cookies = {};
        }
        XiamiApi.prototype.reset = function () {
            this.cookies = {};
            this.token = null;
        };
        XiamiApi.prototype.makeSign = function (node, params) {
            var token = this.token || '';
            var s = token + '_xmMain_' + '/' + node + '_' + params;
            return crypto_1.md5(s);
        };
        XiamiApi.prototype.getCookies = function () {
            return __awaiter(this, void 0, void 0, function () {
                var url, options, result;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this.token) {
                                return [2 /*return*/, null];
                            }
                            url = XiamiApi.BASICURL;
                            options = {
                                method: 'GET',
                                url: url,
                                headers: XiamiApi.HEADERS2,
                                gzip: true,
                                resolveWithFullResponse: true,
                            };
                            return [4 /*yield*/, _request_1.request(options)];
                        case 1:
                            result = _a.sent();
                            if (result.headers.hasOwnProperty('set-cookie')) {
                                cookies_1.makeCookies(result.headers['set-cookie']).forEach(function (cookie) {
                                    _this.cookies[cookie.key] = cookie;
                                    if (cookie.key == 'xm_sg_tk') {
                                        _this.token = cookie.value.split('_')[0];
                                    }
                                });
                            }
                            else {
                                loggerWarning.warning('[XiamiApi.getCookies] [Error]: (params, response):', options, result);
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        XiamiApi.prototype.handleVerify = function (url) {
            return __awaiter(this, void 0, void 0, function () {
                var win, _loop_1, timeout, state_1;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            win = new electron_1.remote.BrowserWindow({
                                width: 380, height: 320,
                                webPreferences: {
                                    enableRemoteModule: false,
                                    disableHtmlFullscreenWindowResize: true,
                                    contextIsolation: false
                                },
                            });
                            // win.webContents.openDevTools();
                            win.on('close', function () {
                                win = null;
                            });
                            win.loadURL(url, { httpReferrer: 'https://www.xiami.com/' });
                            // clear cache
                            win.webContents.session.clearStorageData();
                            win.show();
                            _loop_1 = function (timeout) {
                                var cookiesStr, cookies_2;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0: 
                                        // waiting to get cookies
                                        return [4 /*yield*/, time_1.sleep(1000)];
                                        case 1:
                                            // waiting to get cookies
                                            _b.sent();
                                            return [4 /*yield*/, win.webContents.executeJavaScript('Promise.resolve(document.cookie)', true)];
                                        case 2:
                                            cookiesStr = _b.sent();
                                            if (cookiesStr.includes('x5sec')) {
                                                cookies_2 = {};
                                                cookiesStr.split('; ').forEach(function (chunk) {
                                                    var index = chunk.indexOf('=');
                                                    cookies_2[chunk.slice(0, index)] = chunk.slice(index + 1);
                                                });
                                                Object.keys(cookies_2).forEach(function (key) {
                                                    var cookie = cookies_1.makeCookie(key, cookies_2[key], DOMAIN);
                                                    _this.cookies[key] = cookie;
                                                });
                                                // close window
                                                win.close();
                                                return [2 /*return*/, { value: void 0 }];
                                            }
                                            return [2 /*return*/];
                                    }
                                });
                            };
                            timeout = 0;
                            _a.label = 1;
                        case 1:
                            if (!(timeout < 12000000)) return [3 /*break*/, 4];
                            return [5 /*yield**/, _loop_1(timeout)];
                        case 2:
                            state_1 = _a.sent();
                            if (typeof state_1 === "object")
                                return [2 /*return*/, state_1.value];
                            _a.label = 3;
                        case 3:
                            timeout += 1000;
                            return [3 /*break*/, 1];
                        case 4:
                            // Handle timeout
                            win.close();
                            throw new errors_1.LoginTimeoutError('Timeout !!!');
                    }
                });
            });
        };
        XiamiApi.prototype.request = function (method, url, data) {
            return __awaiter(this, void 0, void 0, function () {
                var headers, cookieJar, cookies, key, options, result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: 
                        // init cookies
                        return [4 /*yield*/, this.getCookies()];
                        case 1:
                            // init cookies
                            _a.sent();
                            headers = __assign({}, XiamiApi.HEADERS1);
                            cookieJar = cookies_1.makeCookieJar();
                            cookies = __assign({}, this.cookies);
                            for (key in cookies) {
                                cookieJar.setCookie(cookies[key], 'http://' + DOMAIN);
                            }
                            options = {
                                method: method,
                                url: url,
                                jar: cookieJar,
                                headers: headers,
                                body: data,
                                gzip: true,
                                resolveWithFullResponse: false,
                            };
                            return [4 /*yield*/, _request_1.request(options)];
                        case 2:
                            result = _a.sent();
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        XiamiApi.prototype.request_with_sign = function (method, node, apiParams, referer, basicUrl, excludedCookies) {
            if (excludedCookies === void 0) { excludedCookies = []; }
            return __awaiter(this, void 0, void 0, function () {
                var queryStr, sign, headers, xmUA, cookieJar, cookies, key, url, options, result, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: 
                        // init cookies
                        return [4 /*yield*/, this.getCookies()];
                        case 1:
                            // init cookies
                            _a.sent();
                            queryStr = JSON.stringify(apiParams);
                            sign = this.makeSign(node, queryStr);
                            basicUrl = basicUrl || XiamiApi.BASICURL;
                            headers = !!referer ? __assign(__assign({}, XiamiApi.HEADERS1), { referer: referer }) : __assign({}, XiamiApi.HEADERS1);
                            headers['authority'] = url_1.getHost(basicUrl);
                            xmUA = undefined;
                            if (window && window.uabModule)
                                xmUA = window.uabModule.getUA();
                            headers['xm-ua'] = xmUA;
                            cookieJar = cookies_1.makeCookieJar();
                            cookies = __assign({}, this.cookies);
                            excludedCookies.forEach(function (key) { delete cookies[key]; });
                            for (key in cookies) {
                                cookieJar.setCookie(cookies[key], 'http://' + DOMAIN);
                            }
                            url = basicUrl + node + '?' + url_1.querystringify({ _q: queryStr, _s: sign });
                            options = {
                                method: method,
                                url: url,
                                jar: cookieJar,
                                headers: headers,
                                gzip: true,
                                resolveWithFullResponse: false,
                            };
                            return [4 /*yield*/, _request_1.request(options)];
                        case 2:
                            result = _a.sent();
                            json = JSON.parse(result.trim());
                            if (!(json['rgv587_flag'] == 'sm')) return [3 /*break*/, 4];
                            return [4 /*yield*/, this.handleVerify('https:' + json.url)];
                        case 3:
                            _a.sent();
                            return [2 /*return*/, this.request_with_sign(method, node, apiParams, referer, basicUrl, excludedCookies)];
                        case 4:
                            // msg: "令牌过期"
                            if (json.code == 'SG_TOKEN_EXPIRED') {
                                this.reset();
                                return [2 /*return*/, this.request_with_sign(method, node, apiParams, referer, basicUrl, excludedCookies)];
                            }
                            // TODO: Handle each errors
                            if (json.code != 'SUCCESS') {
                                loggerWarning.warning('[XiamiApi.request] [Error]: (params, response):', options, json);
                            }
                            return [2 /*return*/, json];
                    }
                });
            });
        };
        XiamiApi.prototype.request_without_sign = function (method, node, params, data, referer, basicUrl, excludedCookies) {
            if (excludedCookies === void 0) { excludedCookies = []; }
            return __awaiter(this, void 0, void 0, function () {
                var headers, xmUA, cookieJar, cookies, key, url, options, result, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: 
                        // init cookies
                        return [4 /*yield*/, this.getCookies()];
                        case 1:
                            // init cookies
                            _a.sent();
                            basicUrl = basicUrl || XiamiApi.BASICURL;
                            headers = !!referer ? __assign(__assign({}, XiamiApi.HEADERS1), { referer: referer }) : __assign({}, XiamiApi.HEADERS1);
                            headers['authority'] = url_1.getHost(basicUrl);
                            xmUA = undefined;
                            if (window && window.uabModule)
                                xmUA = window.uabModule.getUA();
                            headers['xm-ua'] = xmUA;
                            if (data)
                                headers['content-type'] = 'application/json';
                            cookieJar = cookies_1.makeCookieJar();
                            cookies = __assign({}, this.cookies);
                            excludedCookies.forEach(function (key) { delete cookies[key]; });
                            for (key in cookies) {
                                cookieJar.setCookie(cookies[key], 'http://' + DOMAIN);
                            }
                            url = basicUrl + node + (params ? '?' + url_1.querystringify(params) : '');
                            options = {
                                method: method,
                                url: url,
                                jar: cookieJar,
                                headers: headers,
                                body: data,
                                gzip: true,
                                resolveWithFullResponse: false,
                            };
                            return [4 /*yield*/, _request_1.request(options)];
                        case 2:
                            result = _a.sent();
                            json = JSON.parse(result.trim());
                            // TODO: Handle each errors
                            return [2 /*return*/, json];
                    }
                });
            });
        };
        /**
         * @param songId is the original song id
         */
        XiamiApi.prototype.audios = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, song;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request_with_sign(XiamiApi.REQUEST_METHOD_MAP.audios, XiamiApi.NODE_MAP.audios, { songIds: [songId] }, "https://m.xiami.com/song/" + songId, 'https://node.xiami.com/')];
                        case 1:
                            json = _a.sent();
                            song = parser_1.makeSong(json.result.data.songDetails[0]);
                            return [2 /*return*/, song.audios || []];
                    }
                });
            });
        };
        XiamiApi.prototype.song = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, song;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request_with_sign(XiamiApi.REQUEST_METHOD_MAP.song, XiamiApi.NODE_MAP.song, { songId: songId }, "https://www.xiami.com/song/" + songId)];
                        case 1:
                            json = _a.sent();
                            song = parser_1.makeSong(json.result.data);
                            return [2 /*return*/, song];
                    }
                });
            });
        };
        /**
         * Get an album
         *
         * @param albumId is the original id
         */
        XiamiApi.prototype.album = function (albumId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, album;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request_with_sign(XiamiApi.REQUEST_METHOD_MAP.album, XiamiApi.NODE_MAP.album, { albumId: albumId }, "https://www.xiami.com/album/" + albumId)];
                        case 1:
                            json = _a.sent();
                            album = parser_1.makeAlbum(json.result.data.albumDetail);
                            return [2 /*return*/, album];
                    }
                });
            });
        };
        /**
         * Get an collection
         *
         * @param collectionId is the original id
         */
        XiamiApi.prototype.collection = function (collectionId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 100; }
            return __awaiter(this, void 0, void 0, function () {
                var json, collection, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request_with_sign(XiamiApi.REQUEST_METHOD_MAP.collection, XiamiApi.NODE_MAP.collection, { listId: collectionId }, "https://www.xiami.com/collect/" + collectionId)];
                        case 1:
                            json = _a.sent();
                            collection = parser_1.makeCollection(json.result.data.collectDetail);
                            return [4 /*yield*/, this.collectionSongs(collectionId, page, size)];
                        case 2:
                            songs = _a.sent();
                            collection.songs = songs;
                            return [2 /*return*/, collection];
                    }
                });
            });
        };
        XiamiApi.prototype.collectionSongs = function (collectionId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 100; }
            return __awaiter(this, void 0, void 0, function () {
                var json, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request_with_sign(XiamiApi.REQUEST_METHOD_MAP.collectionSongs, XiamiApi.NODE_MAP.collectionSongs, {
                                listId: collectionId,
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                },
                            }, "https://www.xiami.com/collect/" + collectionId)];
                        case 1:
                            json = _a.sent();
                            songs = parser_1.makeSongs(json.result.data.songs);
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        /**
         * Login is needed
         */
        XiamiApi.prototype.artist = function (artistId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, artist;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request_with_sign(XiamiApi.REQUEST_METHOD_MAP.artist, XiamiApi.NODE_MAP.artist, { artistId: artistId }, "https://www.xiami.com/list/album?artistId=" + artistId)];
                        case 1:
                            json = _a.sent();
                            artist = parser_1.makeArtist(json.result.data.artistDetail);
                            return [2 /*return*/, artist];
                    }
                });
            });
        };
        /**
         * Get albums amount of an artist, the artistId must be number string
         */
        XiamiApi.prototype.artistAlbums = function (artistId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request_with_sign(XiamiApi.REQUEST_METHOD_MAP.artistAlbums, XiamiApi.NODE_MAP.artistAlbums, {
                                artistId: artistId,
                                pagingVO: {
                                    page: page,
                                    pageSize: size
                                },
                                category: 0,
                            }, "https://www.xiami.com/list/album?artistId=" + artistId)];
                        case 1:
                            json = _a.sent();
                            info = json.result.data.albums;
                            albums = parser_1.makeAlbums(info);
                            return [2 /*return*/, albums];
                    }
                });
            });
        };
        /**
         * Get songs of an artist, the artistId must be number string
         */
        XiamiApi.prototype.artistSongs = function (artistId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request_with_sign(XiamiApi.REQUEST_METHOD_MAP.artistSongs, XiamiApi.NODE_MAP.artistSongs, {
                                artistId: artistId,
                                pagingVO: {
                                    page: page,
                                    pageSize: size
                                },
                            }, "https://www.xiami.com/list/song?id=" + artistId + "&type=all")];
                        case 1:
                            json = _a.sent();
                            info = json.result.data.songs;
                            songs = parser_1.makeSongs(info);
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        XiamiApi.prototype.searchSongs = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request_with_sign(XiamiApi.REQUEST_METHOD_MAP.searchSongs, XiamiApi.NODE_MAP.searchSongs, {
                                key: keyword,
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                }
                            }, "https://www.xiami.com/")];
                        case 1:
                            json = _a.sent();
                            info = json.result.data.songs;
                            songs = parser_1.makeSongs(info);
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        XiamiApi.prototype.searchAlbums = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request_with_sign(XiamiApi.REQUEST_METHOD_MAP.searchAlbums, XiamiApi.NODE_MAP.searchAlbums, {
                                key: keyword,
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                }
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.result.data.albums;
                            albums = parser_1.makeAlbums(info);
                            return [2 /*return*/, albums];
                    }
                });
            });
        };
        XiamiApi.prototype.searchArtists = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, artists;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request_with_sign(XiamiApi.REQUEST_METHOD_MAP.searchArtists, XiamiApi.NODE_MAP.searchArtists, {
                                key: keyword.replace(/\s+/g, '+'),
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                }
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.result.data.artists;
                            artists = parser_1.makeArtists(info);
                            return [2 /*return*/, artists];
                    }
                });
            });
        };
        XiamiApi.prototype.searchCollections = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request_with_sign(XiamiApi.REQUEST_METHOD_MAP.searchCollections, XiamiApi.NODE_MAP.searchCollections, {
                                key: keyword.replace(/\s+/g, '+'),
                                pagingVO: {
                                    page: page,
                                    pageSize: size,
                                }
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.result.data.collects;
                            collections = parser_1.makeCollections(info);
                            return [2 /*return*/, collections];
                    }
                });
            });
        };
        /**
         * For json
         */
        XiamiApi.HEADERS1 = {
            'accept-encoding': 'gzip, deflate, br',
            'accept-language': 'en-US,en;q=0.9,zh-CN;q=0.8,zh-TW;q=0.7,zh;q=0.6,ja;q=0.5',
            'user-agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36',
            'accept': 'application/json, text/plain, */*',
            'referer': 'https://www.xiami.com/',
            'sec-fetch-mode': 'cors',
            'authority': 'www.xiami.com',
            'sec-fetch-site': 'same-origin',
        };
        /**
         * For web page
         */
        XiamiApi.HEADERS2 = {
            'user-agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36',
            'accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8',
            'accept-encoding': 'gzip, deflate, br',
            'accept-language': 'zh-CN,zh;q=0.9,en;q=0.8,zh-TW;q=0.7',
        };
        XiamiApi.BASICURL = 'https://www.xiami.com/';
        XiamiApi.NODE_MAP = {
            audios: 'song/getSongDetails',
            song: 'api/song/initialize',
            // album: 'api/album/getAlbumDetail',
            album: 'api/album/initialize',
            collection: 'api/collect/getCollectDetail',
            collectionSongs: 'api/collect/getCollectSongs',
            artist: 'api/artist/initialize',
            // artist: 'api/artist/getArtistDetail',
            artistAlbums: 'api/album/getArtistAlbums',
            artistSongs: 'api/album/getArtistSongs',
            searchSongs: 'api/search/searchSongs',
            searchAlbums: 'api/search/searchAlbums',
            searchArtists: 'api/search/searchArtists',
            searchCollections: 'api/search/searchCollects',
        };
        XiamiApi.REQUEST_METHOD_MAP = {
            audios: 'GET',
            song: 'GET',
            album: 'GET',
            collection: 'GET',
            collectionSongs: 'GET',
            artist: 'GET',
            artistAlbums: 'GET',
            artistSongs: 'GET',
            searchSongs: 'GET',
            searchAlbums: 'GET',
            searchArtists: 'GET',
            searchCollections: 'GET',
        };
        return XiamiApi;
    }());
    exports.XiamiApi = XiamiApi;
});
