define(["require", "exports", "debug", "chord/base/common/platform"], function (require, exports, debug, platform_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Logger = exports.LogLevel = void 0;
    var LogLevel;
    (function (LogLevel) {
        LogLevel[LogLevel["Trace"] = 0] = "Trace";
        LogLevel[LogLevel["Debug"] = 1] = "Debug";
        LogLevel[LogLevel["Info"] = 2] = "Info";
        LogLevel[LogLevel["Warning"] = 3] = "Warning";
        LogLevel[LogLevel["Error"] = 4] = "Error";
        LogLevel[LogLevel["Critical"] = 5] = "Critical";
        LogLevel[LogLevel["Off"] = 6] = "Off";
    })(LogLevel = exports.LogLevel || (exports.LogLevel = {}));
    var DEFAULT_LOG_LEVEL = LogLevel.Info;
    // time : level : massage : args
    var DEFAULT_LOG_FORMAT = platform_1.isWindows ? '%s | %s | %s | %O' : '%s 🔅 %s 🔅 %s 🔅 %O';
    var Logger = /** @class */ (function () {
        function Logger(nodeName, level, format) {
            if (level === void 0) { level = DEFAULT_LOG_LEVEL; }
            if (format === void 0) { format = DEFAULT_LOG_FORMAT; }
            this.level = level;
            this._debug = debug(nodeName);
            this.nodeName = nodeName;
            this.format = format;
        }
        Logger.prototype.getLevel = function () {
            return this.level;
        };
        Logger.prototype.setLevel = function (level) {
            this.level = level;
        };
        Logger.prototype.setFormat = function (format) {
            this.format = format;
        };
        Logger.prototype.log = function (level, massage, args) {
            if (this.getLevel() <= level) {
                debug.enable(this.nodeName);
                this._debug(this.format, new Date().toUTCString(), LogLevel[level], massage, args);
                debug.disable();
            }
        };
        Logger.prototype.trace = function (massage) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            this.log(LogLevel.Trace, massage, args);
        };
        Logger.prototype.debug = function (massage) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            this.log(LogLevel.Debug, massage, args);
        };
        Logger.prototype.info = function (massage) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            this.log(LogLevel.Info, massage, args);
        };
        Logger.prototype.warning = function (massage) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            this.log(LogLevel.Warning, massage, args);
        };
        Logger.prototype.error = function (massage) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            this.log(LogLevel.Error, massage, args);
        };
        Logger.prototype.critical = function (massage) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            this.log(LogLevel.Critical, massage, args);
        };
        Logger.prototype.off = function (massage) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
        };
        return Logger;
    }());
    exports.Logger = Logger;
});
