define(["require", "exports"], function (require, exports) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.literal_to_number = exports.literal_number = void 0;
    var OneK = 1000;
    function literal_number(num) {
        if (num === null || null === undefined) {
            return '';
        }
        if (num < OneK) {
            return num.toString();
        }
        num /= OneK;
        if (num < OneK) {
            return num.toFixed(1) + 'K';
        }
        num /= OneK;
        if (num < OneK) {
            return num.toFixed(1) + 'M';
        }
        num /= OneK;
        return num.toFixed(1) + 'G';
    }
    exports.literal_number = literal_number;
    function literal_to_number(literal) {
        if (!literal)
            return 0;
        if (typeof literal == 'number')
            return literal;
        var num = Number.parseFloat(literal);
        literal = literal.toLowerCase();
        var c = literal.slice(-1);
        if ('kmg'.includes(c)) {
            switch (c) {
                case 'k':
                    num *= OneK;
                    break;
                case 'm':
                    num *= OneK * OneK;
                    break;
                case 'm':
                    num *= OneK * OneK * OneK;
                    break;
            }
        }
        return num;
    }
    exports.literal_to_number = literal_to_number;
});
