var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "fs", "chord/base/common/objects", "chord/base/common/property", "chord/preference/api/user", "chord/preference/common/user"], function (require, exports, fs, objects_1, property_1, user_1, user_2) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.userConfiguration = exports.UserConfiguration = void 0;
    var UserConfiguration = /** @class */ (function () {
        function UserConfiguration() {
            var config;
            try {
                config = JSON.parse(fs.readFileSync(user_2.USER_CONFIGURATION_PATH).toString());
                config = __assign(__assign({}, user_1.initiateUserConfiguration()), config);
            }
            catch (e) {
                config = user_1.initiateUserConfiguration();
            }
            this.configuration = config;
        }
        UserConfiguration.prototype.getConfig = function () {
            return objects_1.deepCopy(this.configuration);
        };
        UserConfiguration.prototype.setConfig = function (path, value) {
            property_1.setDescendentProp(this.configuration, path, objects_1.deepCopy(value));
        };
        UserConfiguration.prototype.saveConfig = function (config) {
            config = config || this.configuration;
            fs.writeFileSync(user_2.USER_CONFIGURATION_PATH, JSON.stringify(config, null, 4), { encoding: 'utf-8' });
        };
        return UserConfiguration;
    }());
    exports.UserConfiguration = UserConfiguration;
    // Global user configuration
    exports.userConfiguration = new UserConfiguration();
});
