var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
define(["require", "exports", "assert", "process", "mocha", "chord/sound/common/origin", "chord/sound/himalaya/api"], function (require, exports, assert, process, mocha_1, origin_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var _origin = 'himalaya';
    var _getEpisodeId = origin_1.getEpisodeId.bind(null, _origin);
    var _getPodcastId = origin_1.getPodcastId.bind(null, _origin);
    var api = new api_1.HimalayaApi();
    var IN_CI = process.env.IN_CI;
    mocha_1.suite('music/qianqian/HimalayaApi', function () {
        /**
         * Net requests have some probability to be fail,
         * so we test these requests at local, missing at CI
        */
        if (IN_CI)
            return;
        // test('demoAudios', async function() {
        //     let audios = await api.demoAudios('68692449');
        // });
        mocha_1.test('audios', function () {
            return __awaiter(this, void 0, void 0, function () {
                var audios;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.audios('2291267')];
                        case 1:
                            audios = _a.sent();
                            assert.equal(audios.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('episode', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.episode('2291267')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.episodeOriginalId, '2291267');
                            assert.equal(item.episodeId, _getEpisodeId('2291267'));
                            assert.equal(item.podcastId, _getPodcastId('117912'));
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('podcast', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.podcast('117912')];
                        case 1:
                            item = _a.sent();
                            console.log(item);
                            assert.equal(item.podcastOriginalId, '117912');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('podcastEpisodes', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.podcastEpisodes('117912', 1)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            assert.equal(item[0].episodeId.includes(_origin), true);
                            assert.equal(item[0].podcastId, _getPodcastId('117912'));
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchEpisodes', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.searchEpisodes('盗墓笔记', 1, 1)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchPodcasts', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.searchPodcasts('盗墓笔记', 1, 1)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('fromURL', function () {
            return __awaiter(this, void 0, void 0, function () {
                var data, data_1, data_1_1, _a, url, key, id, items, e_1_1;
                var e_1, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            data = [
                                ['https://www.himalaya.com/history-podcasts/你应该详尽了解的《美国历史》【真正读懂美国史】-117912', 'podcastOriginalId', '117912'],
                                ['https://www.himalaya.com/history-podcasts/%E4%BD%A0%E5%BA%94%E8%AF%A5%E8%AF%A6%E5%B0%BD%E4%BA%86%E8%A7%A3%E7%9A%84%E3%80%8A%E7%BE%8E%E5%9B%BD%E5%8E%86%E5%8F%B2%E3%80%8B%E3%80%90%E7%9C%9F%E6%AD%A3%E8%AF%BB%E6%87%82%E7%BE%8E%E5%9B%BD%E5%8F%B2%E3%80%91-117912/6-5-1-%E5%A5%B4%E9%9A%B6%E5%88%B6%E4%B8%8E%E8%87%AA%E7%94%B1%E7%9A%84%E8%AF%AD%E8%A8%80-2291267', 'episodeOriginalId', '2291267'],
                            ];
                            _c.label = 1;
                        case 1:
                            _c.trys.push([1, 6, 7, 8]);
                            data_1 = __values(data), data_1_1 = data_1.next();
                            _c.label = 2;
                        case 2:
                            if (!!data_1_1.done) return [3 /*break*/, 5];
                            _a = __read(data_1_1.value, 3), url = _a[0], key = _a[1], id = _a[2];
                            return [4 /*yield*/, api.fromURL(url)];
                        case 3:
                            items = _c.sent();
                            assert.equal(items[0][key], id);
                            _c.label = 4;
                        case 4:
                            data_1_1 = data_1.next();
                            return [3 /*break*/, 2];
                        case 5: return [3 /*break*/, 8];
                        case 6:
                            e_1_1 = _c.sent();
                            e_1 = { error: e_1_1 };
                            return [3 /*break*/, 8];
                        case 7:
                            try {
                                if (data_1_1 && !data_1_1.done && (_b = data_1.return)) _b.call(data_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                            return [7 /*endfinally*/];
                        case 8: return [2 /*return*/];
                    }
                });
            });
        });
    });
});
