define(["require", "exports", "chord/base/node/random"], function (require, exports, random_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getMainBackground = void 0;
    var MAIN_BACKGROUND_MAP = {
        'searchView': 'linear-gradient(rgb(47, 67, 106), rgb(5, 7, 11) 85%)',
        // 'albumView': 'linear-gradient(rgb(30, 50, 100), rgb(4, 6, 12) 85%)',
        'artistView': 'linear-gradient(rgb(18, 18, 18), rgb(8, 8, 8) 85%)',
        // 'collectionView': 'linear-gradient(rgb(102, 56, 51), rgb(10, 6, 5) 85%)',
        'libraryView': 'linear-gradient(rgb(41, 50, 60), rgb(5, 7, 11) 85%)',
        'preferenceView': 'linear-gradient(rgb(86, 77, 165), rgb(5, 7, 11) 85%)',
        'userProfileView': 'linear-gradient(rgb(104, 123, 122), rgb(1, 1, 11) 85%)',
        'homeView': 'linear-gradient(rgb(55, 93, 113), rgb(5, 9, 11) 85%)',
    };
    function pickColor() {
        var r = random_1.getRandomInt(0, 160);
        var g = random_1.getRandomInt(0, 160);
        var b = random_1.getRandomInt(0, 160);
        var dr = Math.floor(r * 0.1);
        var dg = Math.floor(g * 0.1);
        var db = Math.floor(b * 0.1);
        return "linear-gradient(rgb(" + r + ", " + g + ", " + b + "), rgb(" + dr + ", " + dg + ", " + db + ") 85%)";
    }
    function getMainBackground(key) {
        return MAIN_BACKGROUND_MAP[key] || pickColor();
    }
    exports.getMainBackground = getMainBackground;
});
