var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/api/utils/statistic", "chord/music/common/size", "chord/base/common/time", "chord/workbench/parts/player/browser/action/playAlbum", "chord/workbench/parts/mainView/browser/action/showAlbum", "chord/workbench/parts/mainView/browser/action/showArtist", "chord/workbench/parts/menu/browser/action/menu", "chord/workbench/parts/common/abc/card", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/originIcons", "chord/music/core/api"], function (require, exports, React, react_redux_1, statistic_1, size_1, time_1, playAlbum_1, showAlbum_1, showArtist_1, menu_1, card_1, common_1, common_2, originIcons_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    /**
     * Album item view
     *
     * This view doesn't display album's songs
     *
     * props.album is given by parent component
     */
    var AlbumItemView = /** @class */ (function (_super) {
        __extends(AlbumItemView, _super);
        function AlbumItemView(props) {
            return _super.call(this, props) || this;
        }
        AlbumItemView.prototype.render = function () {
            var _this = this;
            var album = this.props.album;
            var cover = album.albumCoverPath || api_1.musicApi.resizeImageUrl(album.origin, album.albumCoverUrl, size_1.ESize.Large);
            var originIcon = originIcons_1.OriginIcon(album.origin, 'cover-icon xiami-icon');
            var likeAndPlayCount = statistic_1.getLikeAndPlayCount(album);
            var addons = (React.createElement("span", null,
                originIcon,
                " ",
                time_1.getDateYear(album.releaseDate),
                " \u2022 ",
                album.songCount,
                " tracks"));
            var infos = [
                { item: album.artistName, act: function () { return _this.props.handleShowArtistViewById(album.artistId); } },
                { item: likeAndPlayCount },
                { item: addons },
            ];
            return React.createElement(card_1.Card, { name: album.albumName, cover: { item: cover, act: function () { return _this.props.handleShowAlbumView(album); } }, defaultCover: common_1.AlbumIcon, menu: function (e) { return _this.props.showAlbumMenu(e, album); }, button: { item: common_2.PlayIcon, act: function () { return _this.props.handlePlayAlbum(album); } }, infos: infos, shape: 'rectangle' });
        };
        return AlbumItemView;
    }(React.Component));
    function mapDispatchToProps(dispatch) {
        return {
            handlePlayAlbum: function (album) { return playAlbum_1.handlePlayAlbum(album).then(function (act) { return dispatch(act); }); },
            handleShowAlbumView: function (album) { return showAlbum_1.handleShowAlbumView(album).then(function (act) { return dispatch(act); }); },
            showAlbumMenu: function (e, album) { return dispatch(menu_1.showAlbumMenu(e, album)); },
            handleShowArtistViewById: function (artistId) { return showArtist_1.handleShowArtistViewById(artistId).then(function (act) { return dispatch(act); }); },
        };
    }
    exports.default = react_redux_1.connect(null, mapDispatchToProps)(AlbumItemView);
});
