var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
define(["require", "exports", "react", "chord/platform/utils/common/keys"], function (require, exports, React, keys_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var PaginationView = /** @class */ (function (_super) {
        __extends(PaginationView, _super);
        function PaginationView(props) {
            var _this = _super.call(this, props) || this;
            _this.state = {
                page: props.page,
                pointer: props.page,
            };
            return _this;
        }
        PaginationView.getDerivedStateFromProps = function (nextProps, prevState) {
            if (prevState.page != nextProps.page) {
                return { page: nextProps.page, pointer: nextProps.page };
            }
            return null;
        };
        PaginationView.prototype.movePointer = function (nextPointer) {
            this.setState({ pointer: nextPointer });
        };
        PaginationView.prototype.makePageButton = function (page, key) {
            var _this = this;
            var className = page == this.props.page ? 'pagination-link is-current' : 'pagination-link';
            return (React.createElement("li", { key: key, onClick: function () { return _this.props.handleClick(page); } },
                React.createElement("span", { className: className }, page)));
        };
        PaginationView.prototype.makeEllipsis = function (nextPointer, direction, key) {
            var _this = this;
            var symb = direction == 'left' ? '⬅' : '➡';
            return (React.createElement("li", { key: key, onClick: function () { return _this.movePointer(nextPointer); } },
                React.createElement("span", { className: 'pagination-ellipsis cursor-pointer' }, symb)));
        };
        /**
         * size = 9, as following
         * 6 is the value of this.state.pointer
         *
         * 1  ... 3 4 5 6 7 8 9 ... 100
         */
        PaginationView.prototype.getPages = function () {
            var e_1, _a;
            var _this = this;
            var total = this.props.total;
            var size = this.props.size;
            if (total <= size) {
                return __spreadArray([], __read(Array(total).keys())).map(function (index) { return index + 1; })
                    .map(function (page) { return _this.makePageButton(page, keys_1.makeListKey(page, 'page')); });
            }
            var pointer = this.state.pointer;
            pointer = pointer == 1 ? 2 : (pointer == total ? total - 1 : pointer);
            var half = (size - 3) / 2;
            var list = [pointer];
            var p = 0;
            var remains = size - 3;
            while (remains) {
                p += 1;
                if (remains && pointer - p > 1) {
                    list = __spreadArray([pointer - p], __read(list));
                    remains -= 1;
                }
                if (remains && pointer + p < total) {
                    list.push(pointer + p);
                    remains -= 1;
                }
            }
            var pages = [];
            // add first page
            pages.push(this.makePageButton(1, keys_1.makeListKey(1, 'page')));
            if (list[0] != 2) {
                pages.push(this.makeEllipsis(Math.max(0, pointer - half * 2), 'left', keys_1.makeListKey(1, 'page-ellipsis')));
            }
            try {
                // add middle pages
                for (var list_1 = __values(list), list_1_1 = list_1.next(); !list_1_1.done; list_1_1 = list_1.next()) {
                    var i = list_1_1.value;
                    pages.push(this.makePageButton(i, keys_1.makeListKey(i, 'page')));
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (list_1_1 && !list_1_1.done && (_a = list_1.return)) _a.call(list_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            if (list.slice(-1)[0] != total - 1) {
                pages.push(this.makeEllipsis(Math.min(pointer + half * 2, total), 'right', keys_1.makeListKey(2, 'page-ellipsis')));
            }
            // add last page
            pages.push(this.makePageButton(total, keys_1.makeListKey(total, 'page')));
            return pages;
        };
        PaginationView.prototype.render = function () {
            var _this = this;
            var _a = this.props, page = _a.page, total = _a.total;
            if (total == 0)
                return null;
            var prePage = Math.max(0, page - 1);
            var nextPage = Math.min(total, page + 1);
            var pages = this.getPages();
            return (React.createElement("div", { className: 'pagination-container' },
                React.createElement("nav", { className: 'pagination is-rounded', role: 'navigation', "aria-label": 'pagination' },
                    React.createElement("span", { className: 'pagination-previous', onClick: function () { return _this.props.handleClick(prePage); } }, "Previous"),
                    React.createElement("span", { className: 'pagination-next', onClick: function () { return _this.props.handleClick(nextPage); } }, " Next page"),
                    React.createElement("ul", { className: 'pagination-list' }, pages))));
        };
        return PaginationView;
    }(React.Component));
    exports.default = PaginationView;
});
