var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/api/utils/statistic", "chord/music/common/size", "chord/workbench/parts/mainView/browser/action/showRadio", "chord/workbench/parts/menu/browser/action/menu", "chord/workbench/parts/common/abc/card", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/originIcons", "chord/sound/core/api"], function (require, exports, React, react_redux_1, statistic_1, size_1, showRadio_1, menu_1, card_1, common_1, originIcons_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var RadioItemView = /** @class */ (function (_super) {
        __extends(RadioItemView, _super);
        function RadioItemView(props) {
            return _super.call(this, props) || this;
        }
        RadioItemView.prototype.render = function () {
            var _this = this;
            var radio = this.props.radio;
            var cover = radio.radioCoverPath || api_1.soundApi.resizeImageUrl(radio.origin, radio.radioCoverUrl, size_1.ESize.Middle);
            var originIcon = originIcons_1.OriginIcon(radio.origin, 'cover-icon xiami-icon');
            var radioCount = statistic_1.getUserProfileCount(radio);
            var name = (React.createElement("span", null,
                originIcon,
                " ",
                radio.radioName));
            var infos = [
                { item: radioCount },
            ];
            return React.createElement(card_1.Card, { name: name, cover: { item: cover, act: function () { return _this.props.handleShowRadioView(radio); } }, defaultCover: common_1.RadioIcon, menu: function (e) { return _this.props.showRadioMenu(e, radio); }, button: null, infos: infos, shape: 'circle' });
        };
        return RadioItemView;
    }(React.Component));
    function mapDispatchToProps(dispatch) {
        return {
            handleShowRadioView: function (radio) { return showRadio_1.handleShowRadioView(radio).then(function (act) { return dispatch(act); }); },
            showRadioMenu: function (e, radio) { return dispatch(menu_1.showRadioMenu(e, radio)); },
        };
    }
    exports.default = react_redux_1.connect(null, mapDispatchToProps)(RadioItemView);
});
