var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/api/utils/statistic", "chord/music/common/size", "chord/workbench/parts/mainView/browser/action/showUserProfile", "chord/workbench/parts/player/browser/action/playUser", "chord/workbench/parts/menu/browser/action/menu", "chord/workbench/parts/common/abc/card", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/originIcons", "chord/music/core/api"], function (require, exports, React, react_redux_1, statistic_1, size_1, showUserProfile_1, playUser_1, menu_1, card_1, common_1, common_2, originIcons_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var UserProfileItemView = /** @class */ (function (_super) {
        __extends(UserProfileItemView, _super);
        function UserProfileItemView(props) {
            return _super.call(this, props) || this;
        }
        UserProfileItemView.prototype.render = function () {
            var _this = this;
            var userProfile = this.props.userProfile;
            var cover = userProfile.userAvatarPath || api_1.musicApi.resizeImageUrl(userProfile.origin, userProfile.userAvatarUrl, size_1.ESize.Large);
            var originIcon = originIcons_1.OriginIcon(userProfile.origin, 'cover-icon xiami-icon');
            var userProfileCount = statistic_1.getUserProfileCount(userProfile);
            var name = (React.createElement("span", null,
                originIcon,
                " ",
                userProfile.userName));
            var infos = [
                { item: userProfileCount },
            ];
            return React.createElement(card_1.Card, { name: name, cover: { item: cover, act: function () { return _this.props.handleShowUserProfileView(userProfile); } }, defaultCover: common_1.UserProfileIcon, menu: function (e) { return _this.props.showUserProfileMenu(e, userProfile); }, button: { item: common_2.PlayIcon, act: function () { return _this.props.handlePlayUserFavoriteSongs(userProfile); } }, infos: infos, shape: 'circle' });
        };
        return UserProfileItemView;
    }(React.Component));
    function mapDispatchToProps(dispatch) {
        return {
            handleShowUserProfileView: function (userProfile) { return showUserProfile_1.handleShowUserProfileView(userProfile).then(function (act) { return dispatch(act); }); },
            handlePlayUserFavoriteSongs: function (userProfile) { return playUser_1.handlePlayUserFavoriteSongs(userProfile).then(function (act) { return dispatch(act); }); },
            showUserProfileMenu: function (e, userProfile) { return dispatch(menu_1.showUserProfileMenu(e, userProfile)); },
        };
    }
    exports.default = react_redux_1.connect(null, mapDispatchToProps)(UserProfileItemView);
});
