define(["require", "exports", "chord/library/core/library", "chord/workbench/parts/mainView/browser/action/plugins/syncAddRemove"], function (require, exports, library_1, syncAddRemove_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.handleAddLibraryRadio = exports.handleAddLibraryPodcast = exports.handleAddLibraryEpisode = exports.handleAddLibraryUserProfile = exports.handleAddLibraryCollection = exports.handleAddLibraryAlbum = exports.handleAddLibraryArtist = exports.handleAddLibrarySong = void 0;
    function handleAddLibrarySong(song) {
        song.like = true;
        var librarySong = library_1.defaultLibrary.addSong(song);
        syncAddRemove_1.syncAdd(song);
        return {
            type: 'c:mainView:addLibrarySong',
            act: 'c:mainView:addLibrarySong',
            song: librarySong,
        };
    }
    exports.handleAddLibrarySong = handleAddLibrarySong;
    function handleAddLibraryArtist(artist) {
        artist.like = true;
        var libraryArtist = library_1.defaultLibrary.addArtist(artist);
        syncAddRemove_1.syncAdd(artist);
        return {
            type: 'c:mainView:addLibraryArtist',
            act: 'c:mainView:addLibraryArtist',
            artist: libraryArtist,
        };
    }
    exports.handleAddLibraryArtist = handleAddLibraryArtist;
    function handleAddLibraryAlbum(album) {
        album.like = true;
        var libraryAlbum = library_1.defaultLibrary.addAlbum(album);
        syncAddRemove_1.syncAdd(album);
        return {
            type: 'c:mainView:addLibraryAlbum',
            act: 'c:mainView:addLibraryAlbum',
            album: libraryAlbum,
        };
    }
    exports.handleAddLibraryAlbum = handleAddLibraryAlbum;
    function handleAddLibraryCollection(collection) {
        collection.like = true;
        var libraryCollection = library_1.defaultLibrary.addCollection(collection);
        syncAddRemove_1.syncAdd(collection);
        return {
            type: 'c:mainView:addLibraryCollection',
            act: 'c:mainView:addLibraryCollection',
            collection: libraryCollection,
        };
    }
    exports.handleAddLibraryCollection = handleAddLibraryCollection;
    function handleAddLibraryUserProfile(userProfile) {
        userProfile.like = true;
        var libraryUserProfile = library_1.defaultLibrary.addUserProfile(userProfile);
        syncAddRemove_1.syncAdd(userProfile);
        return {
            type: 'c:mainView:addLibraryUserProfile',
            act: 'c:mainView:addLibraryUserProfile',
            userProfile: libraryUserProfile,
        };
    }
    exports.handleAddLibraryUserProfile = handleAddLibraryUserProfile;
    // Sound items
    function handleAddLibraryEpisode(episode) {
        episode.like = true;
        var libraryEpisode = library_1.defaultLibrary.addEpisode(episode);
        syncAddRemove_1.syncAdd(episode);
        return {
            type: 'c:mainView:addLibraryEpisode',
            act: 'c:mainView:addLibraryEpisode',
            episode: libraryEpisode,
        };
    }
    exports.handleAddLibraryEpisode = handleAddLibraryEpisode;
    function handleAddLibraryPodcast(podcast) {
        podcast.like = true;
        var libraryPodcast = library_1.defaultLibrary.addPodcast(podcast);
        syncAddRemove_1.syncAdd(podcast);
        return {
            type: 'c:mainView:addLibraryPodcast',
            act: 'c:mainView:addLibraryPodcast',
            podcast: libraryPodcast,
        };
    }
    exports.handleAddLibraryPodcast = handleAddLibraryPodcast;
    function handleAddLibraryRadio(radio) {
        radio.like = true;
        var libraryRadio = library_1.defaultLibrary.addRadio(radio);
        syncAddRemove_1.syncAdd(radio);
        return {
            type: 'c:mainView:addLibraryRadio',
            act: 'c:mainView:addLibraryRadio',
            radio: libraryRadio,
        };
    }
    exports.handleAddLibraryRadio = handleAddLibraryRadio;
});
