var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
define(["require", "exports", "chord/music/common/origin", "chord/workbench/api/utils/offset", "chord/workbench/api/common/state/offset", "chord/music/core/api"], function (require, exports, origin_1, offset_1, offset_2, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.handleGetMoreCollections = exports.handleShowCollectionListView = exports.handleShowCollectionListOptionsView = void 0;
    function handleShowCollectionListOptionsView() {
        return __awaiter(this, void 0, void 0, function () {
            var store, state, _a, xiamiOptions, neteaseOptions, qqOptions;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        store = window.store;
                        state = store.getState();
                        if (!!state.mainView.homeView.collectionsView.optionsSet.xiami) {
                            return [2 /*return*/, {
                                    type: 'c:mainView:home:showCollectionListOptionsView',
                                    act: 'c:mainView:home:showCollectionListOptionsView',
                                    optionsSet: null,
                                }];
                        }
                        return [4 /*yield*/, Promise.all([
                                api_1.musicApi.collectionListOptions(origin_1.ORIGIN.xiami),
                                api_1.musicApi.collectionListOptions(origin_1.ORIGIN.netease),
                                api_1.musicApi.collectionListOptions(origin_1.ORIGIN.qq),
                            ])];
                    case 1:
                        _a = __read.apply(void 0, [_c.sent(), 3]), xiamiOptions = _a[0], neteaseOptions = _a[1], qqOptions = _a[2];
                        return [2 /*return*/, {
                                type: 'c:mainView:home:showCollectionListOptionsView',
                                act: 'c:mainView:home:showCollectionListOptionsView',
                                optionsSet: (_b = {},
                                    _b[origin_1.ORIGIN.xiami] = xiamiOptions,
                                    _b[origin_1.ORIGIN.netease] = neteaseOptions,
                                    _b[origin_1.ORIGIN.qq] = qqOptions,
                                    _b),
                            }];
                }
            });
        });
    }
    exports.handleShowCollectionListOptionsView = handleShowCollectionListOptionsView;
    function handleShowCollectionListView(origin, option, order, size) {
        if (size === void 0) { size = 50; }
        return __awaiter(this, void 0, void 0, function () {
            var offset, orders, collections;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        offset = offset_2.initiateOffset();
                        offset.offset = (origin == origin_1.ORIGIN.xiami) ? 1 : 0;
                        offset.limit = size;
                        orders = api_1.musicApi.collectionListOrders(origin);
                        order = order || orders[0];
                        return [4 /*yield*/, api_1.musicApi.collectionList(origin, option.id, order.id, offset.offset, offset.limit)];
                    case 1:
                        collections = _a.sent();
                        if (collections.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:home:showCollectionListView',
                                act: 'c:mainView:home:showCollectionListView',
                                origin: origin,
                                option: option,
                                orders: orders,
                                order: order,
                                collections: collections,
                                collectionsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.handleShowCollectionListView = handleShowCollectionListView;
    function handleGetMoreCollections(origin, option, order, offset, size) {
        if (size === void 0) { size = 10; }
        return __awaiter(this, void 0, void 0, function () {
            var collections, offsets, futs, collectionsList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        collections = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offsets = offset_1.makeOffsets(origin, offset, size);
                        futs = offsets.map(function (_offset) { return api_1.musicApi.collectionList(origin, option.id, order.id, _offset.offset, _offset.limit); });
                        return [4 /*yield*/, Promise.all(futs)];
                    case 1:
                        collectionsList = _a.sent();
                        collections = collections.concat.apply(collections, __spreadArray([], __read(collectionsList))).slice(0, size);
                        offset = offset_1.setCurrectOffset(origin, offset, collections.length);
                        _a.label = 2;
                    case 2:
                        if (collections.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:home:collections:getMoreCollections',
                                act: 'c:mainView:home:collections:getMoreCollections',
                                collections: collections,
                                collectionsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.handleGetMoreCollections = handleGetMoreCollections;
});
