define(["require", "exports", "chord/library/core/library"], function (require, exports, library_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getMoreRadios = exports.getMorePodcasts = exports.getMoreEpisodes = exports.getMoreUserProfiles = exports.getMoreCollections = exports.getMoreAlbums = exports.getMoreArtists = exports.getMoreSongs = void 0;
    function getMoreLibraryItems(type, keyword, offset, size) {
        var _a;
        if (size === void 0) { size = 10; }
        var cType = type[0].toUpperCase() + type.slice(1) + 's';
        var items = [];
        if (offset.more) {
            items = library_1.defaultLibrary['library' + cType](offset.offset, size, keyword);
        }
        if (items.length == 0) {
            offset.more = false;
        }
        else {
            // offset = lastId
            offset.offset = items[items.length - 1].id;
        }
        return _a = {
                type: 'c:mainView:getMoreLibrary' + cType,
                act: 'c:mainView:getMoreLibrary' + cType
            },
            _a[type + 's'] = items,
            _a[type + 'sOffset'] = offset,
            _a;
    }
    function getMoreSongs(keyword, offset, size) {
        if (size === void 0) { size = 10; }
        return getMoreLibraryItems('song', keyword, offset, size);
        // let librarySongs = [];
        // if (offset.more) {
        //     librarySongs = defaultLibrary.librarySongs(offset.offset, size, keyword);
        // }
        // if (librarySongs.length == 0) {
        //     offset.more = false;
        // } else {
        //     // offset = lastId
        //     offset.offset = librarySongs[librarySongs.length - 1].id;
        // }
        // return {
        //     type: 'c:mainView:getMoreLibrarySongs',
        //     act: 'c:mainView:getMoreLibrarySongs',
        //     songs: librarySongs,
        //     songsOffset: offset,
        // };
    }
    exports.getMoreSongs = getMoreSongs;
    function getMoreArtists(keyword, offset, size) {
        if (size === void 0) { size = 10; }
        return getMoreLibraryItems('artist', keyword, offset, size);
        // let userArtists = [];
        // if (offset.more) {
        //     userArtists = defaultLibrary.libraryArtists(offset.offset, size, keyword);
        // }
        // if (userArtists.length == 0) {
        //     offset.more = false;
        // } else {
        //     offset.offset = userArtists[userArtists.length - 1].id;
        // }
        // return {
        //     type: 'c:mainView:getMoreLibraryArtists',
        //     act: 'c:mainView:getMoreLibraryArtists',
        //     artists: userArtists,
        //     artistsOffset: offset,
        // };
    }
    exports.getMoreArtists = getMoreArtists;
    function getMoreAlbums(keyword, offset, size) {
        if (size === void 0) { size = 10; }
        return getMoreLibraryItems('album', keyword, offset, size);
        // let userAlbums = [];
        // if (offset.more) {
        //     userAlbums = defaultLibrary.libraryAlbums(offset.offset, size, keyword);
        // }
        // if (userAlbums.length == 0) {
        //     offset.more = false;
        // } else {
        //     offset.offset = userAlbums[userAlbums.length - 1].id;
        // }
        // return {
        //     type: 'c:mainView:getMoreLibraryAlbums',
        //     act: 'c:mainView:getMoreLibraryAlbums',
        //     albums: userAlbums,
        //     albumsOffset: offset,
        // };
    }
    exports.getMoreAlbums = getMoreAlbums;
    function getMoreCollections(keyword, offset, size) {
        if (size === void 0) { size = 10; }
        return getMoreLibraryItems('collection', keyword, offset, size);
        // let userCollections = [];
        // if (offset.more) {
        //     userCollections = defaultLibrary.libraryCollections(offset.offset, size, keyword);
        // }
        // if (userCollections.length == 0) {
        //     offset.more = false;
        // } else {
        //     offset.offset = userCollections[userCollections.length - 1].id;
        // }
        // return {
        //     type: 'c:mainView:getMoreLibraryCollections',
        //     act: 'c:mainView:getMoreLibraryCollections',
        //     collections: userCollections,
        //     collectionsOffset: offset,
        // };
    }
    exports.getMoreCollections = getMoreCollections;
    function getMoreUserProfiles(keyword, offset, size) {
        if (size === void 0) { size = 10; }
        return getMoreLibraryItems('userProfile', keyword, offset, size);
        // let userProfile = [];
        // if (offset.more) {
        //     userProfile = defaultLibrary.libraryUserProfiles(offset.offset, size, keyword);
        // }
        // if (userProfile.length == 0) {
        //     offset.more = false;
        // } else {
        //     offset.offset = userProfile[userProfile.length - 1].id;
        // }
        // return {
        //     type: 'c:mainView:getMoreLibraryUserProfiles',
        //     act: 'c:mainView:getMoreLibraryUserProfiles',
        //     userProfiles: userProfile,
        //     userProfilesOffset: offset,
        // };
    }
    exports.getMoreUserProfiles = getMoreUserProfiles;
    function getMoreEpisodes(keyword, offset, size) {
        if (size === void 0) { size = 10; }
        return getMoreLibraryItems('episode', keyword, offset, size);
    }
    exports.getMoreEpisodes = getMoreEpisodes;
    function getMorePodcasts(keyword, offset, size) {
        if (size === void 0) { size = 10; }
        return getMoreLibraryItems('podcast', keyword, offset, size);
    }
    exports.getMorePodcasts = getMorePodcasts;
    function getMoreRadios(keyword, offset, size) {
        if (size === void 0) { size = 10; }
        return getMoreLibraryItems('radio', keyword, offset, size);
    }
    exports.getMoreRadios = getMoreRadios;
});
