var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
define(["require", "exports", "chord/preference/utils/app", "chord/workbench/api/common/state/offset", "chord/music/core/api", "chord/sound/core/api"], function (require, exports, app_1, offset_1, api_1, api_2) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.search = exports.searchFromURL = exports.searchKeyword = void 0;
    /**
     * Search keyword
     */
    function searchKeyword(keyword) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, offset, limit, _b, songs, albums, artists, collections, episodes, podcasts, radios;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = offset_1.initiateOffset(), offset = _a.offset, limit = _a.limit;
                        return [4 /*yield*/, Promise.all([
                                api_1.musicApi.searchSongs(keyword, offset, limit),
                                api_1.musicApi.searchAlbums(keyword, offset, limit),
                                api_1.musicApi.searchArtists(keyword, offset, limit),
                                api_1.musicApi.searchCollections(keyword, offset, limit),
                                api_2.soundApi.searchEpisodes(keyword, offset, limit),
                                api_2.soundApi.searchPodcasts(keyword, offset, limit),
                                api_2.soundApi.searchRadios(keyword, offset, limit),
                            ])];
                    case 1:
                        _b = __read.apply(void 0, [_c.sent(), 7]), songs = _b[0], albums = _b[1], artists = _b[2], collections = _b[3], episodes = _b[4], podcasts = _b[5], radios = _b[6];
                        return [2 /*return*/, {
                                type: 'c:mainView:searchInput',
                                act: 'c:mainView:searchInput',
                                keyword: keyword,
                                songs: songs,
                                albums: albums,
                                artists: artists,
                                collections: collections,
                                episodes: episodes,
                                podcasts: podcasts,
                                radios: radios,
                            }];
                }
            });
        });
    }
    exports.searchKeyword = searchKeyword;
    /**
     * Search input as url
     */
    function searchFromURL(input) {
        return __awaiter(this, void 0, void 0, function () {
            var songs, albums, artists, collections, users, episodes, podcasts, radios, items, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        songs = [];
                        albums = [];
                        artists = [];
                        collections = [];
                        users = [];
                        episodes = [];
                        podcasts = [];
                        radios = [];
                        _a = [[]];
                        return [4 /*yield*/, api_1.musicApi.fromURL(input)];
                    case 1:
                        _b = [__spreadArray.apply(void 0, _a.concat([__read.apply(void 0, [(_c.sent())])]))];
                        return [4 /*yield*/, api_2.soundApi.fromURL(input)];
                    case 2:
                        items = __spreadArray.apply(void 0, _b.concat([__read.apply(void 0, [(_c.sent())])]));
                        if (items.length == 0)
                            return [2 /*return*/, null];
                        items.forEach(function (item) {
                            switch (item.type) {
                                case 'song':
                                    songs.push(item);
                                    break;
                                case 'artist':
                                    artists.push(item);
                                    break;
                                case 'album':
                                    albums.push(item);
                                    break;
                                case 'collection':
                                    collections.push(item);
                                    break;
                                case 'userProfile':
                                    users.push(item);
                                    break;
                                case 'episode':
                                    episodes.push(item);
                                    break;
                                case 'podcast':
                                    podcasts.push(item);
                                    break;
                                case 'radio':
                                    radios.push(item);
                                    break;
                                default:
                                    break;
                            }
                        });
                        return [2 /*return*/, {
                                type: 'c:mainView:searchInput',
                                act: 'c:mainView:searchInput',
                                keyword: input,
                                songs: songs,
                                albums: albums,
                                artists: artists,
                                collections: collections,
                                episodes: episodes,
                                podcasts: podcasts,
                                radios: radios,
                            }];
                }
            });
        });
    }
    exports.searchFromURL = searchFromURL;
    function saveSearchKeyword(keyword) {
        app_1.writeLocalSearchHistory(keyword);
    }
    function search(keyword) {
        return __awaiter(this, void 0, void 0, function () {
            var act;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        saveSearchKeyword(keyword);
                        if (!/[\/?=]/.exec(keyword)) return [3 /*break*/, 2];
                        return [4 /*yield*/, searchFromURL(keyword)];
                    case 1:
                        act = _a.sent();
                        _a.label = 2;
                    case 2:
                        if (act)
                            return [2 /*return*/, act];
                        return [2 /*return*/, searchKeyword(keyword)];
                }
            });
        });
    }
    exports.search = search;
});
