var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/api/utils/statistic", "chord/music/common/size", "chord/base/common/time", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/songItem", "chord/workbench/parts/player/browser/action/playAlbum", "chord/workbench/parts/mainView/browser/action/showArtist", "chord/workbench/parts/menu/browser/action/menu", "chord/music/core/api", "chord/css!../../media/album"], function (require, exports, React, react_redux_1, statistic_1, size_1, time_1, common_1, songItem_1, playAlbum_1, showArtist_1, menu_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function AlbumEntity(_a) {
        var album = _a.album, handlePlayAlbum = _a.handlePlayAlbum, handleShowArtistViewById = _a.handleShowArtistViewById, showAlbumMenu = _a.showAlbumMenu;
        var cover = album.albumCoverPath || api_1.musicApi.resizeImageUrl(album.origin, album.albumCoverUrl, size_1.ESize.Large);
        return (React.createElement("header", { className: 'entity-info' },
            React.createElement("div", null,
                React.createElement("div", null,
                    React.createElement("div", { className: "media-object" },
                        React.createElement("div", { className: "media-object-hoverable" },
                            React.createElement("div", { className: "react-contextmenu-wrapper", onContextMenu: function (e) { return showAlbumMenu(e, album); } },
                                React.createElement("div", { className: "cover-art shadow cover-art--with-auto-height", "aria-hidden": "true", style: { width: 'auto', height: 'auto' } },
                                    React.createElement("div", null,
                                        common_1.AlbumIcon,
                                        React.createElement("div", { className: "cover-art-image cover-art-image-loaded", style: { backgroundImage: "url(\"" + cover + "\")" } })))))))),
            React.createElement(AlbumInfo, { album: album, handlePlayAlbum: handlePlayAlbum, handleShowArtistViewById: handleShowArtistViewById })));
    }
    function AlbumInfo(_a) {
        var album = _a.album, handlePlayAlbum = _a.handlePlayAlbum, handleShowArtistViewById = _a.handleShowArtistViewById;
        var likeAndPlayCount = statistic_1.getLikeAndPlayCount(album);
        return (React.createElement("div", { className: 'media-bd' },
            React.createElement("div", { className: 'entity-name' },
                React.createElement("h2", null, album.albumName),
                React.createElement("div", null,
                    React.createElement("span", null, "By "),
                    React.createElement("span", { className: 'link-subtle a-like cursor-pointer', onClick: function () { return handleShowArtistViewById(album.artistId); } }, album.artistName))),
            React.createElement("p", { className: "text-silence entity-additional-info" }, likeAndPlayCount),
            React.createElement("p", { className: "text-silence entity-additional-info" },
                time_1.getDateYear(album.releaseDate),
                " \u2022 ",
                album.songCount,
                " tracks"),
            React.createElement("button", { className: "btn btn-green cursor-pointer", onClick: function () { return handlePlayAlbum(album); } }, "PLAY")));
    }
    var AlbumView = /** @class */ (function (_super) {
        __extends(AlbumView, _super);
        function AlbumView(props) {
            return _super.call(this, props) || this;
        }
        AlbumView.prototype.componentDidMount = function () {
            // Scroll to document top
            window.scroll(0, 0);
        };
        AlbumView.prototype.render = function () {
            var album = this.props.album;
            var songsView = album.songs.map(function (song, index) { return (React.createElement(songItem_1.default, { key: 'album_song_' + index.toString().padStart(3, '0'), song: song, active: false, short: true, thumb: false, handlePlay: null })); });
            return (React.createElement("div", { className: 'hw-accelerate' },
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("section", { className: 'content album' },
                        React.createElement("div", { className: 'container-fluid' },
                            React.createElement("div", { className: 'row' },
                                React.createElement("div", { className: 'col-xs-12 col-lg-3 col-xl-4 col-sticky' },
                                    React.createElement(AlbumEntity, { album: album, handlePlayAlbum: this.props.handlePlayAlbum, handleShowArtistViewById: this.props.handleShowArtistViewById, showAlbumMenu: this.props.showAlbumMenu })),
                                React.createElement("div", { className: 'col-xs-12 col-lg-9 col-xl-8 description', dangerouslySetInnerHTML: { __html: album.description } }),
                                React.createElement("div", { className: 'col-xs-12 col-lg-9 col-xl-8' },
                                    React.createElement("section", { className: 'tracklist-container' },
                                        React.createElement("ol", { className: 'tracklist' }, songsView)))))))));
        };
        return AlbumView;
    }(React.Component));
    function mapStateToProps(state) {
        return {
            album: state.mainView.albumView.album,
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            handlePlayAlbum: function (album) { return playAlbum_1.handlePlayAlbum(album).then(function (act) { return dispatch(act); }); },
            handleShowArtistViewById: function (artistId) { return showArtist_1.handleShowArtistViewById(artistId).then(function (act) { return dispatch(act); }); },
            showAlbumMenu: function (e, album) { return dispatch(menu_1.showAlbumMenu(e, album)); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(AlbumView);
});
