var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/api/utils/statistic", "chord/music/common/size", "chord/workbench/parts/common/component/songItem", "chord/workbench/parts/common/component/albumItem", "chord/workbench/parts/common/component/viewMoreItem", "chord/workbench/parts/mainView/browser/action/artist", "chord/workbench/parts/player/browser/action/playArtist", "chord/workbench/parts/common/component/buttons", "chord/workbench/parts/menu/browser/action/menu", "chord/music/core/api", "chord/css!../../media/artist"], function (require, exports, React, react_redux_1, statistic_1, size_1, songItem_1, albumItem_1, viewMoreItem_1, artist_1, playArtist_1, buttons_1, menu_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function ArtistNavMenu(_a) {
        var view = _a.view, changeArtistNavMenuView = _a.changeArtistNavMenuView;
        return (React.createElement("nav", { className: 'search-nav-container' },
            React.createElement("ul", { className: 'search-nav-ul' },
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'overview' ? 'search-nav-item__active' : ''), onClick: function () { return changeArtistNavMenuView('overview'); } }, "OVERVIEW")),
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'songs' ? 'search-nav-item__active' : ''), onClick: function () { return changeArtistNavMenuView('songs'); } }, "SONGS")),
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'albums' ? 'search-nav-item__active' : ''), onClick: function () { return changeArtistNavMenuView('albums'); } }, "ALBUMS")))));
    }
    var ArtistView = /** @class */ (function (_super) {
        __extends(ArtistView, _super);
        function ArtistView(props) {
            var _this = _super.call(this, props) || this;
            if (!ArtistView.view) {
                ArtistView.view = _this.props.view;
            }
            _this.state = { view: ArtistView.view };
            _this.changeArtistNavMenuView = _this.changeArtistNavMenuView.bind(_this);
            _this._getSongsView = _this._getSongsView.bind(_this);
            _this._getAlbumsView = _this._getAlbumsView.bind(_this);
            _this._getArtistHeader = _this._getArtistHeader.bind(_this);
            _this.overviewView = _this.overviewView.bind(_this);
            _this.songsView = _this.songsView.bind(_this);
            _this.albumsView = _this.albumsView.bind(_this);
            return _this;
        }
        ArtistView.prototype.componentDidMount = function () {
            // Scroll to document top
            window.scroll(0, 0);
        };
        ArtistView.prototype.changeArtistNavMenuView = function (view) {
            ArtistView.view = view;
            this.setState({ view: view });
        };
        ArtistView.prototype._getSongsView = function (size) {
            var artist = this.props.artist;
            var songsView = artist.songs.slice(0, size ? size : Infinity).map(function (song, index) { return (React.createElement(songItem_1.default, { key: 'artist_song_' + index.toString().padStart(3, '0'), song: song, active: false, short: false, thumb: true, handlePlay: null })); });
            return songsView;
        };
        ArtistView.prototype._getAlbumsView = function (size) {
            var artist = this.props.artist;
            var albumsView = artist.albums.slice(0, size ? size : Infinity).map(function (album, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'artist_album_' + index.toString().padStart(3, '0') },
                React.createElement(albumItem_1.default, { album: album }))); });
            return albumsView;
        };
        ArtistView.prototype._getArtistHeader = function () {
            var _this = this;
            // Maybe need to set background image
            var artist = this.props.artist;
            var cover = artist.artistAvatarPath || api_1.musicApi.resizeImageUrl(artist.origin, artist.artistAvatarUrl, size_1.ESize.Large);
            var likeAndPlayCount = statistic_1.getLikeAndPlayCount(artist);
            return (React.createElement("header", { className: 'artist-header', style: {
                    backgroundImage: "url(\"" + cover + "\")",
                    backgroundPosition: '100% 12%',
                    height: '500px',
                } },
                React.createElement("span", { className: 'monthly-listeners' }, '\u00A0'),
                React.createElement("h1", { className: 'large' }, artist.artistName),
                React.createElement("h1", { className: 'small', style: { opacity: 0.4 } }, likeAndPlayCount),
                React.createElement("div", { className: 'header-buttons' },
                    React.createElement("button", { className: 'btn btn-green cursor-pointer', onClick: function () { return _this.props.handlePlayArtist(artist); } }, "PLAY"),
                    React.createElement(buttons_1.MenuButton, { click: function (e) { return _this.props.showArtistMenu(e, artist); } })),
                React.createElement(ArtistNavMenu, { view: ArtistView.view, changeArtistNavMenuView: this.changeArtistNavMenuView })));
        };
        ArtistView.prototype.overviewView = function () {
            var defaultSize = 10;
            var songsView = this._getSongsView(defaultSize);
            var albumsView = this._getAlbumsView(defaultSize);
            var artist = this.props.artist;
            return (React.createElement("div", null,
                React.createElement("div", { className: 'artist-description', dangerouslySetInnerHTML: { __html: artist.description } }),
                React.createElement("section", { className: 'artist-music container-fluid' },
                    React.createElement("div", { className: 'row' },
                        React.createElement("div", { className: 'contentSpacing' },
                            React.createElement("section", { className: 'col-sm-12 col-md-10 col-md-push-1 artist-toptracks' },
                                React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center' } }, "Popular"),
                                React.createElement("section", { className: 'tracklist-container full-width' },
                                    React.createElement("ol", null, songsView)))))),
                React.createElement("section", { className: 'artist-albums' },
                    React.createElement("div", { className: 'contentSpacing' },
                        React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center' } }, "Albums"),
                        React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                            React.createElement("div", { className: 'align-row-wrap grid--limit row' }, albumsView))))));
        };
        ArtistView.prototype.songsView = function () {
            var _this = this;
            var artist = this.props.artist;
            var songsView = this._getSongsView();
            var offset = this.props.songsOffset;
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return _this.props.getMoreSongs(artist, offset, size); } })) : null;
            return (React.createElement("section", { className: 'artist-music container-fluid' },
                React.createElement("div", { className: 'row' },
                    React.createElement("div", { className: 'contentSpacing' },
                        React.createElement("section", { className: 'col-sm-12 col-md-10 col-md-push-1 artist-toptracks' },
                            React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center', display: 'none' } }, "Popular"),
                            React.createElement("section", { className: 'tracklist-container full-width' },
                                React.createElement("ol", null, songsView))))),
                viewMore));
        };
        ArtistView.prototype.albumsView = function () {
            var _this = this;
            var artist = this.props.artist;
            var albumsView = this._getAlbumsView();
            var offset = this.props.albumsOffset;
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return _this.props.getMoreAlbums(artist, offset, size); } })) : null;
            return (React.createElement("section", { className: 'artist-albums' },
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center', display: 'none' } }, "Albums"),
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'align-row-wrap grid--limit row' }, albumsView)),
                    viewMore)));
        };
        ArtistView.prototype.render = function () {
            var artistHeaderView = this._getArtistHeader();
            var view = ArtistView.view;
            var contentView = null;
            if (view == 'overview') {
                contentView = this.overviewView();
            }
            else if (view == 'songs') {
                contentView = this.songsView();
            }
            else if (view == 'albums') {
                contentView = this.albumsView();
            }
            else {
                return null;
            }
            return (React.createElement("div", { className: 'hw-accelerate' },
                React.createElement("section", { className: 'content artist' },
                    artistHeaderView,
                    contentView)));
        };
        return ArtistView;
    }(React.Component));
    function mapStateToProps(state) {
        return state.mainView.artistView;
    }
    function mapDispatchToProps(dispatch) {
        return {
            getMoreSongs: function (artist, offset, size) { return artist_1.getMoreSongs(artist, offset, size).then(function (act) { return dispatch(act); }); },
            getMoreAlbums: function (artist, offset, size) { return artist_1.getMoreAlbums(artist, offset, size).then(function (act) { return dispatch(act); }); },
            handlePlayArtist: function (artist) { return playArtist_1.handlePlayArtist(artist).then(function (act) { return dispatch(act); }); },
            showArtistMenu: function (e, artist) { return dispatch(menu_1.showArtistMenu(e, artist)); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(ArtistView);
});
