var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/api/utils/statistic", "chord/music/common/size", "chord/base/common/time", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/songItem", "chord/workbench/parts/player/browser/action/playCollection", "chord/workbench/parts/menu/browser/action/menu", "chord/workbench/parts/mainView/browser/action/showUserProfile", "chord/music/core/api", "chord/css!../../media/collection"], function (require, exports, React, react_redux_1, statistic_1, size_1, time_1, common_1, songItem_1, playCollection_1, menu_1, showUserProfile_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function CollectionEntity(_a) {
        var collection = _a.collection, handlePlayCollection = _a.handlePlayCollection, showCollectionMenu = _a.showCollectionMenu, handleShowUserProfileViewById = _a.handleShowUserProfileViewById;
        var cover = collection.collectionCoverPath || api_1.musicApi.resizeImageUrl(collection.origin, collection.collectionCoverUrl, size_1.ESize.Large);
        return (React.createElement("header", { className: 'entity-info' },
            React.createElement("div", null,
                React.createElement("div", null,
                    React.createElement("div", { className: "media-object" },
                        React.createElement("div", { className: "media-object-hoverable" },
                            React.createElement("div", { className: "react-contextmenu-wrapper", onContextMenu: function (e) { return showCollectionMenu(e, collection); } },
                                React.createElement("div", { className: "cover-art shadow cover-art--with-auto-height", "aria-hidden": "true", style: { width: 'auto', height: 'auto' } },
                                    React.createElement("div", null,
                                        common_1.CollectionIcon,
                                        React.createElement("div", { className: "cover-art-image cover-art-image-loaded", style: { backgroundImage: "url(\"" + cover + "\")" } })))))))),
            React.createElement(CollectionInfo, { collection: collection, handlePlayCollection: handlePlayCollection, handleShowUserProfileViewById: handleShowUserProfileViewById })));
    }
    function CollectionInfo(_a) {
        var collection = _a.collection, handlePlayCollection = _a.handlePlayCollection, handleShowUserProfileViewById = _a.handleShowUserProfileViewById;
        var likeAndPlayCount = statistic_1.getLikeAndPlayCount(collection);
        return (React.createElement("div", { className: 'media-bd' },
            React.createElement("div", { className: 'entity-name' },
                React.createElement("h2", null, collection.collectionName),
                React.createElement("div", null,
                    React.createElement("span", null, "By "),
                    React.createElement("span", { className: 'link-subtle a-like cursor-pointer', onClick: function () { return handleShowUserProfileViewById(collection.userId, collection.userMid, collection.userName); } }, collection.userName))),
            React.createElement("p", { className: "text-silence entity-additional-info" }, likeAndPlayCount),
            React.createElement("p", { className: "text-silence entity-additional-info" },
                time_1.getDateYear(collection.releaseDate),
                " \u2022 ",
                collection.songCount,
                " tracks"),
            React.createElement("button", { className: "btn btn-green cursor-pointer", onClick: function () { return handlePlayCollection(collection); } }, "PLAY")));
    }
    var CollectionView = /** @class */ (function (_super) {
        __extends(CollectionView, _super);
        function CollectionView(props) {
            return _super.call(this, props) || this;
        }
        CollectionView.prototype.componentDidMount = function () {
            // Scroll to document top
            window.scroll(0, 0);
        };
        CollectionView.prototype.render = function () {
            var collection = this.props.collection;
            var songsView = collection.songs.map(function (song, index) { return (React.createElement(songItem_1.default, { key: 'collection_song_' + index.toString().padStart(3, '0'), song: song, active: false, short: false, thumb: false, handlePlay: null })); });
            return (React.createElement("div", { className: 'hw-accelerate' },
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("section", { className: 'content collection' },
                        React.createElement("div", { className: 'container-fluid' },
                            React.createElement("div", { className: 'row' },
                                React.createElement("div", { className: 'col-xs-12 col-lg-3 col-xl-4 col-sticky' },
                                    React.createElement(CollectionEntity, { collection: collection, handlePlayCollection: this.props.handlePlayCollection, showCollectionMenu: this.props.showCollectionMenu, handleShowUserProfileViewById: this.props.handleShowUserProfileViewById })),
                                React.createElement("div", { className: 'col-xs-12 col-lg-9 col-xl-8 description', dangerouslySetInnerHTML: { __html: collection.description } }),
                                React.createElement("div", { className: 'col-xs-12 col-lg-9 col-xl-8' },
                                    React.createElement("section", { className: 'tracklist-container' },
                                        React.createElement("ol", { className: 'tracklist' }, songsView)))))))));
        };
        return CollectionView;
    }(React.Component));
    function mapStateToProps(state) {
        return {
            collection: state.mainView.collectionView.collection,
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            handlePlayCollection: function (collection) { return playCollection_1.handlePlayCollection(collection).then(function (act) { return dispatch(act); }); },
            handleShowUserProfileViewById: function (userId, userMid, userName) { return showUserProfile_1.handleShowUserProfileViewById(userId, userMid, userName).then(function (act) { return dispatch(act); }); },
            showCollectionMenu: function (e, collection) { return dispatch(menu_1.showCollectionMenu(e, collection)); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(CollectionView);
});
