define(["require", "exports", "react", "react-redux", "chord/platform/utils/common/keys", "chord/music/common/origin", "chord/workbench/parts/mainView/browser/component/home/component/albums/albumListOptions"], function (require, exports, React, react_redux_1, keys_1, origin_1, albumListOptions_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function AlbumsView(_a) {
        var view = _a.view, origin = _a.origin;
        var View;
        // Reuse following views
        var xiamiAlbumListOptionsView = React.createElement(albumListOptions_1.default, { key: keys_1.makeListKey(0, 'album', 'options'), origin: origin_1.ORIGIN.xiami });
        var qqAlbumListOptionsView = React.createElement(albumListOptions_1.default, { key: keys_1.makeListKey(1, 'album', 'options'), origin: origin_1.ORIGIN.qq });
        switch (view) {
            case 'options':
                View = [xiamiAlbumListOptionsView, qqAlbumListOptionsView];
                break;
            case 'albums':
                switch (origin) {
                    case origin_1.ORIGIN.xiami:
                        View = xiamiAlbumListOptionsView;
                        break;
                    case origin_1.ORIGIN.qq:
                        View = qqAlbumListOptionsView;
                        break;
                    default:
                        throw new Error("[AlbumsView]: unknown origin: " + origin);
                }
                break;
            default:
                throw new Error("[AlbumsView]: unknown view: " + view);
        }
        return View;
    }
    function mapStateToProps(state) {
        return {
            view: state.mainView.homeView.albumsView.view,
            origin: state.mainView.homeView.albumsView.origin,
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps)(AlbumsView);
});
