var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/parts/common/component/songItem", "chord/workbench/parts/common/component/albumItem", "chord/workbench/parts/common/component/collectionItem", "chord/workbench/parts/mainView/browser/component/home/component/newRelease/actions", "chord/workbench/parts/player/browser/action/playMany"], function (require, exports, React, react_redux_1, songItem_1, albumItem_1, collectionItem_1, actions_1, playMany_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var NewReleaseView = /** @class */ (function (_super) {
        __extends(NewReleaseView, _super);
        function NewReleaseView(props) {
            var _this = _super.call(this, props) || this;
            _this.state = {
                songs: [],
                albums: [],
                collections: [],
            };
            _this._getSongsView = _this._getSongsView.bind(_this);
            _this._getAlbumsView = _this._getAlbumsView.bind(_this);
            _this._getCollectionsView = _this._getCollectionsView.bind(_this);
            return _this;
        }
        NewReleaseView.prototype.componentWillMount = function () {
            var _this = this;
            Promise.all([
                actions_1.getMoreSongs(0, 10),
                actions_1.getMoreAlbums(0, 10),
                actions_1.getMoreCollections(0, 10),
            ]).then(function (itemsList) {
                _this.setState({
                    songs: itemsList[0],
                    albums: itemsList[1],
                    collections: itemsList[2],
                });
            });
        };
        NewReleaseView.prototype._getSongsView = function (size) {
            var songsView = this.state.songs.slice(0, size ? size : Infinity).map(function (song, index) { return (React.createElement(songItem_1.default, { key: 'song_newRelease_' + index.toString().padStart(3, '0'), song: song, active: false, short: false, thumb: false, handlePlay: null })); });
            return songsView;
        };
        NewReleaseView.prototype._getAlbumsView = function (size) {
            var albumsView = this.state.albums.slice(0, size ? size : Infinity).map(function (album, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'album_newRelease_' + index.toString().padStart(3, '0') },
                React.createElement(albumItem_1.default, { album: album }))); });
            return albumsView;
        };
        NewReleaseView.prototype._getCollectionsView = function (size) {
            var collectionsView = this.state.collections.slice(0, size ? size : Infinity).map(function (collection, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'collection_newRelease_' + index.toString().padStart(3, '0') },
                React.createElement(collectionItem_1.default, { collection: collection }))); });
            return collectionsView;
        };
        NewReleaseView.prototype.render = function () {
            var _this = this;
            var songsView = this._getSongsView();
            var albumsView = this._getAlbumsView();
            var collectionsView = this._getCollectionsView();
            return (React.createElement("div", null,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Songs"),
                            React.createElement("button", { className: "btn btn-green btn-small cursor-pointer", style: { margin: '0px auto 15px', display: 'block' }, onClick: function () { return _this.props.handlePlaySongs(_this.state.songs); } }, "PlAY ALL"),
                            React.createElement("section", { className: 'tracklist-container' },
                                React.createElement("ol", { className: 'tracklist' }, songsView))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Albums"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, albumsView)))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Playlists"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, collectionsView))))))));
        };
        return NewReleaseView;
    }(React.Component));
    function mapDispatchToProps(dispatch) {
        return {
            handlePlaySongs: function (songs) { return playMany_1.handlePlayManyItems(songs).then(function (act) { return dispatch(act); }); },
        };
    }
    exports.default = react_redux_1.connect(null, mapDispatchToProps)(NewReleaseView);
});
