var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "react", "react-redux", "chord/workbench/parts/common/component/songItem", "chord/workbench/parts/common/component/collectionItem", "chord/workbench/parts/player/browser/action/playMany"], function (require, exports, React, react_redux_1, songItem_1, collectionItem_1, playMany_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var RecommendView = /** @class */ (function (_super) {
        __extends(RecommendView, _super);
        function RecommendView(props) {
            var _this = _super.call(this, props) || this;
            _this._getSongsView = _this._getSongsView.bind(_this);
            _this._getCollectionsView = _this._getCollectionsView.bind(_this);
            return _this;
        }
        RecommendView.prototype._getSongsView = function (size) {
            var songsView = this.props.songs.slice(0, size ? size : Infinity).map(function (song, index) { return (React.createElement(songItem_1.default, { key: 'song_recommend_' + index.toString().padStart(3, '0'), song: song, active: false, short: false, thumb: false, handlePlay: null })); });
            return songsView;
        };
        RecommendView.prototype._getCollectionsView = function (size) {
            var collectionsView = this.props.collections.slice(0, size ? size : Infinity).map(function (collection, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'collection_recommend_' + index.toString().padStart(3, '0') },
                React.createElement(collectionItem_1.default, { collection: collection }))); });
            return collectionsView;
        };
        RecommendView.prototype.render = function () {
            var _this = this;
            var songsView = this._getSongsView();
            var collectionsView = this._getCollectionsView();
            var songs = this.props.songs;
            return (React.createElement("div", null,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Songs"),
                            React.createElement("button", { className: "btn btn-green btn-small cursor-pointer", style: { margin: '0px auto 15px', display: 'block' }, onClick: function () { return _this.props.handlePlayRecommendSongs(songs); } }, "PlAY ALL"),
                            React.createElement("section", { className: 'tracklist-container' },
                                React.createElement("ol", { className: 'tracklist' }, songsView))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Playlists"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, collectionsView))))))));
        };
        return RecommendView;
    }(React.Component));
    function mapStateToProps(state) {
        return __assign({}, state.mainView.homeView.recommendView);
    }
    function mapDispatchToProps(dispatch) {
        return {
            handlePlayRecommendSongs: function (songs) { return playMany_1.handlePlayManyItems(songs).then(function (act) { return dispatch(act); }); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(RecommendView);
});
