var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "react", "react-redux", "chord/platform/utils/common/keys", "chord/workbench/parts/common/component/songItem", "chord/workbench/parts/common/component/artistItem", "chord/workbench/parts/common/component/albumItem", "chord/workbench/parts/common/component/collectionItem", "chord/workbench/parts/common/component/userProfileItem", "chord/workbench/parts/common/component/episodeItem", "chord/workbench/parts/common/component/podcastItem", "chord/workbench/parts/common/component/radioItem", "chord/workbench/parts/common/component/viewMoreItem", "chord/workbench/parts/common/component/navMenu", "chord/workbench/parts/mainView/browser/action/libraryResult", "chord/workbench/parts/player/browser/action/playLibrarySongs"], function (require, exports, React, react_redux_1, keys_1, songItem_1, artistItem_1, albumItem_1, collectionItem_1, userProfileItem_1, episodeItem_1, podcastItem_1, radioItem_1, viewMoreItem_1, navMenu_1, libraryResult_1, playLibrarySongs_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var LibraryResult = /** @class */ (function (_super) {
        __extends(LibraryResult, _super);
        function LibraryResult(props) {
            var _this = _super.call(this, props) || this;
            if (!LibraryResult.view) {
                LibraryResult.view = _this.props.view;
            }
            _this.state = { view: LibraryResult.view };
            _this.changeLibraryResultView = _this.changeLibraryResultView.bind(_this);
            _this._itemWrap = _this._itemWrap.bind(_this);
            _this._getSongsView = _this._getSongsView.bind(_this);
            _this._getAlbumsView = _this._getAlbumsView.bind(_this);
            _this._getArtistsView = _this._getArtistsView.bind(_this);
            _this._getCollectionsView = _this._getCollectionsView.bind(_this);
            _this._getUserProfilesView = _this._getUserProfilesView.bind(_this);
            _this._getEpisodesView = _this._getEpisodesView.bind(_this);
            _this._getPodcastsView = _this._getPodcastsView.bind(_this);
            _this._getRadiosView = _this._getRadiosView.bind(_this);
            _this._getLibraryNavMenu = _this._getLibraryNavMenu.bind(_this);
            _this.topResult = _this.topResult.bind(_this);
            _this.songsResult = _this.songsResult.bind(_this);
            _this.artistsResult = _this.artistsResult.bind(_this);
            _this.albumsResult = _this.albumsResult.bind(_this);
            _this.collectionsResult = _this.collectionsResult.bind(_this);
            _this.userProfilesResult = _this.userProfilesResult.bind(_this);
            return _this;
        }
        LibraryResult.prototype.changeLibraryResultView = function (view) {
            LibraryResult.view = view;
            this.setState({ view: view });
        };
        LibraryResult.prototype._getSongsView = function (size) {
            var songsView = this.props.songs.slice(0, size ? size : Infinity).map(function (userSong, index) { return (React.createElement(songItem_1.default, { key: keys_1.makeListKey(index, 'song', 'library'), song: userSong.song, active: false, short: false, thumb: false, handlePlay: null })); });
            return songsView;
        };
        LibraryResult.prototype._itemWrap = function (item, index, name) {
            return (React.createElement("div", { key: keys_1.makeListKey(index, name, 'library'), className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2' }, item));
        };
        LibraryResult.prototype._getAlbumsView = function (size) {
            var _this = this;
            var albumsView = this.props.albums.slice(0, size ? size : Infinity).map(function (userAlbum, index) { return (_this._itemWrap(React.createElement(albumItem_1.default, { album: userAlbum.album }), index, 'album')); });
            return albumsView;
        };
        LibraryResult.prototype._getArtistsView = function (size) {
            var _this = this;
            var artistsView = this.props.artists.slice(0, size ? size : Infinity).map(function (userArtist, index) { return (_this._itemWrap(React.createElement(artistItem_1.default, { artist: userArtist.artist }), index, 'artist')); });
            return artistsView;
        };
        LibraryResult.prototype._getCollectionsView = function (size) {
            var _this = this;
            var collectionsView = this.props.collections.slice(0, size ? size : Infinity).map(function (userCollection, index) { return (_this._itemWrap(React.createElement(collectionItem_1.default, { collection: userCollection.collection }), index, 'collection')); });
            return collectionsView;
        };
        LibraryResult.prototype._getUserProfilesView = function (size) {
            var _this = this;
            var userProfilesView = this.props.userProfiles.slice(0, size ? size : Infinity).map(function (userUserProfile, index) { return (_this._itemWrap(React.createElement(userProfileItem_1.default, { userProfile: userUserProfile.userProfile }), index, 'userProfile')); });
            return userProfilesView;
        };
        LibraryResult.prototype._getEpisodesView = function (size) {
            var episodesView = this.props.episodes.slice(0, size ? size : Infinity).map(function (userEpisode, index) { return (React.createElement(episodeItem_1.default, { key: keys_1.makeListKey(index, 'episode', 'library'), episode: userEpisode.episode, active: false, short: false, thumb: false, handlePlay: null })); });
            return episodesView;
        };
        LibraryResult.prototype._getPodcastsView = function (size) {
            var _this = this;
            var podcastsView = this.props.podcasts.slice(0, size ? size : Infinity).map(function (userPodcast, index) { return (_this._itemWrap(React.createElement(podcastItem_1.default, { podcast: userPodcast.podcast }), index, 'podcast')); });
            return podcastsView;
        };
        LibraryResult.prototype._getRadiosView = function (size) {
            var _this = this;
            var radiosView = this.props.radios.slice(0, size ? size : Infinity).map(function (userRadio, index) { return (_this._itemWrap(React.createElement(radioItem_1.default, { radio: userRadio.radio }), index, 'radio')); });
            return radiosView;
        };
        LibraryResult.prototype._getLibraryNavMenu = function () {
            var views = [
                { name: 'TOP RESULT', value: 'top' },
                { name: 'SONGS', value: 'songs' },
                { name: 'ARTISTS', value: 'artists' },
                { name: 'ALBUMS', value: 'albums' },
                { name: 'COLLECTIONS', value: 'collections' },
                { name: 'USERS', value: 'userProfiles' },
                { name: 'PODCASTS', value: 'podcasts' },
                { name: 'RADIOS', value: 'radios' },
                { name: 'EPISODES', value: 'episodes' },
            ];
            return React.createElement(navMenu_1.NavMenu, { namespace: 'search-navmenu', thisView: LibraryResult.view, views: views, handleClick: this.changeLibraryResultView });
        };
        LibraryResult.prototype.topResult = function () {
            var defaultSize = 10;
            var songsView = this._getSongsView(defaultSize);
            var albumsView = this._getAlbumsView(defaultSize);
            var artistsView = this._getArtistsView(defaultSize);
            var collectionsView = this._getCollectionsView(defaultSize);
            var userProfilesView = this._getUserProfilesView(defaultSize);
            var episodesView = this._getEpisodesView(defaultSize);
            var podcastsView = this._getPodcastsView(defaultSize);
            var radiosView = this._getRadiosView(defaultSize);
            var searchNavMenu = this._getLibraryNavMenu();
            var makeItemsView = function (name, itemsView) { return (React.createElement("div", { className: 'row' },
                React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, name),
                React.createElement("section", null,
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'align-row-wrap row' }, itemsView))))); };
            return (React.createElement("div", null,
                searchNavMenu,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Songs"),
                            React.createElement("button", { className: "btn btn-green btn-small cursor-pointer", style: { margin: '0px auto 15px', display: 'block' }, onClick: this.props.handlePlayLibrarySongs }, "PlAY ALL"),
                            React.createElement("section", { className: 'tracklist-container' },
                                React.createElement("ol", { className: 'tracklist' }, songsView))),
                        makeItemsView('Artists', artistsView),
                        makeItemsView('Albums', albumsView),
                        makeItemsView('Collections', collectionsView),
                        makeItemsView('Followings', userProfilesView),
                        makeItemsView('Podcasts', podcastsView),
                        makeItemsView('Radios', radiosView),
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Episodes"),
                            React.createElement("section", { className: 'tracklist-container' },
                                React.createElement("ol", { className: 'tracklist' }, episodesView)))))));
        };
        LibraryResult.prototype.songsResult = function () {
            var _this = this;
            var songsView = this._getSongsView();
            var searchNavMenu = this._getLibraryNavMenu();
            var keyword = this.props.keyword;
            var offset = this.props.songsOffset;
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return _this.props.getMoreSongs(keyword, offset, size); } })) : null;
            return (React.createElement("div", null,
                searchNavMenu,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Songs"),
                            React.createElement("button", { className: "btn btn-green btn-small cursor-pointer", style: { margin: '0px auto 15px', display: 'block' }, onClick: this.props.handlePlayLibrarySongs }, "PlAY ALL"),
                            React.createElement("section", { className: 'tracklist-container' },
                                React.createElement("ol", { className: 'tracklist' }, songsView))),
                        viewMore))));
        };
        LibraryResult.prototype._itemsResult = function (itemsView, viewMore) {
            var searchNavMenu = this._getLibraryNavMenu();
            return (React.createElement("div", null,
                searchNavMenu,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Artists"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, itemsView)))),
                        viewMore))));
        };
        LibraryResult.prototype.artistsResult = function () {
            var _this = this;
            var artistsView = this._getArtistsView();
            var keyword = this.props.keyword;
            var offset = this.props.artistsOffset;
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return _this.props.getMoreArtists(keyword, offset, size); } })) : null;
            return this._itemsResult(artistsView, viewMore);
        };
        LibraryResult.prototype.albumsResult = function () {
            var _this = this;
            var albumsView = this._getAlbumsView();
            var keyword = this.props.keyword;
            var offset = this.props.albumsOffset;
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return _this.props.getMoreAlbums(keyword, offset, size); } })) : null;
            return this._itemsResult(albumsView, viewMore);
        };
        LibraryResult.prototype.collectionsResult = function () {
            var _this = this;
            var collectionsView = this._getCollectionsView();
            var keyword = this.props.keyword;
            var offset = this.props.collectionsOffset;
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return _this.props.getMoreCollections(keyword, offset, size); } })) : null;
            return this._itemsResult(collectionsView, viewMore);
        };
        LibraryResult.prototype.userProfilesResult = function () {
            var _this = this;
            var userProfilesView = this._getUserProfilesView();
            var keyword = this.props.keyword;
            var offset = this.props.userProfilesOffset;
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return _this.props.getMoreUserProfiles(keyword, offset, size); } })) : null;
            return this._itemsResult(userProfilesView, viewMore);
        };
        LibraryResult.prototype.episodesResult = function () {
            var _this = this;
            var episodesView = this._getEpisodesView();
            var searchNavMenu = this._getLibraryNavMenu();
            var keyword = this.props.keyword;
            var offset = this.props.episodesOffset;
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return _this.props.getMoreEpisodes(keyword, offset, size); } })) : null;
            return (React.createElement("div", null,
                searchNavMenu,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Episodes"),
                            React.createElement("section", { className: 'tracklist-container' },
                                React.createElement("ol", { className: 'tracklist' }, episodesView))),
                        viewMore))));
        };
        LibraryResult.prototype.podcastsResult = function () {
            var _this = this;
            var podcastsView = this._getPodcastsView();
            var keyword = this.props.keyword;
            var offset = this.props.podcastsOffset;
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return _this.props.getMorePodcasts(keyword, offset, size); } })) : null;
            return this._itemsResult(podcastsView, viewMore);
        };
        LibraryResult.prototype.radiosResult = function () {
            var _this = this;
            var radiosView = this._getRadiosView();
            var keyword = this.props.keyword;
            var offset = this.props.radiosOffset;
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return _this.props.getMoreRadios(keyword, offset, size); } })) : null;
            return this._itemsResult(radiosView, viewMore);
        };
        LibraryResult.prototype.render = function () {
            var view = LibraryResult.view;
            switch (view) {
                case 'songs':
                    return this.songsResult();
                case 'artists':
                    return this.artistsResult();
                case 'albums':
                    return this.albumsResult();
                case 'collections':
                    return this.collectionsResult();
                case 'userProfiles':
                    return this.userProfilesResult();
                case 'episodes':
                    return this.episodesResult();
                case 'podcasts':
                    return this.podcastsResult();
                case 'radios':
                    return this.radiosResult();
                default: // view == 'top'
                    return this.topResult();
            }
        };
        return LibraryResult;
    }(React.Component));
    function mapStateToProps(state) {
        return __assign(__assign({}, state.mainView.libraryView.result), { keyword: state.mainView.libraryView.keyword });
    }
    function mapDispatchToProps(dispatch) {
        return {
            getMoreSongs: function (keyword, offset, size) { return dispatch(libraryResult_1.getMoreSongs(keyword, offset, size)); },
            getMoreAlbums: function (keyword, offset, size) { return dispatch(libraryResult_1.getMoreAlbums(keyword, offset, size)); },
            getMoreArtists: function (keyword, offset, size) { return dispatch(libraryResult_1.getMoreArtists(keyword, offset, size)); },
            getMoreCollections: function (keyword, offset, size) { return dispatch(libraryResult_1.getMoreCollections(keyword, offset, size)); },
            getMoreUserProfiles: function (keyword, offset, size) { return dispatch(libraryResult_1.getMoreUserProfiles(keyword, offset, size)); },
            getMoreEpisodes: function (keyword, offset, size) { return dispatch(libraryResult_1.getMoreEpisodes(keyword, offset, size)); },
            getMorePodcasts: function (keyword, offset, size) { return dispatch(libraryResult_1.getMorePodcasts(keyword, offset, size)); },
            getMoreRadios: function (keyword, offset, size) { return dispatch(libraryResult_1.getMoreRadios(keyword, offset, size)); },
            handlePlayLibrarySongs: function () { return playLibrarySongs_1.handlePlayLibrarySongs().then(function (act) { return dispatch(act); }); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(LibraryResult);
});
