var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/music/common/size", "chord/music/common/origin", "chord/workbench/parts/notification/action/notice", "chord/workbench/parts/mainView/browser/action/showUserProfile", "chord/workbench/parts/player/browser/action/playUser", "chord/workbench/parts/common/component/originIcons", "chord/workbench/parts/common/component/common", "chord/music/core/api", "chord/preference/configuration/user"], function (require, exports, React, react_redux_1, size_1, origin_1, notice_1, showUserProfile_1, playUser_1, originIcons_1, common_1, api_1, user_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.QQLogin = exports.NeteaseLogin = exports.XiamiLogin = void 0;
    var Login = /** @class */ (function (_super) {
        __extends(Login, _super);
        function Login(props) {
            var _this = _super.call(this, props) || this;
            _this.state = { account: '', password: '' };
            _this.handleInputChange = _this.handleInputChange.bind(_this);
            _this.login = _this.login.bind(_this);
            _this.loginOut = _this.loginOut.bind(_this);
            _this.showLogin = _this.showLogin.bind(_this);
            _this.showLogined = _this.showLogined.bind(_this);
            _this.handleCheckbox = _this.handleCheckbox.bind(_this);
            return _this;
        }
        Login.prototype.handleCheckbox = function (event) {
            var check = event.nativeEvent.target.checked;
            user_1.userConfiguration.setConfig(this.origin + ".syncAddRemove", check);
            user_1.userConfiguration.saveConfig();
            this.forceUpdate();
        };
        Login.prototype.handleInputChange = function (event, key) {
            var _a;
            this.setState((_a = {},
                _a[key] = event.target.value,
                _a));
        };
        Login.prototype.login = function () {
            var _this = this;
            api_1.musicApi.login(this.origin, this.state['account'], this.state['password'])
                .then(function (account) {
                user_1.userConfiguration.setConfig(_this.origin, { account: account });
                user_1.userConfiguration.saveConfig();
                _this.setState({ account: '', password: '' });
                notice_1.loginSuccess(account.user);
            }).catch(function (err) {
                notice_1.loginFail(_this.origin, err.message || 'login error');
            });
        };
        /**
         * Remove all user's info
         */
        Login.prototype.loginOut = function () {
            user_1.userConfiguration.setConfig(this.origin, null);
            user_1.userConfiguration.saveConfig();
            api_1.musicApi.clean(this.origin);
            this.forceUpdate();
        };
        Login.prototype.showLogin = function () {
            var _this = this;
            var input = this.origin != origin_1.ORIGIN.qq ? (React.createElement("div", { className: 'inputBox' },
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("form", { onSubmit: function (event) { event.preventDefault(); _this.login(); }, style: { display: 'flex' } },
                        React.createElement("input", { className: 'inputBox-input small', type: 'text', placeholder: "Account", value: this.state.account, onChange: function (e) { return _this.handleInputChange(e, 'account'); } }),
                        React.createElement("input", { className: 'inputBox-input small', type: 'password', placeholder: 'Password', value: this.state.password, onChange: function (e) { return _this.handleInputChange(e, 'password'); } }),
                        React.createElement("button", { className: 'btn btn-green cursor-pointer' }, "Login"))))) : (React.createElement("button", { className: 'btn btn-green cursor-pointer', onClick: function (event) { event.preventDefault(); _this.login(); } }, "Login"));
            return (React.createElement("header", { className: "user-header" },
                React.createElement("div", { className: "row" },
                    React.createElement("div", { className: "user-info col-md-12" },
                        React.createElement("h1", { className: 'user-name' }, this.origin.toUpperCase()),
                        input))));
        };
        Login.prototype.showLogined = function (config) {
            var _this = this;
            var userProfile = config.account.user;
            var userName = userProfile.userName;
            var cover = userProfile.userAvatarPath || api_1.musicApi.resizeImageUrl(userProfile.origin, userProfile.userAvatarUrl.split('@')[0], size_1.ESize.Big);
            var originIcon = originIcons_1.OriginIcon(userProfile.origin, 'user-icon xiami-icon');
            var sync = config.syncAddRemove;
            return (React.createElement("header", { className: "user-header" },
                React.createElement("div", { className: "row" },
                    React.createElement("div", { className: "user-info col-md-12" },
                        React.createElement("div", { className: "media-object mo-artist", style: { maxWidth: '220px', margin: '10px auto' } },
                            React.createElement("div", { className: "media-object-hoverable" },
                                React.createElement("div", { className: "react-contextmenu-wrapper", onContextMenu: function (e) { return _this.props.showUserProfileMenu(e, userProfile); } },
                                    React.createElement("div", { className: "cover-art shadow actionable rounded linking cursor-pointer cover-art--with-auto-height", "aria-hidden": "true", style: { width: 'auto', height: 'auto' } },
                                        React.createElement("div", { onClick: function () { return _this.props.handleShowUserProfileView(userProfile); } },
                                            common_1.UserProfileIcon,
                                            React.createElement("div", { className: "cover-art-image cover-art-image-loaded", style: { backgroundImage: "url(\"" + cover + "\")" } })),
                                        React.createElement("button", { className: "cover-art-playback cursor-pointer", onClick: function () { return _this.props.handlePlayUserFavoriteSongs(userProfile); } },
                                            React.createElement("svg", { className: "icon-play", viewBox: "0 0 85 100" },
                                                React.createElement("path", { fill: "currentColor", d: "M81 44.6c5 3 5 7.8 0 10.8L9 98.7c-5 3-9 .7-9-5V6.3c0-5.7 4-8 9-5l72 43.3z" },
                                                    React.createElement("title", null, "PLAY")))))))),
                        originIcon,
                        React.createElement("h1", { className: "user-name" }, userName),
                        React.createElement("button", { className: 'btn btn-green cursor-pointer', onClick: function (event) { event.preventDefault(); _this.loginOut(); } }, "Login Out"),
                        React.createElement("label", { className: "checkbox-container cursor-pointer" },
                            "Sync To Origin",
                            React.createElement("input", { type: "checkbox", checked: sync, onClick: function (e) { return _this.handleCheckbox(e); } }),
                            React.createElement("span", { className: "checkbox-checkmark" }))))));
        };
        Login.prototype.render = function () {
            var config = user_1.userConfiguration.getConfig();
            var info = config[this.origin];
            if (info) {
                return this.showLogined(info);
            }
            else {
                return this.showLogin();
            }
        };
        return Login;
    }(React.Component));
    var _XiamiLogin = /** @class */ (function (_super) {
        __extends(_XiamiLogin, _super);
        function _XiamiLogin(props) {
            var _this = _super.call(this, props) || this;
            _this.origin = origin_1.ORIGIN.xiami;
            return _this;
        }
        return _XiamiLogin;
    }(Login));
    var _NeteaseLogin = /** @class */ (function (_super) {
        __extends(_NeteaseLogin, _super);
        function _NeteaseLogin(props) {
            var _this = _super.call(this, props) || this;
            _this.origin = origin_1.ORIGIN.netease;
            return _this;
        }
        return _NeteaseLogin;
    }(Login));
    var _QQLogin = /** @class */ (function (_super) {
        __extends(_QQLogin, _super);
        function _QQLogin(props) {
            var _this = _super.call(this, props) || this;
            _this.origin = origin_1.ORIGIN.qq;
            return _this;
        }
        return _QQLogin;
    }(Login));
    function mapDispatchToProps(dispatch) {
        return {
            handleShowUserProfileView: function (userProfile) { return showUserProfile_1.handleShowUserProfileView(userProfile).then(function (act) { return dispatch(act); }); },
            handlePlayUserFavoriteSongs: function (userProfile) { return playUser_1.handlePlayUserFavoriteSongs(userProfile).then(function (act) { return dispatch(act); }); },
        };
    }
    var cnt = react_redux_1.connect(null, mapDispatchToProps);
    exports.XiamiLogin = cnt(_XiamiLogin);
    exports.NeteaseLogin = cnt(_NeteaseLogin);
    exports.QQLogin = cnt(_QQLogin);
});
