var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "react", "react-redux", "chord/workbench/parts/common/component/songItem", "chord/workbench/parts/common/component/artistItem", "chord/workbench/parts/common/component/albumItem", "chord/workbench/parts/common/component/collectionItem", "chord/workbench/parts/common/component/episodeItem", "chord/workbench/parts/common/component/podcastItem", "chord/workbench/parts/common/component/radioItem", "chord/workbench/parts/common/component/navMenu", "chord/workbench/parts/mainView/browser/action/searchResult"], function (require, exports, React, react_redux_1, songItem_1, artistItem_1, albumItem_1, collectionItem_1, episodeItem_1, podcastItem_1, radioItem_1, navMenu_1, searchResult_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var SearchResult = /** @class */ (function (_super) {
        __extends(SearchResult, _super);
        function SearchResult(props) {
            var _this = _super.call(this, props) || this;
            if (!SearchResult.view) {
                SearchResult.view = _this.props.view;
            }
            _this.state = { view: SearchResult.view };
            _this.changeSearchResultView = _this.changeSearchResultView.bind(_this);
            _this._getSongsView = _this._getSongsView.bind(_this);
            _this._getAlbumsView = _this._getAlbumsView.bind(_this);
            _this._getArtistsView = _this._getArtistsView.bind(_this);
            _this._getCollectionsView = _this._getCollectionsView.bind(_this);
            _this._getSearchNavMenu = _this._getSearchNavMenu.bind(_this);
            _this.topResult = _this.topResult.bind(_this);
            _this.songsResult = _this.songsResult.bind(_this);
            _this.artistsResult = _this.artistsResult.bind(_this);
            _this.albumsResult = _this.albumsResult.bind(_this);
            _this.collectionsResult = _this.collectionsResult.bind(_this);
            return _this;
        }
        SearchResult.prototype.changeSearchResultView = function (view) {
            SearchResult.view = view;
            this.setState({ view: view });
        };
        SearchResult.prototype._getSongsView = function (size) {
            var songsView = this.props.songs.slice(0, size ? size : Infinity).map(function (song, index) { return (React.createElement(songItem_1.default, { key: 'song_search_' + index.toString().padStart(3, '0'), song: song, active: false, short: false, thumb: false, handlePlay: null })); });
            return songsView;
        };
        SearchResult.prototype._getAlbumsView = function (size) {
            var albumsView = this.props.albums.slice(0, size ? size : Infinity).map(function (album, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'album_search_' + index.toString().padStart(3, '0') },
                React.createElement(albumItem_1.default, { album: album }))); });
            return albumsView;
        };
        SearchResult.prototype._getArtistsView = function (size) {
            var artistsView = this.props.artists.slice(0, size ? size : Infinity).map(function (artist, index) { return (React.createElement("div", { key: 'artist_search_' + index.toString().padStart(3, '0'), className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2' },
                React.createElement(artistItem_1.default, { artist: artist }))); });
            return artistsView;
        };
        SearchResult.prototype._getCollectionsView = function (size) {
            var collectionsView = this.props.collections.slice(0, size ? size : Infinity).map(function (collection, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'collection_search_' + index.toString().padStart(3, '0') },
                React.createElement(collectionItem_1.default, { collection: collection }))); });
            return collectionsView;
        };
        SearchResult.prototype._getEpisodesView = function (size) {
            var episodesView = this.props.episodes.slice(0, size ? size : Infinity).map(function (episode, index) { return (React.createElement(episodeItem_1.default, { key: 'episode_search_' + index.toString().padStart(3, '0'), episode: episode, active: false, short: false, thumb: false, handlePlay: null })); });
            return episodesView;
        };
        SearchResult.prototype._getPodcastsView = function (size) {
            var podcastsView = this.props.podcasts.slice(0, size ? size : Infinity).map(function (podcast, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'podcast_search_' + index.toString().padStart(3, '0') },
                React.createElement(podcastItem_1.default, { podcast: podcast }))); });
            return podcastsView;
        };
        SearchResult.prototype._getRadiosView = function (size) {
            var radiosView = this.props.radios.slice(0, size ? size : Infinity).map(function (radio, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'radio_search_' + index.toString().padStart(3, '0') },
                React.createElement(radioItem_1.default, { radio: radio }))); });
            return radiosView;
        };
        SearchResult.prototype._getSearchNavMenu = function () {
            var views = [
                { name: 'TOP RESULT', value: 'top' },
                { name: 'SONGS', value: 'songs' },
                { name: 'ARTISTS', value: 'artists' },
                { name: 'ALBUMS', value: 'albums' },
                { name: 'COLLECTIONS', value: 'collections' },
                { name: 'PODCASTS', value: 'podcasts' },
                { name: 'RADIOS', value: 'radios' },
                { name: 'EPISODES', value: 'episodes' },
            ];
            return React.createElement(navMenu_1.NavMenu, { namespace: 'search-navmenu', thisView: SearchResult.view, views: views, handleClick: this.changeSearchResultView });
        };
        SearchResult.prototype.topResult = function () {
            // TODO: Get size from config
            var defaultSize = 30;
            var songsView = this._getSongsView(defaultSize);
            var albumsView = this._getAlbumsView(defaultSize);
            var artistsView = this._getArtistsView(defaultSize);
            var collectionsView = this._getCollectionsView(defaultSize);
            var episodesView = this._getEpisodesView(defaultSize);
            var podcastsView = this._getPodcastsView(defaultSize);
            var radiosView = this._getRadiosView(defaultSize);
            var searchNavMenu = this._getSearchNavMenu();
            return (React.createElement("div", null,
                searchNavMenu,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Songs"),
                            React.createElement("section", { className: 'tracklist-container' },
                                React.createElement("ol", { className: 'tracklist' }, songsView))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Artists"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, artistsView)))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Albums"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, albumsView)))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Playlists"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, collectionsView)))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Podcasts"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, podcastsView)))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Radios"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, radiosView)))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Episodes"),
                            React.createElement("section", { className: 'tracklist-container' },
                                React.createElement("ol", { className: 'tracklist' }, episodesView)))))));
        };
        SearchResult.prototype.songsResult = function () {
            var _this = this;
            var songsView = this._getSongsView();
            var searchNavMenu = this._getSearchNavMenu();
            var keyword = this.props.keyword;
            var offset = this.props.songsOffset;
            return (React.createElement("div", null,
                searchNavMenu,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Songs"),
                            React.createElement("section", { className: 'tracklist-container' },
                                React.createElement("ol", { className: 'tracklist' }, songsView))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("div", { className: "view-more" },
                                React.createElement("div", { className: "view-more-button" },
                                    React.createElement("div", { className: "btn btn-fg-green", onClick: function () { return _this.props.searchMoreSongs(keyword, offset); } }, "View More"))))))));
        };
        SearchResult.prototype.artistsResult = function () {
            var _this = this;
            var artistsView = this._getArtistsView();
            var searchNavMenu = this._getSearchNavMenu();
            var keyword = this.props.keyword;
            var offset = this.props.artistsOffset;
            return (React.createElement("div", null,
                searchNavMenu,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Artists"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, artistsView)))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("div", { className: "view-more" },
                                React.createElement("div", { className: "view-more-button" },
                                    React.createElement("div", { className: "btn btn-fg-green", onClick: function () { return _this.props.searchMoreArtists(keyword, offset); } }, "View More"))))))));
        };
        SearchResult.prototype.albumsResult = function () {
            var _this = this;
            var albumsView = this._getAlbumsView();
            var searchNavMenu = this._getSearchNavMenu();
            var keyword = this.props.keyword;
            var offset = this.props.albumsOffset;
            return (React.createElement("div", null,
                searchNavMenu,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Albums"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, albumsView)))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("div", { className: "view-more" },
                                React.createElement("div", { className: "view-more-button" },
                                    React.createElement("div", { className: "btn btn-fg-green", onClick: function () { return _this.props.searchMoreAlbums(keyword, offset); } }, "View More"))))))));
        };
        SearchResult.prototype.collectionsResult = function () {
            var _this = this;
            var collectionsView = this._getCollectionsView();
            var searchNavMenu = this._getSearchNavMenu();
            var keyword = this.props.keyword;
            var offset = this.props.collectionsOffset;
            return (React.createElement("div", null,
                searchNavMenu,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Playlists"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, collectionsView)))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("div", { className: "view-more" },
                                React.createElement("div", { className: "view-more-button" },
                                    React.createElement("div", { className: "btn btn-fg-green", onClick: function () { return _this.props.searchMoreCollections(keyword, offset); } }, "View More"))))))));
        };
        SearchResult.prototype.episodesResult = function () {
            var _this = this;
            var episodesView = this._getEpisodesView();
            var searchNavMenu = this._getSearchNavMenu();
            var keyword = this.props.keyword;
            var offset = this.props.episodesOffset;
            return (React.createElement("div", null,
                searchNavMenu,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Episodes"),
                            React.createElement("section", { className: 'tracklist-container' },
                                React.createElement("ol", { className: 'tracklist' }, episodesView))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("div", { className: "view-more" },
                                React.createElement("div", { className: "view-more-button" },
                                    React.createElement("div", { className: "btn btn-fg-green", onClick: function () { return _this.props.searchMoreEpisodes(keyword, offset); } }, "View More"))))))));
        };
        SearchResult.prototype.podcastsResult = function () {
            var _this = this;
            var podcastsView = this._getPodcastsView();
            var searchNavMenu = this._getSearchNavMenu();
            var keyword = this.props.keyword;
            var offset = this.props.podcastsOffset;
            return (React.createElement("div", null,
                searchNavMenu,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Podcasts"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, podcastsView)))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("div", { className: "view-more" },
                                React.createElement("div", { className: "view-more-button" },
                                    React.createElement("div", { className: "btn btn-fg-green", onClick: function () { return _this.props.searchMorePodcasts(keyword, offset); } }, "View More"))))))));
        };
        SearchResult.prototype.radiosResult = function () {
            var _this = this;
            var radiosView = this._getRadiosView();
            var searchNavMenu = this._getSearchNavMenu();
            var keyword = this.props.keyword;
            var offset = this.props.radiosOffset;
            return (React.createElement("div", null,
                searchNavMenu,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'row' },
                            React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, "Radios"),
                            React.createElement("section", null,
                                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                                    React.createElement("div", { className: 'align-row-wrap row' }, radiosView)))),
                        React.createElement("div", { className: 'row' },
                            React.createElement("div", { className: "view-more" },
                                React.createElement("div", { className: "view-more-button" },
                                    React.createElement("div", { className: "btn btn-fg-green", onClick: function () { return _this.props.searchMoreRadios(keyword, offset); } }, "View More"))))))));
        };
        SearchResult.prototype.render = function () {
            var view = SearchResult.view;
            switch (view) {
                case 'songs':
                    return this.songsResult();
                case 'artists':
                    return this.artistsResult();
                case 'albums':
                    return this.albumsResult();
                case 'collections':
                    return this.collectionsResult();
                case 'podcasts':
                    return this.podcastsResult();
                case 'radios':
                    return this.radiosResult();
                case 'episodes':
                    return this.episodesResult();
                default: // view == 'top'
                    return this.topResult();
            }
        };
        return SearchResult;
    }(React.Component));
    function mapStateToProps(state) {
        return __assign(__assign({}, state.mainView.searchView.result), { keyword: state.mainView.searchView.keyword });
    }
    function mapDispatchToProps(dispatch) {
        return {
            searchMoreSongs: function (keyword, offset) { return searchResult_1.searchMoreSongs(keyword, offset).then(function (act) { return dispatch(act); }); },
            searchMoreAlbums: function (keyword, offset) { return searchResult_1.searchMoreAlbums(keyword, offset).then(function (act) { return dispatch(act); }); },
            searchMoreArtists: function (keyword, offset) { return searchResult_1.searchMoreArtists(keyword, offset).then(function (act) { return dispatch(act); }); },
            searchMoreCollections: function (keyword, offset) { return searchResult_1.searchMoreCollections(keyword, offset).then(function (act) { return dispatch(act); }); },
            searchMoreEpisodes: function (keyword, offset) { return searchResult_1.searchMoreEpisodes(keyword, offset).then(function (act) { return dispatch(act); }); },
            searchMorePodcasts: function (keyword, offset) { return searchResult_1.searchMorePodcasts(keyword, offset).then(function (act) { return dispatch(act); }); },
            searchMoreRadios: function (keyword, offset) { return searchResult_1.searchMoreRadios(keyword, offset).then(function (act) { return dispatch(act); }); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(SearchResult);
});
