var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/api/utils/statistic", "chord/music/common/size", "chord/workbench/parts/common/component/songItem", "chord/workbench/parts/common/component/albumItem", "chord/workbench/parts/common/component/artistItem", "chord/workbench/parts/common/component/collectionItem", "chord/workbench/parts/common/component/userProfileItem", "chord/workbench/parts/common/component/viewMoreItem", "chord/workbench/parts/mainView/browser/action/userProfile", "chord/workbench/parts/player/browser/action/playUser", "chord/workbench/parts/common/component/buttons", "chord/workbench/parts/menu/browser/action/menu", "chord/music/core/api", "chord/css!../../media/userProfile"], function (require, exports, React, react_redux_1, statistic_1, size_1, songItem_1, albumItem_1, artistItem_1, collectionItem_1, userProfileItem_1, viewMoreItem_1, userProfile_1, playUser_1, buttons_1, menu_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function UserProfileNavMenu(_a) {
        var view = _a.view, changeUserNavMenuView = _a.changeUserNavMenuView;
        return (React.createElement("nav", { className: 'search-nav-container' },
            React.createElement("ul", { className: 'search-nav-ul' },
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'overview' ? 'search-nav-item__active' : ''), onClick: function () { return changeUserNavMenuView('overview'); } }, "OVERVIEW")),
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'songs' ? 'search-nav-item__active' : ''), onClick: function () { return changeUserNavMenuView('songs'); } }, "SONGS")),
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'artists' ? 'search-nav-item__active' : ''), onClick: function () { return changeUserNavMenuView('artists'); } }, "ARTISTS")),
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'albums' ? 'search-nav-item__active' : ''), onClick: function () { return changeUserNavMenuView('albums'); } }, "ALBUMS")),
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'favoriteCollections' ? 'search-nav-item__active' : ''), onClick: function () { return changeUserNavMenuView('favoriteCollections'); } }, "FAVORITE PLAYLISTS")),
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'createdCollections' ? 'search-nav-item__active' : ''), onClick: function () { return changeUserNavMenuView('createdCollections'); } }, "CREATED PLAYLISTS")),
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'followings' ? 'search-nav-item__active' : ''), onClick: function () { return changeUserNavMenuView('followings'); } }, "FOLLOWINGS")))));
    }
    var UserProfileView = /** @class */ (function (_super) {
        __extends(UserProfileView, _super);
        function UserProfileView(props) {
            var _this = _super.call(this, props) || this;
            if (!UserProfileView.view) {
                UserProfileView.view = _this.props.view;
            }
            _this.state = { view: UserProfileView.view };
            _this.changeUserNavMenuView = _this.changeUserNavMenuView.bind(_this);
            _this._getUserProfileHeader = _this._getUserProfileHeader.bind(_this);
            _this._getSongsView = _this._getSongsView.bind(_this);
            _this._getArtistsView = _this._getArtistsView.bind(_this);
            _this._getAlbumsView = _this._getAlbumsView.bind(_this);
            _this._getFavoriteCollectionsView = _this._getFavoriteCollectionsView.bind(_this);
            _this._getCreatedCollectionsView = _this._getCreatedCollectionsView.bind(_this);
            _this._getFollowingsView = _this._getFollowingsView.bind(_this);
            _this._itemsView = _this._itemsView.bind(_this);
            _this.overviewView = _this.overviewView.bind(_this);
            _this.songsView = _this.songsView.bind(_this);
            _this.artistsView = _this.artistsView.bind(_this);
            _this.albumsView = _this.albumsView.bind(_this);
            _this.favoriteCollectionsView = _this.favoriteCollectionsView.bind(_this);
            _this.createdCollectionsView = _this.createdCollectionsView.bind(_this);
            _this.followingsView = _this.followingsView.bind(_this);
            return _this;
        }
        UserProfileView.prototype.componentDidMount = function () {
            // Scroll to document top
            window.scroll(0, 0);
        };
        UserProfileView.prototype.changeUserNavMenuView = function (view) {
            UserProfileView.view = view;
            this.setState({ view: view });
        };
        UserProfileView.prototype._getSongsView = function (size) {
            var userProfile = this.props.userProfile;
            var songsView = userProfile.songs.slice(0, size ? size : Infinity).map(function (song, index) { return (React.createElement(songItem_1.default, { key: 'user_song_' + index.toString().padStart(4, '0'), song: song, active: false, short: false, thumb: true, handlePlay: null })); });
            return songsView;
        };
        UserProfileView.prototype._getArtistsView = function (size) {
            var userProfile = this.props.userProfile;
            var artistsView = userProfile.artists.slice(0, size ? size : Infinity).map(function (artist, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'user_artist_' + index.toString().padStart(4, '0') },
                React.createElement(artistItem_1.default, { artist: artist }))); });
            return artistsView;
        };
        UserProfileView.prototype._getAlbumsView = function (size) {
            var userProfile = this.props.userProfile;
            var albumsView = userProfile.albums.slice(0, size ? size : Infinity).map(function (album, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'user_album_' + index.toString().padStart(4, '0') },
                React.createElement(albumItem_1.default, { album: album }))); });
            return albumsView;
        };
        UserProfileView.prototype._getFavoriteCollectionsView = function (size) {
            var userProfile = this.props.userProfile;
            var favoriteCollectionsView = userProfile.favoriteCollections.slice(0, size ? size : Infinity).map(function (collection, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'user_collection_' + index.toString().padStart(4, '0') },
                React.createElement(collectionItem_1.default, { collection: collection }))); });
            return favoriteCollectionsView;
        };
        UserProfileView.prototype._getCreatedCollectionsView = function (size) {
            var userProfile = this.props.userProfile;
            var createdCollectionsView = userProfile.createdCollections.slice(0, size ? size : Infinity).map(function (collection, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'user_collection_' + index.toString().padStart(4, '0') },
                React.createElement(collectionItem_1.default, { collection: collection }))); });
            return createdCollectionsView;
        };
        UserProfileView.prototype._getFollowingsView = function (size) {
            var userProfile = this.props.userProfile;
            var followings = userProfile.followings.slice(0, size ? size : Infinity).map(function (userProfile, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: 'user_collection_' + index.toString().padStart(4, '0') },
                React.createElement(userProfileItem_1.default, { userProfile: userProfile }))); });
            return followings;
        };
        UserProfileView.prototype._getUserProfileHeader = function () {
            var _this = this;
            // Maybe need to set background image
            var userProfile = this.props.userProfile;
            var cover = userProfile.userAvatarPath || api_1.musicApi.resizeImageUrl(userProfile.origin, userProfile.userAvatarUrl.split('@')[0], size_1.ESize.Big);
            var userProfileCount = statistic_1.getUserProfileCount(this.props.userProfile);
            return (React.createElement("header", { className: 'user-header user-info' },
                React.createElement("figure", { className: "avatar user-avatar", style: { backgroundImage: "url(\"" + cover + "\")", width: '200px', height: '200px', margin: '10px auto' } }),
                React.createElement("h1", { className: 'user-name' }, userProfile.userName),
                React.createElement("h1", { className: 'small', style: { opacity: 0.4 } }, userProfileCount),
                React.createElement("div", { className: 'header-buttons' },
                    React.createElement("button", { className: 'btn btn-green cursor-pointer', onClick: function () { return _this.props.handlePlayUserFavoriteSongs(userProfile); } }, "PLAY FAVORITE SONGS"),
                    React.createElement(buttons_1.MenuButton, { click: function (e) { return _this.props.showUserProfileMenu(e, userProfile); } })),
                React.createElement(UserProfileNavMenu, { view: UserProfileView.view, changeUserNavMenuView: this.changeUserNavMenuView })));
        };
        UserProfileView.prototype.overviewView = function () {
            var defaultSize = 10;
            var songsView = this._getSongsView(defaultSize);
            var artistsView = this._getArtistsView(defaultSize);
            var albumsView = this._getAlbumsView(defaultSize);
            var favoriteCollectionsView = this._getFavoriteCollectionsView(defaultSize);
            var createdCollectionsView = this._getCreatedCollectionsView(defaultSize);
            // let followingsView = this._getFollowingsView(defaultSize);
            var userProfile = this.props.userProfile;
            var makeItemsView = function (view, title) { return (React.createElement("section", { className: 'artist-albums' },
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center' } }, title),
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'align-row-wrap grid--limit row' }, view))))); };
            return (React.createElement("div", null,
                React.createElement("div", { className: 'col-xs-12 col-lg-9 col-xl-8 description', dangerouslySetInnerHTML: { __html: userProfile.description } }),
                React.createElement("section", { className: 'container-fluid' },
                    React.createElement("div", { className: 'row' },
                        React.createElement("div", { className: 'contentSpacing' },
                            React.createElement("div", { className: 'col-xs-12 col-lg-9 col-xl-8 description', dangerouslySetInnerHTML: { __html: userProfile.description } }),
                            React.createElement("section", { className: 'col-sm-12 col-md-10 col-md-push-1 artist-toptracks' },
                                React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center' } }, "Songs"),
                                React.createElement("section", { className: 'tracklist-container full-width' },
                                    React.createElement("ol", null, songsView)))))),
                makeItemsView(artistsView, 'Artists'),
                makeItemsView(albumsView, 'Albums'),
                makeItemsView(favoriteCollectionsView, 'Favorite Collections'),
                makeItemsView(createdCollectionsView, 'Created Collections')));
        };
        UserProfileView.prototype.songsView = function () {
            var _this = this;
            var userProfile = this.props.userProfile;
            var songsView = this._getSongsView();
            var offset = this.props.songsOffset;
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return _this.props.getMoreFavoriteSongs(userProfile, offset, size); } })) : null;
            return (React.createElement("section", { className: 'container-fluid' },
                React.createElement("div", { className: 'row' },
                    React.createElement("div", { className: 'contentSpacing' },
                        React.createElement("section", { className: 'col-sm-12 col-md-10 col-md-push-1 artist-toptracks' },
                            React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center', display: 'none' } }, "Songs"),
                            React.createElement("section", { className: 'tracklist-container full-width' },
                                React.createElement("ol", null, songsView))))),
                viewMore));
        };
        UserProfileView.prototype._itemsView = function (view, handler, offset, title) {
            var userProfile = this.props.userProfile;
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return handler(userProfile, offset, size); } })) : null;
            return (React.createElement("section", { className: 'artist-albums' },
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center', display: 'none' } }, title),
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'align-row-wrap grid--limit row' }, view)),
                    viewMore)));
        };
        UserProfileView.prototype.artistsView = function () {
            return this._itemsView(this._getArtistsView(), this.props.getMoreFavoriteArtists, this.props.artistsOffset, 'ARTISTS');
        };
        UserProfileView.prototype.albumsView = function () {
            return this._itemsView(this._getAlbumsView(), this.props.getMoreFavoriteAlbums, this.props.albumsOffset, 'ALBUMS');
        };
        UserProfileView.prototype.favoriteCollectionsView = function () {
            return this._itemsView(this._getFavoriteCollectionsView(), this.props.getMoreFavoriteCollections, this.props.favoriteCollectionsOffset, 'FAVORITE PLAYLISTS');
        };
        UserProfileView.prototype.createdCollectionsView = function () {
            return this._itemsView(this._getCreatedCollectionsView(), this.props.getMoreCreatedCollections, this.props.createdCollectionsOffset, 'CREATED PLAYLISTS');
        };
        UserProfileView.prototype.followingsView = function () {
            return this._itemsView(this._getFollowingsView(), this.props.getMoreFollowings, this.props.followingsOffset, 'Followings');
        };
        UserProfileView.prototype.render = function () {
            var userHeaderView = this._getUserProfileHeader();
            var view = UserProfileView.view;
            var contentView = null;
            if (view == 'overview') {
                contentView = this.overviewView();
            }
            else if (view == 'songs') {
                contentView = this.songsView();
            }
            else if (view == 'artists') {
                contentView = this.artistsView();
            }
            else if (view == 'albums') {
                contentView = this.albumsView();
            }
            else if (view == 'favoriteCollections') {
                contentView = this.favoriteCollectionsView();
            }
            else if (view == 'createdCollections') {
                contentView = this.createdCollectionsView();
            }
            else if (view == 'followings') {
                contentView = this.followingsView();
            }
            else {
                return null;
            }
            return (React.createElement("div", { className: 'hw-accelerate' },
                React.createElement("section", { className: 'content artist' },
                    userHeaderView,
                    contentView)));
        };
        return UserProfileView;
    }(React.Component));
    function mapStateToProps(state) {
        return state.mainView.userProfileView;
    }
    function mapDispatchToProps(dispatch) {
        return {
            getMoreFavoriteSongs: function (userProfile, offset, size) { return userProfile_1.getMoreFavoriteSongs(userProfile, offset, size).then(function (act) { return dispatch(act); }); },
            getMoreFavoriteArtists: function (userProfile, offset, size) { return userProfile_1.getMoreFavoriteArtists(userProfile, offset, size).then(function (act) { return dispatch(act); }); },
            getMoreFavoriteAlbums: function (userProfile, offset, size) { return userProfile_1.getMoreFavoriteAlbums(userProfile, offset, size).then(function (act) { return dispatch(act); }); },
            getMoreFavoriteCollections: function (userProfile, offset, size) { return userProfile_1.getMoreFavoriteCollections(userProfile, offset, size).then(function (act) { return dispatch(act); }); },
            getMoreCreatedCollections: function (userProfile, offset, size) { return userProfile_1.getMoreCreatedCollections(userProfile, offset, size).then(function (act) { return dispatch(act); }); },
            getMoreFollowings: function (userProfile, offset, size) { return userProfile_1.getMoreFollowings(userProfile, offset, size).then(function (act) { return dispatch(act); }); },
            handlePlayUserFavoriteSongs: function (userProfile) { return playUser_1.handlePlayUserFavoriteSongs(userProfile).then(function (act) { return dispatch(act); }); },
            showUserProfileMenu: function (e, userProfile) { return dispatch(menu_1.showUserProfileMenu(e, userProfile)); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(UserProfileView);
});
