define(["require", "exports", "chord/platform/log/common/log", "chord/platform/utils/common/paths", "react", "react-redux", "chord/workbench/parts/mainView/browser/component/search/search", "chord/workbench/parts/mainView/browser/component/album/album", "chord/workbench/parts/mainView/browser/component/artist/artist", "chord/workbench/parts/mainView/browser/component/collection/collection", "chord/workbench/parts/mainView/browser/component/home/home", "chord/workbench/parts/mainView/browser/component/library/library", "chord/workbench/parts/mainView/browser/component/preference/preference", "chord/workbench/parts/mainView/browser/component/user/userProfile", "chord/workbench/parts/mainView/browser/component/podcast/podcast", "chord/workbench/parts/mainView/browser/component/radio/radio", "chord/css!./media/mainView"], function (require, exports, log_1, paths_1, React, react_redux_1, search_1, album_1, artist_1, collection_1, home_1, library_1, preference_1, userProfile_1, podcast_1, radio_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var logger = new log_1.Logger(paths_1.filenameToNodeName(__filename));
    function MainView(_a) {
        var view = _a.view;
        logger.info('MainView view:', view);
        var View;
        switch (view) {
            case 'searchView':
                View = React.createElement(search_1.default, null);
                break;
            case 'albumView':
                View = React.createElement(album_1.default, null);
                break;
            case 'artistView':
                View = React.createElement(artist_1.default, null);
                break;
            case 'collectionView':
                View = React.createElement(collection_1.default, null);
                break;
            case 'userProfileView':
                View = React.createElement(userProfile_1.default, null);
                break;
            case 'podcastView':
                View = React.createElement(podcast_1.default, null);
                break;
            case 'radioView':
                View = React.createElement(radio_1.default, null);
                break;
            case 'homeView':
                View = React.createElement(home_1.default, null);
                break;
            case 'libraryView':
                View = React.createElement(library_1.default, null);
                break;
            case 'preferenceView':
                View = React.createElement(preference_1.default, null);
                break;
            default:
                logger.error('[MainView]: No get view', view);
                return null;
        }
        return (React.createElement("div", { className: 'main-view-container' }, View));
    }
    function mapStateToProps(state) {
        return {
            view: state.mainView.view,
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps)(MainView);
});
