var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
define(["require", "exports", "chord/platform/log/common/log", "chord/platform/utils/common/paths", "chord/base/common/assert"], function (require, exports, log_1, paths_1, assert_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.removeFromLibrary = exports.addLibraryRadio = exports.addLibraryPodcast = exports.addLibraryEpisode = exports.addLibraryUserProfile = exports.addLibraryCollection = exports.addLibraryAlbum = exports.addLibraryArtist = exports.addLibrarySong = void 0;
    var logger = new log_1.Logger(paths_1.filenameToNodeName(__filename));
    function addLibrarySong(state, act) {
        assert_1.equal(act.act, 'c:mainView:addLibrarySong');
        var songs = __spreadArray([act.song], __read(state.songs));
        return __assign(__assign({}, state), { songs: songs });
    }
    exports.addLibrarySong = addLibrarySong;
    function addLibraryArtist(state, act) {
        assert_1.equal(act.act, 'c:mainView:addLibraryArtist');
        var artists = __spreadArray([act.artist], __read(state.artists));
        return __assign(__assign({}, state), { artists: artists });
    }
    exports.addLibraryArtist = addLibraryArtist;
    function addLibraryAlbum(state, act) {
        assert_1.equal(act.act, 'c:mainView:addLibraryAlbum');
        var albums = __spreadArray([act.album], __read(state.albums));
        return __assign(__assign({}, state), { albums: albums });
    }
    exports.addLibraryAlbum = addLibraryAlbum;
    function addLibraryCollection(state, act) {
        assert_1.equal(act.act, 'c:mainView:addLibraryCollection');
        var collections = __spreadArray([act.collection], __read(state.collections));
        return __assign(__assign({}, state), { collections: collections });
    }
    exports.addLibraryCollection = addLibraryCollection;
    function addLibraryUserProfile(state, act) {
        assert_1.equal(act.act, 'c:mainView:addLibraryUserProfile');
        var userProfiles = __spreadArray([act.userProfile], __read(state.userProfiles));
        return __assign(__assign({}, state), { userProfiles: userProfiles });
    }
    exports.addLibraryUserProfile = addLibraryUserProfile;
    // Sound
    function addLibraryEpisode(state, act) {
        assert_1.equal(act.act, 'c:mainView:addLibraryEpisode');
        var episodes = __spreadArray([act.episode], __read(state.episodes));
        return __assign(__assign({}, state), { episodes: episodes });
    }
    exports.addLibraryEpisode = addLibraryEpisode;
    function addLibraryPodcast(state, act) {
        assert_1.equal(act.act, 'c:mainView:addLibraryPodcast');
        var podcasts = __spreadArray([act.podcast], __read(state.podcasts));
        return __assign(__assign({}, state), { podcasts: podcasts });
    }
    exports.addLibraryPodcast = addLibraryPodcast;
    function addLibraryRadio(state, act) {
        assert_1.equal(act.act, 'c:mainView:addLibraryRadio');
        var radios = __spreadArray([act.radio], __read(state.radios));
        return __assign(__assign({}, state), { radios: radios });
    }
    exports.addLibraryRadio = addLibraryRadio;
    function removeFromLibrary(state, act) {
        assert_1.equal(act.act, 'c:mainView:removeFromLibrary');
        var item = act.item;
        switch (item.type) {
            case 'song':
                var songs = state.songs.filter(function (song) { return song.song.songId != item.songId; });
                return __assign(__assign({}, state), { songs: songs });
            case 'artist':
                var artists = state.artists.filter(function (artist) { return artist.artist.artistId != item.artistId; });
                return __assign(__assign({}, state), { artists: artists });
            case 'album':
                var albums = state.albums.filter(function (album) { return album.album.albumId != item.albumId; });
                return __assign(__assign({}, state), { albums: albums });
            case 'collection':
                var collections = state.collections.filter(function (collection) { return collection.collection.collectionId != item.collectionId; });
                return __assign(__assign({}, state), { collections: collections });
            case 'userProfile':
                var userProfiles = state.userProfiles.filter(function (userProfile) { return userProfile.userProfile.userId != item.userId; });
                return __assign(__assign({}, state), { userProfiles: userProfiles });
            case 'episode':
                var episodes = state.episodes.filter(function (episode) { return episode.episode.episodeId != item.episodeId; });
                return __assign(__assign({}, state), { episodes: episodes });
            case 'podcast':
                var podcasts = state.podcasts.filter(function (podcast) { return podcast.podcast.podcastId != item.podcastId; });
                return __assign(__assign({}, state), { podcasts: podcasts });
            case 'radio':
                var radios = state.radios.filter(function (radio) { return radio.radio.radioId != item.radioId; });
                return __assign(__assign({}, state), { radios: radios });
            default:
                logger.error('`removeFromLibrary` reducer: unknown item\'s type:', item.type, item);
        }
        return __assign({}, state);
    }
    exports.removeFromLibrary = removeFromLibrary;
});
