var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
define(["require", "exports", "chord/base/common/assert", "chord/workbench/api/common/state/offset"], function (require, exports, assert_1, offset_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getMoreLibraryRadios = exports.getMoreLibraryPodcasts = exports.getMoreLibraryEpisodes = exports.getMoreLibraryUserProfiles = exports.getMoreLibraryCollections = exports.getMoreLibraryAlbums = exports.getMoreLibraryArtists = exports.getMoreLibrarySongs = exports.showLibraryResult = void 0;
    function showLibraryResult(state, act) {
        assert_1.equal(act.act, 'c:mainView:libraryInput');
        var keyword = act.keyword;
        var songsOffset = offset_1.initiateOffset();
        if (act.songs.length) {
            songsOffset.offset = act.songs[act.songs.length - 1].id;
        }
        var artistsOffset = offset_1.initiateOffset();
        if (act.artists.length) {
            artistsOffset.offset = act.artists[act.artists.length - 1].id;
        }
        var albumsOffset = offset_1.initiateOffset();
        if (act.albums.length) {
            albumsOffset.offset = act.albums[act.albums.length - 1].id;
        }
        var collectionsOffset = offset_1.initiateOffset();
        if (act.collections.length) {
            collectionsOffset.offset = act.collections[act.collections.length - 1].id;
        }
        var userProfilesOffset = offset_1.initiateOffset();
        if (act.userProfiles.length) {
            userProfilesOffset.offset = act.userProfiles[act.userProfiles.length - 1].id;
        }
        var episodesOffset = offset_1.initiateOffset();
        if (act.episodes.length) {
            episodesOffset.offset = act.episodes[act.episodes.length - 1].id;
        }
        var podcastsOffset = offset_1.initiateOffset();
        if (act.podcasts.length) {
            podcastsOffset.offset = act.podcasts[act.podcasts.length - 1].id;
        }
        var radiosOffset = offset_1.initiateOffset();
        if (act.radios.length) {
            radiosOffset.offset = act.radios[act.radios.length - 1].id;
        }
        var result = {
            view: 'top',
            songs: act.songs,
            artists: act.artists,
            albums: act.albums,
            collections: act.collections,
            userProfiles: act.userProfiles,
            episodes: act.episodes,
            podcasts: act.podcasts,
            radios: act.radios,
            songsOffset: songsOffset,
            artistsOffset: artistsOffset,
            albumsOffset: albumsOffset,
            collectionsOffset: collectionsOffset,
            userProfilesOffset: userProfilesOffset,
            episodesOffset: episodesOffset,
            podcastsOffset: podcastsOffset,
            radiosOffset: radiosOffset,
        };
        return { keyword: keyword, result: result };
    }
    exports.showLibraryResult = showLibraryResult;
    function getMoreLibraryItems(type, state, act) {
        var _a;
        var cType = type[0].toUpperCase() + type.slice(1) + 's';
        type = type + 's';
        assert_1.equal(act.act, 'c:mainView:getMoreLibrary' + cType);
        var itemsOffset = act[type + 'Offset'];
        var items = __spreadArray(__spreadArray([], __read(state[type])), __read(act[type]));
        return __assign(__assign({}, state), (_a = {}, _a[type] = items, _a[type + 'Offset'] = itemsOffset, _a));
    }
    function getMoreLibrarySongs(state, act) {
        return getMoreLibraryItems('song', state, act);
        // equal(act.act, 'c:mainView:getMoreLibrarySongs');
        // let songsOffset = act.songsOffset;
        // let songs = [...state.songs, ...act.songs];
        // return { ...state, songs, songsOffset };
    }
    exports.getMoreLibrarySongs = getMoreLibrarySongs;
    function getMoreLibraryArtists(state, act) {
        return getMoreLibraryItems('artist', state, act);
        // equal(act.act, 'c:mainView:getMoreLibraryArtists');
        // let artistsOffset = act.artistsOffset;
        // let artists = [...state.artists, ...act.artists];
        // return { ...state, artists, artistsOffset };
    }
    exports.getMoreLibraryArtists = getMoreLibraryArtists;
    function getMoreLibraryAlbums(state, act) {
        return getMoreLibraryItems('album', state, act);
        // equal(act.act, 'c:mainView:getMoreLibraryAlbums');
        // let albumsOffset = act.albumsOffset;
        // let albums = [...state.albums, ...act.albums];
        // return { ...state, albums, albumsOffset };
    }
    exports.getMoreLibraryAlbums = getMoreLibraryAlbums;
    function getMoreLibraryCollections(state, act) {
        return getMoreLibraryItems('collection', state, act);
        // equal(act.act, 'c:mainView:getMoreLibraryCollections');
        // let collectionsOffset = act.collectionsOffset;
        // let collections = [...state.collections, ...act.collections];
        // return { ...state, collections, collectionsOffset };
    }
    exports.getMoreLibraryCollections = getMoreLibraryCollections;
    function getMoreLibraryUserProfiles(state, act) {
        return getMoreLibraryItems('userProfile', state, act);
        // equal(act.act, 'c:mainView:getMoreLibraryUserProfiles');
        // let userProfilesOffset = act.userProfilesOffset;
        // let userProfiles = [...state.userProfiles, ...act.userProfiles];
        // return { ...state, userProfiles, userProfilesOffset };
    }
    exports.getMoreLibraryUserProfiles = getMoreLibraryUserProfiles;
    function getMoreLibraryEpisodes(state, act) {
        return getMoreLibraryItems('episode', state, act);
    }
    exports.getMoreLibraryEpisodes = getMoreLibraryEpisodes;
    function getMoreLibraryPodcasts(state, act) {
        return getMoreLibraryItems('podcast', state, act);
    }
    exports.getMoreLibraryPodcasts = getMoreLibraryPodcasts;
    function getMoreLibraryRadios(state, act) {
        return getMoreLibraryItems('radio', state, act);
    }
    exports.getMoreLibraryRadios = getMoreLibraryRadios;
});
