var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
define(["require", "exports", "chord/base/common/assert"], function (require, exports, assert_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.addSearchRadios = exports.addSearchPodcasts = exports.addSearchEpisodes = exports.addSearchCollections = exports.addSearchArtists = exports.addSearchAlbums = exports.addSearchSongs = exports.showSearchResult = void 0;
    function showSearchResult(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchInput');
        var result = __assign(__assign({}, state.result), { view: 'top', songs: act.songs, albums: act.albums, artists: act.artists, collections: act.collections, episodes: act.episodes, podcasts: act.podcasts, radios: act.radios });
        var keywords = act.keyword == state.history.keywords[0] ? __spreadArray([], __read(state.history.keywords)) : __spreadArray([act.keyword], __read(state.history.keywords.filter(function (keyword) { return keyword != act.keyword; }).slice(0, 999)));
        var history = { keywords: keywords };
        return __assign(__assign({}, state), { view: 'searchResult', keyword: act.keyword, history: history, result: result });
    }
    exports.showSearchResult = showSearchResult;
    function addSearchSongs(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMoreSongs');
        var songsOffset = act.songsOffset;
        var songs = __spreadArray(__spreadArray([], __read(state.songs)), __read(act.songs));
        return __assign(__assign({}, state), { songs: songs, songsOffset: songsOffset });
    }
    exports.addSearchSongs = addSearchSongs;
    function addSearchAlbums(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMoreAlbums');
        var albumsOffset = act.albumsOffset;
        var albums = __spreadArray(__spreadArray([], __read(state.albums)), __read(act.albums));
        return __assign(__assign({}, state), { albums: albums, albumsOffset: albumsOffset });
    }
    exports.addSearchAlbums = addSearchAlbums;
    function addSearchArtists(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMoreArtists');
        var artistsOffset = act.artistsOffset;
        var artists = __spreadArray(__spreadArray([], __read(state.artists)), __read(act.artists));
        return __assign(__assign({}, state), { artists: artists, artistsOffset: artistsOffset });
    }
    exports.addSearchArtists = addSearchArtists;
    function addSearchCollections(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMoreCollections');
        var collectionsOffset = act.collectionsOffset;
        var collections = __spreadArray(__spreadArray([], __read(state.collections)), __read(act.collections));
        return __assign(__assign({}, state), { collections: collections, collectionsOffset: collectionsOffset });
    }
    exports.addSearchCollections = addSearchCollections;
    function addSearchEpisodes(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMoreEpisodes');
        var episodesOffset = act.episodesOffset;
        var episodes = __spreadArray(__spreadArray([], __read(state.episodes)), __read(act.episodes));
        return __assign(__assign({}, state), { episodes: episodes, episodesOffset: episodesOffset });
    }
    exports.addSearchEpisodes = addSearchEpisodes;
    function addSearchPodcasts(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMorePodcasts');
        var podcastsOffset = act.podcastsOffset;
        var podcasts = __spreadArray(__spreadArray([], __read(state.podcasts)), __read(act.podcasts));
        return __assign(__assign({}, state), { podcasts: podcasts, podcastsOffset: podcastsOffset });
    }
    exports.addSearchPodcasts = addSearchPodcasts;
    function addSearchRadios(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMoreRadios');
        var radiosOffset = act.radiosOffset;
        var radios = __spreadArray(__spreadArray([], __read(state.radios)), __read(act.radios));
        return __assign(__assign({}, state), { radios: radios, radiosOffset: radiosOffset });
    }
    exports.addSearchRadios = addSearchRadios;
});
