var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/parts/player/browser/action/addToQueue", "chord/workbench/parts/mainView/browser/action/removeFromLibrary", "chord/library/core/library"], function (require, exports, React, react_redux_1, addToQueue_1, removeFromLibrary_1, library_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var Menu = /** @class */ (function (_super) {
        __extends(Menu, _super);
        function Menu(props) {
            var _this = _super.call(this, props) || this;
            _this.menu = React.createRef();
            return _this;
        }
        Menu.prototype.shouldComponentUpdate = function (nextProps) {
            if (this.menu.current) {
                this.menu.current.style.display = 'block';
            }
            return true;
        };
        Menu.prototype.render = function () {
            var _this = this;
            var item = this.props.item;
            if (!item) {
                return null;
            }
            var top = this.props.top;
            var left = this.props.left;
            var like = library_1.defaultLibrary.exists(item);
            item.like = like;
            var addLibraryItem = item && (!like ? (React.createElement("div", { className: "react-contextmenu-item cursor-pointer", role: "menuitem", tabIndex: -1, onClick: function () { return _this.props.handleAddLibraryItem(item); } },
                "Save to your Favorite ",
                this.props.name)) : null);
            var addToQueueTail = this.props.toQueue ?
                React.createElement("div", { className: "react-contextmenu-item cursor-pointer", role: "menuitem", tabIndex: -1, onClick: function () { return _this.props.handleAddToQueue(item, 'tail'); } }, "Add to Queue (After)") : null;
            var addToQueueHead = this.props.toQueue ?
                React.createElement("div", { className: "react-contextmenu-item cursor-pointer", role: "menuitem", tabIndex: -1, onClick: function () { return _this.props.handleAddToQueue(item, 'head'); } }, "Add to Queue (Before)") : null;
            var removeFromLibraryItem = item && (like ? (React.createElement("div", { className: "react-contextmenu-item cursor-pointer", role: "menuitem", tabIndex: -1, onClick: function () { return _this.props.handleRemoveFromLibrary(item); } }, "Remove from library")) : null);
            return (React.createElement("nav", { ref: this.menu, role: "menu", tabIndex: -1, className: "react-contextmenu", style: { position: 'fixed', opacity: 1, pointerEvents: 'auto', top: top + "px", left: left + "px" } },
                addLibraryItem,
                addToQueueTail,
                addToQueueHead,
                removeFromLibraryItem));
        };
        return Menu;
    }(React.Component));
    function mapDispatchToProps(dispatch) {
        return {
            handleAddToQueue: function (item, direction) { return addToQueue_1.handleAddToQueue(item, direction).then(function (act) { return dispatch(act); }); },
            handleRemoveFromLibrary: function (item) { return dispatch(removeFromLibrary_1.handleRemoveFromLibrary(item)); },
        };
    }
    exports.default = react_redux_1.connect(null, mapDispatchToProps)(Menu);
});
