var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "chord/base/common/property", "chord/workbench/parts/menu/browser/reducer/reduceMap"], function (require, exports, property_1, reduceMap_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.menuReducer = void 0;
    function handleView(act) {
        switch (act) {
            case 'c:menu:showSongMenu':
                return 'songMenuView';
            case 'c:menu:showArtistMenu':
                return 'artistMenuView';
            case 'c:menu:showAlbumMenu':
                return 'albumMenuView';
            case 'c:menu:showCollectionMenu':
                return 'collectionMenuView';
            case 'c:menu:showUserProfileMenu':
                return 'userProfileMenuView';
            // Sound
            case 'c:menu:showEpisodeMenu':
                return 'episodeMenuView';
            case 'c:menu:showPodcastMenu':
                return 'podcastMenuView';
            case 'c:menu:showRadioMenu':
                return 'radioMenuView';
            default:
                return null;
        }
    }
    function menuReducer(state, act) {
        var _a = reduceMap_1.map(act.act), reducer = _a.reducer, node = _a.node;
        var reducerState = property_1.getDescendentProp(state, node);
        var result = reducer(reducerState, act);
        var newState = __assign({}, state);
        newState = property_1.setDescendentProp(newState, node, result);
        var preView = newState.view;
        var view = handleView(act.act);
        newState.view = view || preView;
        return newState;
    }
    exports.menuReducer = menuReducer;
});
