var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/base/common/functions", "chord/platform/utils/common/keys", "chord/workbench/api/common/state/notification", "chord/workbench/parts/mainView/browser/action/showAlbum", "chord/workbench/parts/mainView/browser/action/showArtist", "chord/workbench/parts/mainView/browser/action/showCollection", "chord/workbench/parts/mainView/browser/action/showUserProfile", "chord/workbench/parts/mainView/browser/action/showPodcast", "chord/workbench/parts/mainView/browser/action/showRadio"], function (require, exports, React, react_redux_1, functions_1, keys_1, notification_1, showAlbum_1, showArtist_1, showCollection_1, showUserProfile_1, showPodcast_1, showRadio_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function getItemName(item) {
        return item.type == 'userProfile' ? item.userName : item[item.type + 'Name'];
    }
    function getItemType(item) {
        return item.type == 'userProfile' ? 'user' : item.type;
    }
    function NoticeView(_a) {
        var type = _a.type, name = _a.name, _b = _a.message, message = _b === void 0 ? null : _b, _c = _a.className, className = _c === void 0 ? null : _c, click = _a.click;
        var messageView = message ? React.createElement("div", { dir: 'auto', className: "ellipsis-one-line " + className, title: message }, message) : null;
        return (React.createElement("li", { className: 'navBar-item navBar-item--small' },
            React.createElement("div", { className: 'react-contextmenu-wrapper' },
                React.createElement("div", { className: 'navBar-link-text-with-icon-wrapper' },
                    React.createElement("div", { className: 'navbar-link__text' },
                        React.createElement("div", { dir: 'auto', className: 'ellipsis-one-line cursor-pointer', title: name, onClick: function () { return click(); } }, name),
                        messageView,
                        React.createElement("span", { className: 'navBar-item__type' }, type))))));
    }
    function PlayItemNoticeView(_a) {
        var item = _a.item, handleShowItem = _a.handleShowItem;
        var name = getItemName(item);
        var type = getItemType(item);
        return React.createElement(NoticeView, { type: type, name: name, message: null, className: null, click: handleShowItem });
    }
    function FilterSongView(_a) {
        var item = _a.item, message = _a.message, handleShowItem = _a.handleShowItem;
        var name = getItemName(item);
        var type = getItemType(item);
        var msg = message + " songs aren't available";
        return React.createElement(NoticeView, { type: type, name: name, message: msg, className: 'warning-warn', click: handleShowItem });
    }
    function NoAudioView(_a) {
        var item = _a.item;
        var name = getItemName(item);
        var type = 'song';
        var msg = "The song hasn't audio";
        return React.createElement(NoticeView, { type: type, name: name, message: msg, className: 'warning-warn', click: functions_1.voidFn });
    }
    function NoSongView(_a) {
        var item = _a.item, handleShowItem = _a.handleShowItem;
        var name = getItemName(item);
        var type = getItemType(item);
        var msg = 'No song is available';
        return React.createElement(NoticeView, { type: type, name: name, message: msg, className: 'warning-error', click: handleShowItem });
    }
    function LoginSuccess(_a) {
        var item = _a.item, handleShowItem = _a.handleShowItem;
        var name = getItemName(item);
        return React.createElement(NoticeView, { type: item.origin, name: name, message: 'Login Success', className: 'warning-ok', click: handleShowItem });
    }
    function LoginFail(_a) {
        var origin = _a.origin, message = _a.message;
        return React.createElement(NoticeView, { type: origin, name: 'Login Fail', message: message, className: 'warning-error', click: functions_1.voidFn });
    }
    function SwitchKbps(_a) {
        var item = _a.item, message = _a.message;
        return React.createElement(NoticeView, { type: 'SONG', name: item.songName, message: 'Switch to ' + message + 'kbps', className: 'warning-warn', click: functions_1.voidFn });
    }
    function BlockedKbps(_a) {
        var item = _a.item, message = _a.message;
        return React.createElement(NoticeView, { type: 'SONG', name: item.songName, message: message + 'kbps' + ' is blocked', className: 'warning-warn', click: functions_1.voidFn });
    }
    function ServerFail(_a) {
        var item = _a.item, handleShowItem = _a.handleShowItem;
        var name = getItemName(item);
        var type = getItemType(item);
        var msg = 'Remote Server Fail';
        return React.createElement(NoticeView, { type: type, name: name, message: msg, className: 'warning-error', click: handleShowItem });
    }
    function Info(_a) {
        var item = _a.item, message = _a.message;
        return React.createElement(NoticeView, { type: 'INFO', name: item, message: message, className: 'warning-warn', click: functions_1.voidFn });
    }
    var Notification = /** @class */ (function (_super) {
        __extends(Notification, _super);
        function Notification(props) {
            var _this = _super.call(this, props) || this;
            _this.state = { toggle: true };
            _this._toggle = _this._toggle.bind(_this);
            _this._handleShowItem = _this._handleShowItem.bind(_this);
            _this._makeNoticeViews = _this._makeNoticeViews.bind(_this);
            return _this;
        }
        Notification.prototype._toggle = function () {
            this.setState(function (preState) { return ({ toggle: !preState.toggle }); });
        };
        Notification.prototype._handleShowItem = function (item) {
            var _this = this;
            switch (item.type) {
                case 'album':
                    return function () { return _this.props.handleShowAlbumView(item); };
                case 'artist':
                    return function () { return _this.props.handleShowArtistView(item); };
                case 'collection':
                    return function () { return _this.props.handleShowCollectionView(item); };
                case 'userProfile':
                    return function () { return _this.props.handleShowUserProfileView(item); };
                case 'podcast':
                    return function () { return _this.props.handleShowPodcastView(item); };
                case 'radio':
                    return function () { return _this.props.handleShowRadioView(item); };
                case 'song':
                case 'episode':
                default:
                    return functions_1.voidFn;
            }
        };
        Notification.prototype._makeNoticeViews = function () {
            var _this = this;
            return this.props.entries.map(function (notice, index) {
                var key = keys_1.makeListKey(index, 'notice', 'item');
                switch (notice.type) {
                    case notification_1.NOTICES.PLAY_SONG:
                    case notification_1.NOTICES.PLAY_ALBUM:
                    case notification_1.NOTICES.PLAY_ARTIST:
                    case notification_1.NOTICES.PLAY_COLLECTION:
                    case notification_1.NOTICES.PLAY_USERPROFILE:
                    case notification_1.NOTICES.PLAY_LIST:
                    case notification_1.NOTICES.PLAY_EPISODE:
                    case notification_1.NOTICES.PLAY_PODCAST:
                    case notification_1.NOTICES.PLAY_RADIO:
                        return React.createElement(PlayItemNoticeView, { item: notice.item, handleShowItem: _this._handleShowItem(notice.item), key: key });
                    case notification_1.NOTICES.FILTER_SONGS:
                        return React.createElement(FilterSongView, { item: notice.item, message: notice.message, handleShowItem: _this._handleShowItem(notice.item), key: key });
                    case notification_1.NOTICES.NO_AUDIO:
                        return React.createElement(NoAudioView, { item: notice.item, key: key });
                    case notification_1.NOTICES.NO_SONG:
                        return React.createElement(NoSongView, { item: notice.item, handleShowItem: _this._handleShowItem(notice.item), key: key });
                    case notification_1.NOTICES.LOGIN_SUCCESS:
                        return React.createElement(LoginSuccess, { item: notice.item, handleShowItem: _this._handleShowItem(notice.item), key: key });
                    case notification_1.NOTICES.LOGIN_FAIL:
                        return React.createElement(LoginFail, { origin: notice.item, message: notice.message, key: key });
                    case notification_1.NOTICES.SWITCH_KBPS:
                        return React.createElement(SwitchKbps, { item: notice.item, message: notice.message, key: key });
                    case notification_1.NOTICES.BLOCKED_KBPS:
                        return React.createElement(BlockedKbps, { item: notice.item, message: notice.message, key: key });
                    case notification_1.NOTICES.SERVER_FAIL:
                        return React.createElement(ServerFail, { item: notice.item, handleShowItem: _this._handleShowItem(notice.item), key: key });
                    case notification_1.NOTICES.INFO:
                        return React.createElement(Info, { item: notice.item, message: notice.message, key: key });
                    default:
                        throw new Error("[_makeNoticeViews]: unknown notice type: " + notice.type);
                }
            });
        };
        Notification.prototype.render = function () {
            var _this = this;
            var entries = this._makeNoticeViews();
            return (React.createElement("div", null,
                React.createElement("h2", { className: 'navBar-group-header cursor-pointer', onClick: function () { return _this._toggle(); } }, "NOTIFICATION"),
                React.createElement("ul", { className: 'notification-container', style: { display: this.state.toggle ? 'block' : 'none' } }, entries)));
        };
        return Notification;
    }(React.Component));
    function mapStateToProps(state) {
        return state.notification;
    }
    function mapDispatchToProps(dispatch) {
        return {
            handleShowAlbumView: function (album) { return showAlbum_1.handleShowAlbumView(album).then(function (act) { return dispatch(act); }); },
            handleShowArtistView: function (artist) { return showArtist_1.handleShowArtistView(artist).then(function (act) { return dispatch(act); }); },
            handleShowCollectionView: function (collection) { return showCollection_1.handleShowCollectionView(collection).then(function (act) { return dispatch(act); }); },
            handleShowUserProfileView: function (userProfile) { return showUserProfile_1.handleShowUserProfileView(userProfile).then(function (act) { return dispatch(act); }); },
            handleShowPodcastView: function (podcast) { return showPodcast_1.handleShowPodcastView(podcast).then(function (act) { return dispatch(act); }); },
            handleShowRadioView: function (radio) { return showRadio_1.handleShowRadioView(radio).then(function (act) { return dispatch(act); }); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(Notification);
});
