var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "react", "react-redux", "chord/workbench/api/utils/playItem", "chord/base/common/time", "chord/music/common/size", "chord/workbench/parts/player/browser/action/playList", "chord/workbench/parts/common/component/episodeItem", "chord/workbench/parts/common/component/songItem", "chord/workbench/parts/player/browser/component/lyric", "chord/workbench/parts/common/component/buttons", "chord/workbench/parts/common/component/originIcons", "chord/workbench/parts/mainView/browser/action/showArtist", "chord/workbench/parts/mainView/browser/action/showAlbum", "chord/workbench/parts/mainView/browser/action/addLibraryItem", "chord/workbench/parts/mainView/browser/action/removeFromLibrary", "chord/workbench/parts/mainView/browser/action/showPodcast", "chord/workbench/parts/mainView/browser/action/showRadio", "chord/library/core/library"], function (require, exports, React, react_redux_1, playItem_1, time_1, size_1, playList_1, episodeItem_1, songItem_1, lyric_1, buttons_1, originIcons_1, showArtist_1, showAlbum_1, addLibraryItem_1, removeFromLibrary_1, showPodcast_1, showRadio_1, library_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PlayListItemDetail = exports.PlayListContent = exports.PlayListButtom = void 0;
    var PlayListItemDetail = /** @class */ (function (_super) {
        __extends(PlayListItemDetail, _super);
        function PlayListItemDetail(props) {
            var _this = _super.call(this, props) || this;
            _this.handleLibraryActFunc = _this.handleLibraryActFunc.bind(_this);
            _this.scrollToCurrentPlaying = _this.scrollToCurrentPlaying.bind(_this);
            return _this;
        }
        PlayListItemDetail.prototype.handleLibraryActFunc = function (playItem) {
            var handleLibraryActFunc = playItem.like ? this.props.handleRemoveFromLibrary
                : (playItem.type == 'song') ? this.props.handleAddLibrarySong : this.props.handleAddLibraryEpisode;
            playItem.like = !playItem.like;
            handleLibraryActFunc(playItem);
            this.forceUpdate();
        };
        PlayListItemDetail.prototype.scrollToCurrentPlaying = function () {
            var elem = document.getElementById('playing-this');
            if (elem)
                elem.scrollIntoView({ behavior: 'smooth', block: 'start', inline: 'nearest' });
        };
        PlayListItemDetail.prototype.render = function () {
            var _this = this;
            var playItem = this.props.playItem;
            if (!playItem) {
                return null;
            }
            var like = library_1.defaultLibrary.exists(playItem);
            playItem.like = like;
            var item = new playItem_1.PlayItem(playItem), cover = item.cover(size_1.ESize.Large), icon = item.icon(), itemName = item.name(), boxId = item.boxId(), boxName = item.boxName(), ownerId = item.ownerId(), ownerName = item.ownerName();
            var originIcon = originIcons_1.OriginIcon(playItem.origin, 'top-icon xiami-icon');
            var likeIconClass = like ? 'spoticon-heart-active-20' : 'spoticon-heart-20';
            var handleShowOwnerViewById;
            var handleShowBoxViewById;
            switch (playItem.type) {
                case 'song':
                    handleShowOwnerViewById = this.props.handleShowArtistViewById;
                    handleShowBoxViewById = this.props.handleShowAlbumViewById;
                    break;
                case 'episode':
                    handleShowOwnerViewById = this.props.handleShowRadioViewById;
                    handleShowBoxViewById = this.props.handleShowPodcastViewById;
                    break;
                default:
                    throw new Error("[PlayListItemDetail]: unknown playItem type: " + playItem);
            }
            return (React.createElement("div", { className: 'playlist-content-song-detail' },
                React.createElement("div", null,
                    React.createElement("div", { className: "cover-art shadow cover-art--with-auto-height", "aria-hidden": "true", style: { width: '200px', height: '200px', padding: 0 }, onClick: this.scrollToCurrentPlaying },
                        React.createElement("div", null,
                            icon,
                            React.createElement("div", { className: "cover-art-image cover-art-image-loaded", style: { backgroundImage: "url(\"" + cover + "\")" } }))),
                    React.createElement("div", { style: { display: 'flex', justifyContent: 'center', margin: '3px 0px' } },
                        React.createElement(buttons_1.SmallButton, { title: this.props.lyricOn ? 'list' : 'lyric', click: this.props.toggleLyric }))),
                React.createElement("div", { style: { display: 'inline-grid', width: 'inherit' } },
                    React.createElement("div", { className: "mo-meta ellipsis-one-line" },
                        React.createElement("div", { className: "react-contextmenu-wrapper" },
                            React.createElement("span", null, originIcon))),
                    React.createElement("div", { className: "mo-info" },
                        React.createElement("div", { className: "react-contextmenu-wrapper" },
                            React.createElement("span", { className: "mo-info-name link-subtle" }, itemName))),
                    React.createElement("div", { className: "mo-meta ellipsis-one-line" },
                        React.createElement("div", { className: "react-contextmenu-wrapper", onClick: function () { return handleShowBoxViewById(boxId); } },
                            React.createElement("span", { className: "link-subtle a-like cursor-pointer" }, boxName))),
                    React.createElement("div", { className: "mo-meta ellipsis-one-line" },
                        React.createElement("div", { className: "react-contextmenu-wrapper", onClick: function () { return handleShowOwnerViewById(ownerId); } },
                            React.createElement("span", { className: "link-subtle a-like cursor-pointer" }, ownerName))),
                    React.createElement("div", { className: "mo-meta ellipsis-one-line" },
                        React.createElement("div", { className: "react-contextmenu-wrapper" },
                            React.createElement("span", null, playItem.releaseDate ? time_1.getDateYear(playItem.releaseDate) : null))),
                    React.createElement("div", { className: "mo-info" },
                        React.createElement("div", { className: "react-contextmenu-wrapper" },
                            React.createElement("button", { className: "link-subtle control-button " + likeIconClass + " cursor-pointer", onClick: function () { return _this.handleLibraryActFunc(playItem); } }))))));
        };
        return PlayListItemDetail;
    }(React.Component));
    function mapDispatchToPropsForItemDetail(dispatch) {
        return {
            handleShowArtistViewById: function (artistId) { return showArtist_1.handleShowArtistViewById(artistId).then(function (act) { return dispatch(act); }); },
            handleShowAlbumViewById: function (albumId) { return showAlbum_1.handleShowAlbumViewById(albumId).then(function (act) { return dispatch(act); }); },
            handleAddLibrarySong: function (song) { return dispatch(addLibraryItem_1.handleAddLibrarySong(song)); },
            handleAddLibraryEpisode: function (episode) { return dispatch(addLibraryItem_1.handleAddLibraryEpisode(episode)); },
            handleRemoveFromLibrary: function (item) { return dispatch(removeFromLibrary_1.handleRemoveFromLibrary(item)); },
            handleShowPodcastViewById: function (podcastId) { return showPodcast_1.handleShowPodcastViewById(podcastId).then(function (act) { return dispatch(act); }); },
            handleShowRadioViewById: function (radioId) { return showRadio_1.handleShowRadioViewById(radioId).then(function (act) { return dispatch(act); }); },
        };
    }
    var _PlayListItemDetail = react_redux_1.connect(null, mapDispatchToPropsForItemDetail)(PlayListItemDetail);
    exports.PlayListItemDetail = _PlayListItemDetail;
    var PlayListContent = /** @class */ (function (_super) {
        __extends(PlayListContent, _super);
        function PlayListContent(props) {
            var _this = _super.call(this, props) || this;
            _this.state = { toggleLyric: false };
            _this.toggleLyric = _this.toggleLyric.bind(_this);
            _this.playListContent = _this.playListContent.bind(_this);
            _this.lyric = _this.lyric.bind(_this);
            return _this;
        }
        PlayListContent.prototype.toggleLyric = function () {
            this.setState(function (preState) { return ({
                toggleLyric: !preState.toggleLyric,
            }); });
        };
        PlayListContent.prototype.playListContent = function () {
            var _this = this;
            var playList = this.props.playList;
            var index = this.props.index;
            var kbps = this.props.kbps;
            var playItems = playList.map(function (playItem, i) {
                switch (playItem.type) {
                    case 'song':
                        return React.createElement(songItem_1.default, { key: i.toString(), song: playItem, active: index == i, short: false, thumb: true, handlePlay: function () { return _this.props.handlePlay(i); } });
                    case 'episode':
                        return React.createElement(episodeItem_1.default, { key: i.toString(), episode: playItem, active: index == i, short: false, thumb: true, handlePlay: function () { return _this.props.handlePlay(i); } });
                    default:
                        return null;
                }
            });
            var playItem = playList[index];
            var playListInfo = "\u29BF " + (index + 1) + " / " + playList.length + " \u2AF8 " + kbps + "kbps";
            return (React.createElement("div", null,
                React.createElement("div", { className: 'playlist-content-songs' },
                    React.createElement("div", { className: 'playlist-content-songs-container' }, playItems),
                    React.createElement("div", { style: { textAlign: 'center' } }, playListInfo)),
                React.createElement(_PlayListItemDetail, { playItem: playItem, lyricOn: this.state.toggleLyric, toggleLyric: this.toggleLyric })));
        };
        PlayListContent.prototype.lyric = function () {
            var playList = this.props.playList;
            var index = this.props.index;
            var playItem = playList[index];
            // episode has not lyric
            return (React.createElement("div", null,
                React.createElement(lyric_1.default, { song: playItem.type == 'song' ? playItem : null }),
                React.createElement(_PlayListItemDetail, { playItem: playItem, lyricOn: this.state.toggleLyric, toggleLyric: this.toggleLyric })));
        };
        PlayListContent.prototype.render = function () {
            if (this.state.toggleLyric) {
                return this.lyric();
            }
            return this.playListContent();
        };
        return PlayListContent;
    }(React.Component));
    var PlayListButtom = /** @class */ (function (_super) {
        __extends(PlayListButtom, _super);
        function PlayListButtom(props) {
            var _this = _super.call(this, props) || this;
            _this.showPlayList = _this.showPlayList.bind(_this);
            _this.playListContent = _this.props.playListContent;
            _this.show = false;
            return _this;
        }
        PlayListButtom.prototype.showPlayList = function () {
            this.show = !this.show;
            this.playListContent.current.style.display = this.show ? 'flex' : 'none';
        };
        PlayListButtom.prototype.render = function () {
            return (React.createElement("div", { className: 'player-list-container' },
                React.createElement("button", { className: 'spoticon-queue-16 control-button cursor-pointer', onClick: this.showPlayList, "aria-label": 'Queue' })));
        };
        return PlayListButtom;
    }(React.Component));
    exports.PlayListButtom = PlayListButtom;
    function mapStateToProps(state) {
        return __assign({}, state.player);
    }
    function mapDispatchToProps(dispatch) {
        return {
            handlePlay: function (index) { return playList_1.handlePlay(index).then(function (act) { return dispatch(act); }); },
        };
    }
    var _PlayListContent = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(PlayListContent);
    exports.PlayListContent = _PlayListContent;
});
