var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "chord/base/common/time", "chord/workbench/api/node/audio", "chord/workbench/parts/player/browser/action/control", "chord/workbench/parts/player/browser/action/plugins/playLog"], function (require, exports, React, time_1, audio_1, control_1, playLog_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.onEnd = exports.onPause = exports.onPlay = void 0;
    var ppoint;
    var _box;
    var _bar;
    var _slider;
    var _processTime;
    var _duration;
    var intervalDuration = 1000;
    function step() {
        var duration = audio_1.CAudio.playing() ? audio_1.CAudio.duration() : 0;
        var seek = audio_1.CAudio.playing() ? audio_1.CAudio.seek() || 0 : 0;
        var percent = duration ? seek / duration * 100 : 0;
        _bar.style.width = percent + "%";
        _slider.style.left = percent + "%";
        _processTime.innerText = time_1.getHumanDuration(seek * 1000);
        _duration.innerText = time_1.getHumanDuration(duration * 1000);
    }
    function onPlay(soundId, store) {
        ppoint = setInterval(step, intervalDuration);
    }
    exports.onPlay = onPlay;
    function onPause(soundId, store) {
        clearInterval(ppoint);
        ppoint = null;
    }
    exports.onPause = onPause;
    function onEnd(soundId, store) {
        clearInterval(ppoint);
        ppoint = null;
        step();
        playLog_1.handlePlayLog();
        // play next song
        control_1.handleForward().then(function (act) { return store.dispatch(act); });
    }
    exports.onEnd = onEnd;
    // configure control functions for CAudio
    audio_1.CAudio.registerOnPlay('control-onplay', onPlay);
    audio_1.CAudio.registerOnPause('control-onpause', onPause);
    audio_1.CAudio.registerOnEnd('control-onend', onEnd);
    function handleSeek(e) {
        if (audio_1.CAudio.hasAudio()) {
            var percent = e.nativeEvent.offsetX / _box.offsetWidth;
            var duration = audio_1.CAudio.duration();
            var seek = duration * percent;
            audio_1.CAudio.seek(seek);
        }
    }
    var ProcessBar = /** @class */ (function (_super) {
        __extends(ProcessBar, _super);
        function ProcessBar(props) {
            var _this = _super.call(this, props) || this;
            _this.box = React.createRef();
            _this.bar = React.createRef();
            _this.slider = React.createRef();
            _this.processTime = React.createRef();
            _this.duration = React.createRef();
            return _this;
        }
        ProcessBar.prototype.componentDidMount = function () {
            _box = this.box.current;
            _bar = this.bar.current;
            _slider = this.slider.current;
            _processTime = this.processTime.current;
            _duration = this.duration.current;
        };
        ProcessBar.prototype.render = function () {
            // ProcessBar renders only once. Later, updating handled by shouldComponentUpdate
            return (React.createElement("div", { className: 'playback-bar' },
                React.createElement("div", { ref: this.processTime, className: 'playback-bar__progress-time' }),
                React.createElement("div", { ref: this.box, className: 'progress-bar cursor-pointer', onClick: function (e) { return handleSeek(e); } },
                    React.createElement("div", { className: "middle-align progress-bar__bg" },
                        React.createElement("div", { ref: this.bar, className: "progress-bar__fg" }),
                        React.createElement("div", { ref: this.slider, className: "progress-bar__slider" }))),
                React.createElement("div", { className: 'playback-bar__progress-time', ref: this.duration })));
        };
        return ProcessBar;
    }(React.Component));
    exports.default = ProcessBar;
});
