var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "chord/platform/log/common/log", "chord/platform/utils/common/paths", "chord/base/common/property", "chord/workbench/parts/reduceMap", "chord/workbench/api/common/state/stateGlobal"], function (require, exports, log_1, paths_1, property_1, reduceMap_1, stateGlobal_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.mainReducer = void 0;
    var logger = new log_1.Logger(paths_1.filenameToNodeName(__filename));
    function mainReducer(state, act) {
        logger.info('[main reducer]: act:', act);
        // Redux initiation
        if (act.type.startsWith('@@redux')) {
            return stateGlobal_1.initiateStateGlobal();
        }
        var _a = reduceMap_1.map(act.act), reducer = _a.reducer, node = _a.node;
        var reducerState = property_1.getDescendentProp(state, node);
        logger.info('[main reducer]: node:', node);
        var result = reducer(reducerState, act);
        logger.info('[main reducer]: reducer result:', result);
        var newState = __assign({}, state);
        newState = property_1.setDescendentProp(newState, node, result);
        logger.info('[main reducer]: new state:', newState);
        return newState;
    }
    exports.mainReducer = mainReducer;
});
